2002-12-27  David Gravereaux <davygrvy@pobox.com>

	* generic/tkText.h: ANSI unfriendly typedef for TkTextBTree
	repaired for C++ compilers.

2002-12-27  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c (WaitForEvent): process Map and Unmap events
	as well as Configure events during WaitFor{Configure|Map}Notify.
	Fixes [Bug 578569] (WaitForMapNotify could process Map and Unmap
	events out of order, making Tk think a window was unmapped when
	it really wasn't).

2002-12-18  Todd M. Helfter  <tmh@purdue.edu>

	* doc/label.n: Fixed documentation of the -compound option to
	the label widget.  The option was simply missing from the
	man page [Bug 577540]

2002-12-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/photo.n: Fixed documentation of the put subcommand to no
	longer talk about files and to mention that you can use colour
	names for working with solid colours.  [Bug 640026]

2002-12-13  Don Porter <dgp@users.sf.net>

	* generic/tkMain.c (Tk_Main):  Call on Tcl*StartupScript*() routines
	to store the startup script, if any.  [Bug 616245].

2002-12-10  David Gravereaux  <davygrvy@pobox.com>

	* win/makefile.vc: tclThreadTest.obj not required to link
	tktest.exe [Bug 651396]

2002-12-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkEntry.c (ConfigureEntry): keep a flag to indicate when
	a var is traced to prevent double-traces caused by configuring the
	widget in traces with validation on. (dejong)

2002-12-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkInt.decls: add TkWinSetHINSTANCE decl
	* generic/tkIntPlatDecls.h: regen
	* generic/tkStubInit.c: regen
	* win/tkWinInit.c (TkpInit):  While init and cleanup aren't correct
	* win/tkWinX.c (TkWinXInit):  in DllMain, we had to specify the
	* win/tkWin32Dll.c (DllMain): true HINSTANCE or the resources of a
	dynamic Tk weren't being loaded correctly.  Created a new function
	TkWinSetHINSTANCE for this purpose.

2002-12-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinX.c (TkWinXInit):      Move cleanup into an exit handler
	* win/tkWin32Dll.c (DllMain):     to ensure that it will be called
	* win/tkWinWm.c (TkWinWmCleanup): without having to unload the dll.
	Also reset the static int initialized on cleanup to allow reinit.

2002-12-01  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/event.test (_keypress, _text_ind_to_x_y): Force focus to
	widget in _keypress method to avoid problems with window managers
	that use focus follows mouse. [Bug 526209]

2002-12-01  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add wm-transient-6.3 to check that a transient
	remains withdrawn when it is first withdrawn and then turned into
	a transient.
	* unix/tkUnixWm.c:
	* win/tkWinWm.c: Replace WM_TRANSIENT_WITHDRAWN with WM_WITHDRAWN
	and set this flag whenever a window is explicitly withdrawn. This
	fixes the test case added above. [Bug 644356]

2002-11-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/textDisp.test:
	* generic/tkTextDisp.c (TkTextSeeCmd): handle see for unmapped
	text displays. [Bug #641778]

2002-11-19  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (TkpDisplayScrollbar): If the
	scrollbar width is set to 12 or less (but 12 is what you
	should use) use the small metric scrollbar.

	(UpdateControlValues): Fix thinko in setting off AUTO_ADJUST for
	the place geometry manager.

2002-11-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in: add macosx/*.tcl (buildTkConfig.tcl in
	particular) to the dist target.

2002-11-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkWindow.c (Tk_DestroyWindow, DeleteWindowsExitProc):
	Add TkHalfdeadWindow type and halfdeadWindowList to keep track of
	windows that were only partially deallocated before a call to
	exit. Finish cleaning up these windows in DeleteWindowsExitProc.
	Keep track of cleanup status in Tk_DestroyWindow so that a window
	with a Destroy binding which calls exit will get fully destroyed.
	* tests/window.test: Add Tk_DestroyWindow tests for an assortment
	of half dead window cases. [Bug 630533]

2002-11-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: fixed erroneous
	removal of libtkstub before Wish was built.

2002-11-07  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/unixWm.test: Add short delay to test unixWm-51.7
	to account for raise/lower changes in TIP 107. This allows
	the test case to pass under Window Maker on Linux.

2002-11-07  Peter Spjuth  <peter.spjuth@space.se>

	* tests/place.test:
	* generic/tkPlace.c: place info did not return all settings,
	and didn't make sure the result was a proper list.
	Put '-in' first in result to be more consistent with how
	grid/pack info behaves. [Bug #635025][Bug #532022]

2002-11-07  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: added macosx/README to dist target.
	* macosx/Wish.pbproj/project.pbxproj: fix to 'wish' script
	to allow it to work when not installed into '/'.

2002-11-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/configure.in: Check that AR, RANLIB, and RC
	are found on the path when building with gcc.

2002-11-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added Wish linker flag
	-headerpad_max_install_names to allow use of 'install_name_tool'.
	fixed tkConfig.sh generation and redo_prebinding in the case where
	Tk is not installed alongside Tcl.

2002-11-03  David Gravereaux <davygrvy@pobox.com>

	* win/winMain.c (Tcl_AppInit): Calls Registry_Init() and
	Dde_Init() when STATIC_BUILD and TCL_USE_STATIC_PACKAGES macros
	are set.

	* win/makefile.vc:  linkexten option now sets the
	TCL_USE_STATIC_PACKAGES	macro which also adds the registry and
	dde static lib files to the link of the shell. [Patch 479697]

	* win/rules.vc: Matches the one from Tcl.

	* win/buildall.vc.bat: More useful commentary.

2002-11-01  Andreas Kupries  <andreask@activestate.com>

	* win/makefile.vc (TCLREGLIBNAME): Updated to registry 1.1.

2002-10-29  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: added info on new package searching in
	Frameworks directories.

2002-10-22  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.1 TAGGED FOR RELEASE ***

	* changes: updated for 8.4.1 release

2002-10-21  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: revised according to Jim's suggestions
	* macosx/tkMacOSXAppInit.c: use standard PATH_MAX from <limits.h>

2002-10-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/winMain.c (WinMain, main): remove obsolete SetMessageQueue call

	* win/configure: Regen.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Check for bug in Cygwin version
	of windres and work around that case by passing a POSIX path
	instead of a Windows native path. One can't always pass a POSIX
	path because the mingw native toolchain accepts only Windows
	native paths. (dejong)

	* win/tkWinPort.h: define OPEN_MAX only if not defined.
	[Patch #625472] (howell)

2002-10-18  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacAppInit.c: removed tcltest dependency.
	[Bug #592639] (porter)

2002-10-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/imgPhoto.test:
	* generic/tkImgPhoto.c (ImgPhotoConfigureMaster): fix arg handling
	for missing -format or -data options. [Bug #624974]

	* tests/text.test:		      properly return the number of
	* unix/tkUnixFont.c (ControlUtfProc): bytes consumed. [Bug #624732]

2002-10-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: info specific to building and running
	TclTk on Mac OS X, answers to tcl-mac list FAQs.
	* macosx/Makefile: permission fix after embedded install.
	* macosx/Wish.pbproj/project.pbxproj: after install, fix
	permissions of uninstalled products.

2002-10-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added TEXT document
	type to plist so that files can be dragged onto Wish Shell.

	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXFont.c: added private proc
	TkMacOSXUseAntialiasedText() to enable/disable quickdraw
	text antialiasing where available, default is enabled.
	Added a linked boolean ::tk::mac::antialiasedtext with
	write trace to allow control of antialiasing from tcl.

2002-10-16  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c: fix to accelerators shown in menus
	with non-alphanumeric keys.
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c: applied first patch from [Patch
	#622582] to fix some of [Bug #616988].  Further work is needed
	in this area, but this will let foreign keyboards at least work
	reasonably with Tk.

2002-10-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: add AIX-5 ppc build support. Remove unused
	SC_ENABLE_MEMDEBUG.

	* win/configure:
	* win/tcl.m4: Add --enable-shared=mem support.

2002-10-10  Peter Spjuth  <peter.spjuth@space.se>

	* tests/grid.test:
	* generic/tkGrid.c: The grid size was not updated properly
	when removing a widget from a grid. [Bug #621241] (forssen)

2002-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/canvPs.test: tests for canvas embedded window ps generation
	* generic/tkCanvWind.c (CanvasPsWindow): removed dead code loop.
	* generic/tkCanvas.h: moved TkColormapData struct to tkCanvPs.c
	* generic/tkCanvPs.c (TkImageGetColor): corrected bogus use of
	TkColormapData on Windows (Windows now requires RGB pixel data
	from image).
	* win/tkWinImage.c (XGetImage, XGetImageZPixmap): added support
	for generating ps for embedded widgets on canvases on Windows,
	tested for 8, 16, 24 and 32-bit depths (XGetImageZPixmap not used).

	* library/tk.tcl: simplified the adding of extra <ISO_Left_Tab>
	and <hpBackTab> events to <<PrevWindow>>.

2002-10-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/README: doc'ed --enable-symbols options.
	* unix/Makefile.in: comment docs
	* unix/configure: regen
	* unix/tcl.m4: replaced SC_ENABLE_MEMDEBUG with a more intelligent
	SC_ENABLE_SYMBOLS that takes yes|no|mem|all as options now.

2002-10-09  Don Porter <dgp@users.sf.net>

	* generic/tk.h:  Added reminder comment to edit
	macosx/Wish.pbproj/project.pbxproj when version number changes.

2002-10-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: don't remove tclsh after building embedded.

	* macosx/Wish.pbproj/project.pbxproj: bumped version to 8.4.1;
	added missing library/mkpsenc.tcl to framework.

2002-10-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkInt.decls(tkIntXlib): added XQueryTree declaration for
	mac & aqua, since it's now called from ParentXId via Tk_HandleEvent.
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c: regen.
	* mac/tkMacXStubs.c: added XQueryTree stub

	* mac/tkMacEmbed.c (TkpUseWindow): check that container window
	has -container option set (sync with other platforms).

	* mac/tkMacBitmap.c:
	* mac/tkMacFont.c:
	* mac/tkMacSend.c:
	* mac/tkMacTest.c:
	* mac/tkMacWm.c: CONSTification.

	* mac/tkMacProjects.sea.hqx: added tkStyle.c and tkUndo.c to
	tk library projects.

2002-10-09  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgPhoto.c (ImgPhotoSetSize): Only error-out if we
	fail to allocate a non-empty buffer; getting a NULL when we
	allocate an empty buffer is no problem since nothing will look at
	the value anyway. [Bug 619544]
	Also tidied up file to take into account the fact that we're using
	32 bits per pixel in the master to accommodate the alpha channel
	as well as RGB.

2002-10-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/winButton.test: add option clear to top to prevent option
	leakage from other tests causing problems. [Bug #582382]

	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd): leave the
	DestroyPanedWindow proc to free the pwPtr, add a Preserve
	reference to the pwPtr->tkwin.
	(DestroyPanedWindow): Release the pwPtr->tkwin.

	* generic/tkFocus.c (TkFocusFilterEvent): Ignore event if we are
	focusing into a dead window. [Bug #588831] (griffin)

2002-10-02  Jim Ingham  <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (TkpDisplayScrollbar): Put the Tk scrollbar
	pointer into the control reference data for the Mac scrollbar, so we
	can get it out again in the ScrollbarActionProc.

2002-10-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (TextBlinkProc): don't blink the cursor unless
	it is visible. [Bug #616791] [Patch #614474] (bonfield)

	* tests/entry.test: added entry-20.7
	* generic/tkEntry.c (EntryTextVarProc): check if the entry is
	being deleted before handling an associated textvariable.
	[Bug #607390 #617446]

2002-10-01  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/unixSelect.test (unixSelect-1.1[89]): Altered these tests
	to work around [Bug #616923]
	* unix/tkUnixSelect.c (SelRcvIncrProc,TkSelPropProc): It turns out
	a much simpler and more robust solution is possible if we leverage
	Tcl's encoding engine by using the same code path as for the
	normal string selection.  It might be a bit slower, but it should
	be a lot more correct.  [Bug #614650]

2002-09-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/panedwindow.test: added panedwindow-28.[12]
	* generic/tkPanedWindow.c (PanedWindowCmdDeletedProc):
	(Tk_PanedWindowObjCmd): when destroying the panedwindow, destroy
	the proxy before the parent to avoid dependency conflicts.
	[Bug #616589]

2002-09-30  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/unixSelect.test: Test for various things that can fail to
	work in 8.4.0...
	* unix/tkUnixSelect.c (TkSelPropProc,SelRcvIncrProc): Incremental
	transfers of UTF8_STRING selections should now work; Tk will now
	tag them with the right size and only transfer complete UTF8
	characters.  Previously, things only worked when the transfer
	could only happen in one go, and even then not always. [Bug 614650]

	* doc/bind.n: Doc-fix to mention that %A substitutes UNICODE
	characters rather than ASCII ones.  Tk's done this ever since 8.1
	in any case; after all, it is the right thing to do.

2002-09-27  Don Porter <dgp@users.sf.net>

	* README:		Bumped to version 8.4.1 to avoid confusion
	* generic/tk.h:		of CVS snapshots with release 8.4.0.
	* unix/README:
	* unix/configure.in:
	* unix/tk.spec
	* win/configure.in:

	* unix/configure:	autoconf
	* win/configure:

2002-09-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: regen.
	* unix/tcl.m4: improve AIX-4/5 64bit compilation support.

	* unix/Makefile.in: add macosx subdir to dist target.
	Do not generate .Z, only .gz and .zip in alldist target.

2002-09-18  Mumit Khan  <khan@nanotech.wisc.edu>

	Added basic Cygwin support.

	* win/tcl.m4 (SC_PATH_TCLCONFIG): Support one-tree build.
	(SC_PATH_TKCONFIG): Likewise.
	(SC_PROG_TCLSH): Likewise.
	(SC_CONFIG_CFLAGS): Assume real Cygwin port and remove -mno-cygwin
	flags.  Add -mwin32 to extra_cflags and extra_ldflags.
	Remove ``-e _WinMain@16'' from LDFLAGS_WINDOW.
	* win/configure: Regenerate.

	* win/tkWinPort.h (tchar.h): Do not include on Cygwin.
	(_T): Define for Cygwin.
	* win/winMain.c (main): Conditionally define.

2002-09-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: preserve environment value of INSTALL_ROOT.
	When embedding only use deployment build. Force relink before
	embedded build to ensure new linker flags are picked up.

	* macosx/buildTkConfig.tcl (new):
	* macosx/Wish.pbproj/project.pbxproj: synthesize tkConfig.sh
	based on tclConfig.sh in Tcl.framework and tkConfig.sh.in.
	Add symbolic links to debug lib, stub libs and tkConfig.sh
	in framework toplevel. Made tkIntXlibDecls.h a public header
	since Headers/X11/Xlib.h includes it. Install wish8.4 script
	that runs "Wish Shell.app" and corresponding wish link.
	Use tcl headers from built Tcl.framework instead of from tcl
	source directory.

	* macosx/tkMacOSXPort.h: added missing standard unix includes
	and defines, similarly to tkUnixPort.h.
	* macosx/tkMacOSXNotify.c: removed dependency on internal tcl
	header "tclPort.h"

	* unix/Makefile.in:
	* unix/install-sh: copied support for 'install-strip' target
	over from tcl/unix/{Makefile.in,install-sh}

2002-09-22  Jim Ingham <jingham@apple.com>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValue): HiliteControl
	doesn't give the proper "nothing to scroll" look on Mac OS X.
	You have to set the min value greater than the max value to
	get this.

2002-09-15  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* unix/tkUnixEvent.c (TkpCloseDisplay): Use PEEK_XCLOSEIM
	to examine the input context queue before invoking
	XCloseIM. Generate an assert if there is an input
	context that has not been freed.
	[Patch 570902]

2002-09-13  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* generic/tk.h: Moved RC_INVOKED down so that tcl.h is still
	included when running the resource compiler. <tcl.h> excludes the
	unnecessary parts on its own. This reenables the Windows build. It
	failed because the non-inclusion of tcl.h caused the resource
	compiler to miss some vital macro definitions (TCL_FINAL_RELEASE,
	STRINGIFY, ...).

2002-09-12  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.h:
	* mac/tkMacApplication.r:
	* mac/tkMacLibrary.r:
	* mac/tkMacResource.r:
	* macosx/tkAboutDlg.r:
	* macosx/tkMacOSXApplication.r:
	* macosx/tkMacOSXLibrary.r:
	* macosx/tkMacOSXResource.r: unified use of the two equivalent
	resource compiler header inclusion defines RC_INVOKED and
	RESOURCE_INCLUDED, now use RC_INVOKED throughout.

	* macosx/tkMacOSXAppInit.c: improved detection of Wish startup
	by the finder (by checking if stdin is /dev/null), in which
	case we want to bring up the Tk console window.

	* macosx/tkMacOSXHLEvents.c: added 'rapp' apple event handler.

2002-09-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: reference & install
	tk/generic/prolog.ps instead of tk/library/prolog.ps.

2002-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added backwards
	compatibility for OSX 10.1 ProjectBuilder 2.0.

2002-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: added DYLIB_INSTALL_DIR variable for Darwin
	and set it to default value ${LIB_RUNTIME_DIR}
	* unix/tcl.m4 (Darwin): use DYLIB_INSTALL_DIR instead of
	LIB_RUNTIME_DIR in the -install_name argument to ld.
	* unix/configure: regen.

	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Makefile: added support for building Tcl as an embedded
	framework, i.e. using an dyld install_name containing
	@executable_path/../Frameworks via the new DYLIB_INSTALL_DIR
	unix/Makefile variable.

2002-09-10  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.0 TAGGED FOR RELEASE ***

2002-09-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXNotify.c (Tk_MacOSXSetupTkNotifier): corrected
	Mac Jaguar event loop issue.

	* library/tk.tcl: use command instead of control on Aqua bindings.
	Force dialogs to appear below fixed native Mac menubar.
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c: Keypress/release events for pure
	modifier keys were not being passed to Tk.
	Deadkey presses were inserting null characters into text windows.
	Now they do nothing. (Still not ideal, but better than before!)
	* macosx/tkMacOSXMenu.c: Allow more than 200 menus to exist -
	increased to 2000.
	* macosx/tkMacOSXMouseEvent.c: Bad interactions between floating
	windows and ordinary ones.  Ensure that local<->global coordinate
	transformations are wrt to the correct window.
	* macosx/tkMacOSXWm.c: Better error msg for 'wm attributes'.
	Remove crash in 'wm transient'.
	Add 'noActivates' and 'noUpdates' flags to unsupported command.
	[Patch #606658] (darley)

	* library/xmfbox.tcl (::tk::MotifFDialog_ActivateSEnt): corrected
	msgcat code with XPG specifier. [Patch #606719] (miller)

2002-09-06  Don Porter <dgp@users.sf.net>

	* tests/unixWm.test (unixWm-50.3):  Constrained test that hangs
	on Windows.

2002-09-05  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: added overlooked missing
	TK_PATCH_LEVEL version bump to 8.4.0.

2002-09-04  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* win/Makefile.in (install-libraries): Added code section to
	install the message catalogs. Copied same section from
	unix/Makefile.in and adapted it to the slightly different
	environment.

2002-09-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl: further restrict buttons to not resetting
	the "original" relief if it has changed in the interim.  This
	prevents code that simulated overrelief buttons from not working
	in 8.4.  [Bug #604270]

2002-09-03  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.pbproj/project.pbxproj: Bumped version number to
	8.4.0 and updated copyright info.

2002-09-03  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXWm.c: fix to 'wm attributes' error-handling bug.

2002-09-03  Don Porter <dgp@users.sf.net>

	* changes: Updated for 8.4.0 release

2002-09-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/cursor.test: reverted 2002-08-31 change for OS X to use
	'heart' cursor because 'arrow' on windows has a pre-skewed use
	count. [Bug #602667]

	* tests/button.test: added button-14.1
	* win/tkWinButton.c (TkpComputeButtonGeometry): correct Win button
	sizing to be equal for one-line buttons with -height of 0 or 1, as
	well as -height 0 buttons with empty text and no image, which
	should be the same as single-line text buttons. [Bug #565485]

	* library/button.tcl (::tk::ButtonLeave): correctly restore state
	of button to normal for unix bindings. [Bug #597920]

	* doc/tk.n: added tk windowingsystem docs.

	* tests/wm.test:
	* unix/tkUnixWm.c: remove possible 2-second delay in 'raise'.
	[Patch #601518] (english) TIP #107

	* unix/tcl.m4: add support for 64-bit builds on HP-11 with gcc.
	* unix/configure.in: make sure to substitute LD_LIBRARY_PATH_VAR.
	* unix/configure: regend

	* README:		Bumped version number to 8.4.0
	* generic/tk.h:
	* unix/configure:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure:
	* win/configure.in:

	* generic/tkCmds.c:
	* generic/tkWindow.c: made 'tk' available in safe interpreters,
	but only the caret and windowingsystem subcommands may be called.
	* tests/safe.test (safe-1.2): noted that tk is now available in
	safe interps, but not the appname/scaling subcommands.

	* tests/tk.test (tk-1.2): noted new tk windowingsystem subcommand

2002-08-31  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: update from Tcl

	* unix/Makefile.in: import of TK_SHLIB_LD_EXTRAS for Tk library
	specific linker settings. Added use of new LD_LIBRARY_PATH_VAR.

	* unix/configure: regen

2002-08-31  Daniel Steffen  <das@users.sourceforge.net>

	*** macosx-8-4-branch merged into the mainline [tcl patch #602770] ***

	* generic/tk.decls:
	* generic/tkInt.decls: added new "aqua" specific entries to the
	stubs tables. Changed all "unix" entries to "x11" to allow us to
	distinguish and build both "aqua" on MacOSX and "x11" on MacOSX.

	* generic/tk.h: added a #ifnded RESOURCE_INCLUDED so that tk.h can
	be passed to the resource compiler.

	* generic/tkCmds.c (Tk_TkObjCmd): added [tk windowingsystem]
	subcommand: returns "x11" when running on X11, "win32" on Windows,
	"classic" on MacOS9 and "aqua" on MacOSX Aqua (i.e. Carbon)

	* generic/tkFont.c (TkFontGetFirstTextLayout): new private function
	returning the first chunk of a Tk_TextLayout, i.e. until the first
	font change on the first line (or the whole first line if there is
	no such font change).

	* generic/tkMain.c: made Tcl_ThreadDataKey static

	* library/demos/puzzle.tcl: fixed button metrics for aqua

	* tests/cursor.test: check for presence of arrow cursor instead of
	heart cursor

	* xlib/xcolors.c: changed xColors static initialization to more
	standard C

	* macosx/Wish.pbproj/jingham.pbxuser (new):
	* macosx/Wish.pbproj/project.pbxproj (new): project for Apple's
	ProjectBuilder IDE.

	* macosx/Makefile (new): simple makefile for building the project
	from the command line via the ProjectBuilder tool 'pbxbuild'.

	* macosx/tkMacOSXAppInit.c (new): macosx specific AppInit looking
	for a AppMain.tcl file in its bundled Resources/Scripts folder. If
	present, argv[1] is set to that file and the Scripts folder is
	added to the auto_path. This allows tk apps to embed scripts within
	their bundle directory structure.

	* macosx/tkMacOSXInit.c (new): macosx adapted version of
	tkUnixInit.c: we initialize & cache the Carbon native encoding
	(e.g. 'macRoman') and try to find the tk script library files
	inside Tk packaged as a framework.

	* macosx/tkMacOSXNotify.c (new): new macosx specific merged
	Carbon/select-based notifier.

	* macosx/tkMacOSXEvent.c (new):
	* macosx/tkMacOSXEvent.h (new):
	* macosx/tkMacOSXKeyEvent.c (new):
	* macosx/tkMacOSXMouseEvent.c (new):
	* macosx/tkMacOSXWindowEvent.c (new): new macosx specific event
	handling functionality.

	* macosx/tkMacOSX.h (new):
	* macosx/tkMacOSXBitmap.c (new):
	* macosx/tkMacOSXButton.c (new):
	* macosx/tkMacOSXClipboard.c (new):
	* macosx/tkMacOSXColor.c (new):
	* macosx/tkMacOSXConfig.c (new):
	* macosx/tkMacOSXCursor.c (new):
	* macosx/tkMacOSXDefault.h (new):
	* macosx/tkMacOSXDialog.c (new):
	* macosx/tkMacOSXDraw.c (new):
	* macosx/tkMacOSXEmbed.c (new):
	* macosx/tkMacOSXFont.c (new):
	* macosx/tkMacOSXHLEvents.c (new):
	* macosx/tkMacOSXInt.h (new):
	* macosx/tkMacOSXKeyboard.c (new):
	* macosx/tkMacOSXMenu.c (new):
	* macosx/tkMacOSXMenubutton.c (new):
	* macosx/tkMacOSXMenus.c (new):
	* macosx/tkMacOSXPort.h (new):
	* macosx/tkMacOSXRegion.c (new):
	* macosx/tkMacOSXScale.c (new):
	* macosx/tkMacOSXScrlbr.c (new):
	* macosx/tkMacOSXSubwindows.c (new):
	* macosx/tkMacOSXTest.c (new):
	* macosx/tkMacOSXUtil.c (new):
	* macosx/tkMacOSXUtil.h (new):
	* macosx/tkMacOSXWm.c (new):
	* macosx/tkMacOSXWm.h (new):
	* macosx/tkMacOSXXStubs.c (new): macosx ports of classic mac Tk
	implementation in tk/mac.

	* macosx/tkMacOSXSend.c (new): only send to local interp
	implemented currently.

	* macosx/tkMacOSXDebug.h (new):
	* macosx/tkMacOSXDebug.c (new): new macosx specific functions for
	debugging MacOS events, regions, etc.

	* macosx/tkAboutDlg.r (new):
	* macosx/tkMacOSXApplication.r (new):
	* macosx/tkMacOSXCursors.r (new):
	* macosx/tkMacOSXLibrary.r (new):
	* macosx/tkMacOSXMenu.r (new):
	* macosx/tkMacOSXResource.r (new):
	* macosx/tkMacOSXXCursors.r (new):
	* macosx/tclets.r (new): sources for Rez resource compiler.

	* macosx/Wish.icns (new): Wish application icon.

	* generic/tk.h:
	* generic/default.h:
	* generic/tkBind.c:
	* generic/tkCmds.c:
	* generic/tkGrab.c:
	* generic/tkPointer.c:
	* generic/tkPort.h:
	* generic/tkSelect.c:
	* generic/tkStubLib.c:
	* generic/tkTest.c:
	* generic/tkText.c:
	* generic/tkWindow.c:
	* unix/tkUnix3d.c:
	* xlib/xgc.c:
	* xlib/X11/X.h:
	* xlib/X11/Xlib.h:
	* xlib/X11/Xutil.h: added #includes and #ifdefs for macosx

	* library/bgerror.tcl:
	* library/button.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/scrlbar.tcl:
	* library/spinbox.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/demos/menu.tcl:
	* library/demos/menubu.tcl:
	* library/demos/widget: check [tk windowingsystem] instead of
	and/or in addition to $tcl_platform(platform).

	* generic/tkInt.h:
	* mac/tkMacBitmap.c:
	* mac/tkMacWm.c: added missing CONSTification

	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkStubInit.c: regen

2002-08-27  D. Richard Hipp <drh@hwaci.com>

	* doc/checkbutton.n:      [Bug 582457] Fix the -offrelief option so
	* doc/radiobutton.n:      that when -offrelief is flat and -relief is
	* mac/tkMacButton.c:      sunken and -overrelief is raised, buttons
	* unix/tkUnixButton.c:    work look toolbar buttons under Windows.
	* win/tkWinButton.c:      See also: TIP #82.

2002-08-26  Don Porter <dgp@users.sf.net>

	* win/Makefile.in:	Removed dependence on the (parts of) the
	* win/winMain.c:	tcltest executable on Windows.  It was not
	used, and the dependency complicated the Makefile.  [Bug 592638].

2002-08-20  Don Porter <dgp@users.sf.net>

	* README:		Bumped version number to 8.4b3 to distinguish
	* generic/tk.h:		HEAD from the 8.4b2 release.
	* unix/configure.in:
	* win/configure.in:
	* unix/tk.spec:

	* unix/configure:	autoconf
	* win/configure:

	* generic/tk.h:	Added compile-time check that the tcl.h header file
	#included by Tk 8.4 is one from Tcl 8.4.  This is needed to be sure
	that new #defines like CONST84 are available. [Bug 597432].

2002-08-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (install-binaries): simplified pkgIndex.tcl
	file created on installation.
	* win/Makefile.in (install-binaries): corrected and simplified
	creation of pkgIndex.tcl file on installation.

2002-08-14  Vince Darley  <vincentdarley@users.sourceforge.net>

	* win/tkWinDialog.c:
	* win/makefile.vc: broken compilation and link from changes
	Hobbs-08-07 fixed.
	* win/tkWinTest.c: CONST problem resolved.

2002-08-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl: change the bindings to use Priv($w,relief)
	instead of just Priv(relief).  This ensures that neighboring
	buttons don't confuse (over)relief settings.

2002-08-13  Reinhard Max  <max@suse.de>

	* unix/tkUnixSend.c (Tk_SetAppName): Fixed a compiler warning.

2002-08-12  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/image2.tcl: Tweaked the behaviour of the directory
	box on resize, as resizing of the overall window tends to be
	common given the sample images.

2002-08-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tkUnixWm.c (WmTransientCmd): Apply fix for
	wm transient assertion error that was applied
	to tkWinWm.c for Tk Bug #592201.

2002-08-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add deleteWindows at start of
	new transient tests so they do not fail if the
	toplevels already exist.
	* unix/tkUnixWm.c: Revert patch for Tk Bug #592201
	which incorrectly removed numTransients member.

2002-08-08  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c:
	* win/tkWinWm.c:
	* tests/wm.test: Fix for Tk Bug #592201 "wm transient fails with
	two masters"; fixes panic after a transient window is reassigned
	to new master and either master is subsequently destroyed.

2002-08-08  Don Porter <dgp@users.sf.net>

	* tests/unixWm.test:  Corrected packaging of unixWm-50.3 so that
	[setupbg] and [cleanupbg] always balance, no matter what tests
	are skipped.

2002-08-08  Reinhard Max  <max@suse.de>

	* unix/Makefile.in: Fixed typos in DISTNAME, and ZIPNAME.

2002-08-08  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4b2 TAGGED FOR RELEASE ***

	* generic/tkButton.c (TkButtonWorldChanged): added GCFont handling
	to the disabledGc of buttons when compound != none.  The drawing
	appears to be incorrect across platforms still.  [Bug #477740]

	* generic/tkImgGIF.c (FileReadGIF): fixed -from handling for gifs
	[Bug #467524] (obermeier)

2002-08-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCanvUtil.c (TkSmoothParseProc): recognize the built-in
	bezier method by name. [Bug #578654]
	* doc/canvas.n: update to note that -smooth really doesn't take
	or return just booleans.

	* win/tkWinMenu.c (TkpSetWindowMenuBar): fixed logic bug in when
	to idle call ReconfigureWindowsMenu.

	* doc/GetBitmap.3: removed doc refs to deprecated
	Tk_GetBitmapFromData. [Bug #590379]

	* generic/tkPanedWindow.c (Tk_PanedWindowObjCmd):
	* library/panedwindow.tcl: changed class from PanedWindow to
	Panedwindow to not conflict with existing bwidgets, but also to be
	more regular with other names used in the core.

	* tests/panedwindow.test: added -text foobar to some test buttons
	to enable correct testing of panedwindow across platforms.
	[Bug #582370]

	* win/tkWinDialog.c: enabled use of the updated native Windows
	directory browser (tk_chooseDirectory).  This does require
	shell32.dll v4.71 or greater. [Patch #468139]

	* win/configure:
	* win/tcl.m4: added shell32 to libs for updated native Windows
	tk_chooseDirectory dialog.

2002-08-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (RESIZE_PENDING): Separated out flag for
	indicating that a resize needs to be issued.
	(PanedWindowReqProc): Do the old behaviour when the panedwindow is
	not mapped; easiest way of making the test suite pass while still
	preserving improved behaviour in the face of children whose size
	is not known immediately.

2002-08-06  Don Porter <dgp@users.sf.net>

	* tests/defs.tcl: removed file.  No longer needed now that Tk is
	using the tcltest package to do its testing.

2002-08-05  Don Porter <dgp@users.sf.net>

	* win/tkWinFont.c:	Additional changes to fix CONST warnings on
	* win/tkWinWM.c:	Windows due to latest patch.  Tks Vince Darley.

	* doc/3DBorder.3:	Applied companion patch for Tcl Patch 585105,
	* doc/BindTable.3:	updating Tk to use Tcl 8.4's fully CONST-ified
	* doc/ConfigWidg.3:	interface, and fully CONSTifying Tk at the
	* doc/CrtImgType.3:	same time.
	* doc/CrtWindow.3:
	* doc/DeleteImg.3:	This patch includes purging Tk of its last
	* doc/FindPhoto.3:	direct access to interp->result.  [Bug 589853]
	* doc/GetAnchor.3:
	* doc/GetBitmap.3:	The substantial changes include copying
	* doc/GetCapStyl.3:	event sequence strings into Tcl_DStrings
	* doc/GetClrmap.3:	in tkBind.c, and copying [text] indices into
	* doc/GetColor.3:	Tcl_DStrings because parsing them involved
	* doc/GetCursor.3:	overwriting them.  If this causes performance
	* doc/GetFont.3:	trouble, that can be resolved by further
	* doc/GetImage.3:	converting them to Tcl_Obj's.
	* doc/GetJoinStl.3:
	* doc/GetJustify.3:	The #defines USE_NON_CONST and USE_COMPAT_CONST
	* doc/GetOption.3:	have the same effect for Tk as they do for Tcl.
	* doc/GetRelief.3:	(They actually change tcl.h)
	* doc/GetScroll.3:
	* doc/GetVisual.3:
	* doc/InternAtom.3:
	* doc/NameOfImg.3:
	* doc/SetAppName.3:
	* doc/WindowId.3:
	* generic/tk.decls:
	* generic/tk.h:
	* generic/tk3d.c:
	* generic/tkAtom.c:
	* generic/tkBind.c:
	* generic/tkBitmap.c:
	* generic/tkButton.c:
	* generic/tkCanvArc.c:
	* generic/tkCanvBmap.c:
	* generic/tkCanvImg.c:
	* generic/tkCanvLine.c:
	* generic/tkCanvPoly.c:
	* generic/tkCanvPs.c:
	* generic/tkCanvText.c:
	* generic/tkCanvUtil.c:
	* generic/tkCanvWind.c:
	* generic/tkCanvas.c:
	* generic/tkCanvas.h:
	* generic/tkClipboard.c:
	* generic/tkCmds.c:
	* generic/tkColor.c:
	* generic/tkConfig.c:
	* generic/tkConsole.c:
	* generic/tkCursor.c:
	* generic/tkDecls.h:
	* generic/tkEntry.c:
	* generic/tkFont.c:
	* generic/tkFrame.c:
	* generic/tkGet.c:
	* generic/tkGrid.c:
	* generic/tkImage.c:
	* generic/tkImgBmap.c:
	* generic/tkImgPhoto.c:
	* generic/tkInt.decls:
	* generic/tkInt.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkListbox.c:
	* generic/tkMenu.c:
	* generic/tkMenubutton.c:
	* generic/tkMessage.c:
	* generic/tkOldConfig.c:
	* generic/tkOption.c:
	* generic/tkRectOval.c:
	* generic/tkScale.c:
	* generic/tkScrollbar.c:
	* generic/tkSelect.c:
	* generic/tkStyle.c:
	* generic/tkTest.c:
	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextImage.c:
	* generic/tkTextIndex.c:
	* generic/tkTextMark.c:
	* generic/tkTextTag.c:
	* generic/tkTextWind.c:
	* generic/tkUtil.c:
	* generic/tkVisual.c:
	* generic/tkWindow.c:
	* mac/tkMacConfig.c:
	* mac/tkMacCursor.c:
	* mac/tkMacEmbed.c:
	* mac/tkMacSend.c:
	* unix/tkUnixConfig.c:
	* unix/tkUnixCursor.c:
	* unix/tkUnixEmbed.c:
	* unix/tkUnixFont.c:
	* unix/tkUnixSelect.c:
	* unix/tkUnixSend.c:
	* unix/tkUnixWm.c:
	* win/tkWinConfig.c:
	* win/tkWinCursor.c:
	* win/tkWinEmbed.c:
	* win/tkWinMenu.c:
	* win/tkWinSend.c:

2002-08-02  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (DestroyPanedWindow): Idle calls need to
	be deleted on destruction of the window, or things can *really* go
	pear-shaped.

2002-07-31  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkPanedWindow.c (PanedWindowReqProc): Postpone pane
	arrangement until idle, as is done in other window managers, to
	fix problems with size calculations when the children don't
	already know their sizes anyway.

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-07-29  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Remove code that was setting
	CC_SEARCH_FLAGS and LD_SEARCH_FLAGS to try to
	account for cc vs ld linking. Tcl now handles this.
	* unix/tcl.m4: Update from Tcl.

2002-07-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Add MAJOR_VERSION, MINOR_VERSION,
	PATCH_LEVEL, INSTALL_LIBRARY, STUB_LIB_FILE, and LIB_FILE
	to support changes in tcl.m4 related to library builds.
	Use MAKE_LIB macro to avoid dealing with RANLIB issues.
	Rename TK_CC_SEARCH_FLAGS to CC_SEARCH_FLAGS and
	rename TK_LD_SEARCH_FLAGS to LD_SEARCH_FLAGS.
	Use new INSTALL_LIB and INSTALL_STUB_LIB substs to
	deal with ranlib issues when install libraries.
	* unix/configure: Regen.
	* unix/configure.in: Remove AC_PROG_RANLIB since
	this is done by tcl.m4 now. Define CC_SEARCH_FLAGS
	instead of TK_CC_SEARCH_FLAGS and so on.
	Use MAKE_LIB and MAKE_STUB_LIB from tcl.m4.
	Remove AC_SUBST calls that are no done in tcl.m4.
	* unix/tcl.m4: Update from Tcl.
	* unix/tkConfig.sh.in: Subst CC_SEARCH_FLAGS and
	LD_SEARCH_FLAGS.

2002-07-25  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkInt.h:
	* generic/tkWindow.c:
	* mac/tkMacWm.c:
	* unix/tkUnixWm.c:
	* win/tkWinWm.c:
	* tests/wm.test:
	* tests/winWm.test:
	* tests/unixWm.test: Objectifed wm. [Patch #564521]
	Note: At this point the Mac file is completely untested
	and may not even compile.

2002-07-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/spinbox.test: added spinbox-22.[1-3]
	* generic/tkEntry.c (ConfigureEntry): made the textvariable value
	take precedence over changed -from/-to values, unless it must be
	constrained.  [Bug #559078]

	* library/spinbox.tcl (MouseSelect): when not in the entry, just
	return instead of invoking - ButtonUp handles invoking already.
	[Bug #499168]

	* library/tk.tcl (RestoreFocusGrab): handle the case where the
	FocusGrab info is not set. [Bug #553283]

2002-07-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/canvas.test: added canvas-14.[1-6]
	* generic/tkCanvas.c (CanvasWidgetCmd): corrected handling of
	'scan' subcommand args.  Also removed early return cases to goto
	done instead where the canvasPtr would be Tcl_Release'd.  This may
	solve other problems with unreleased canvasPtr's. [Bug #581560]

	* win/tkWinButton.c (TkpDisplayButton): corrected display of focus
	ring around the actual text when the button is a compound button.
	[Bug #583691]

	* unix/README: Corrected notes about running user interactive Tk
	tests. [Bug #462320]

	* generic/tkText.c (TextEditUndo): set isDirtyIncrement to -1 when
	reverting to note proper "dirtiness". [Bug #580362] (callewaert)

	* generic/tkEntry.c (DisplayEntry): correct cursor position before
	calling Tk_SetCaretPos. (yamamoto)

2002-07-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-07-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::file::chooseDir):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog):
	Revert [Tk patch 568278]. The transient window workaround
	is no longer needed since the fix for [Tk bug 570764]
	solved the problem for withdrawn transients.

2002-07-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure:
	* unix/configure.in:
	* win/configure:
	* win/configure.in: Add AC_PREREQ(2.13) in an attempt
	to make it more clear that the configure scripts
	must be generated with autoconf version 2.13.
	[Tcl Bug 583573]

2002-07-19  D. Richard Hipp  <drh@hwaci.com>

	* library/mkpsec.tcl: Fix a bug that was causing postscript generation
	to fail under Win2K.

2002-07-18  Reinhard Max  <max@suse.de>

	* unix/tkUnixSend.c: Using Tcl_GetTime instead of TclpGetTime.

2002-07-17  Reinhard Max  <max@suse.de>

	* library/unsupported.tcl: Extended ExposePrivateVariable, and
	ExposePrivateCommand to accept patterns as well.

2002-07-17  Don Porter <dgp@users.sf.net>

	* generic/tkFont.c: Corrected reversed logic in assert -> panic
	conversion.  [Bug 582799]

2002-07-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkFont.c (TkFontPkgFree): Call panic instead
	of assert since assert is not used in the rest of Tk.
	[Tk bug 579651]

2002-07-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	* win/Makefile.in: Add a more descriptive warning
	in the event `make genstubs` needs to be rerun.

2002-07-16  Vince Darley  <vincentdarley@users.sourceforge.net>

	* win/tkWinWm.c:
	* doc/wm.n: fix for part of [Bug 581627], and made iconbitmap
	code on Windows more flexible about reading in icons [Bug
	220800].

2002-07-15  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.bc (new): re-add of the borland makefile.  Submitted
	by Helmut Giese <hgiese@ratiosoft.com>.  This needs testing, still.

2002-07-15  Don Porter <dgp@users.sf.net>

	* Fixes for [Bug 581627, 581795].
	* generic/tkTest.c:		Test commands not supported on non-Unix
	platforms should not be defined there in the first place.
	* tests/constraints.tcl:	Fixed "secureserver" constraint.
	* tests/unixWm.test:		Some tests needed "unix" constraint.
	* win/tkWinWm.c:		Typo in error message.

2002-07-14  Don Porter <dgp@users.sf.net>

	* tests/event.test:	Fixes to enable testing of only userInteraction
	* tests/visual_bb.test:	tests.

	* README:		Bumped HEAD to version 8.4b2 in order to
	* generic/tk.h:		distinguish it from the 8.4b1 release.
	* unix/configure*:	Also extended LOCALES to cover all message
	* unix/tk.spec:		catalogs.
	* win/configure*:

	* tests/focustTcl.test:	Conversion bug: Corrected backwards logic.
	* tests/imgPhoto.test:	Conversion bug: overwrote unix/README.

	* tests/all.tcl:		Completed conversion of Tk test suite
	* tests/constraints.tcl:	to use tcltest.
	* tests/[b-v]*.test:
	* unix/Makefile.in:

2002-07-12  Don Porter <dgp@users.sf.net>

	* tests/constraints.tcl:	Converted more files to tcltest and
	* tests/[g-x]*.test:		factored out common code.

2002-07-11  Don Porter <dgp@users.sf.net>

	* tests/canvPsImg.tcl:			Converted several files in the
	* tests/constraints.tcl (new file):	Tk test suite for testing by
	* tests/[r-x]*.test:			tcltest 2.1.
	* unix/Makefile.in:

2002-07-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (Tk_ChooseDirectoryObjCmd): initialize
	utfTitle to NULL, add a few more notes about limitations of
	possible new Tk_ChooseDirectoryObjCmd function.

2002-07-11  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/imgPhoto.test (imgPhoto-15.1): Added test of mem-alloc
	failure, but this is non-portable.
	* generic/tkImgPhoto.c (ImgPhotoSetSize): Allowed this function to
	fail when it can't allocate enough memory.  Note that not all the
	places that call it can fail nicely without API changes; some
	still panic but at least some of the potential failures are now
	handled gracefully.

	* tests/visual_bb.test (lpr): Stopped this from relying on
	external files; direct piping is much more flexible for this
	application.

2002-07-09  Don Porter <dgp@users.sf.net>

	* generic/tkTest.c:	Removed unused dependence on TclThread_Init()
	* tests/defs.tcl:	and [testthread].  [Bug 578165, Tcl Bug 531413]

2002-07-08  David Gravereaux <davygrvy@pobox.com>

	* unix/Makefile.in: Added missing win/lamp.bmp to the dist
	target.

2002-07-05  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4b1 TAGGED FOR RELEASE ***

2002-07-04  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/bgerror.tcl (bgerror): Stopped the bgerror dialog from
	getting wider than the screen; in theory really long messages
	could make it become taller than the screen now, but that's much
	less likely to happen.  Also trimmed a little bit of internal
	space so that the icon-message gap is the same as the icon-frame
	and message-frame gaps.

2002-07-01  Don Porter <dgp@users.sf.net>

	* unix/configure:
	* unix/tcl.m4: Updated to latest tcl.m4 from Tcl.

2002-06-28  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/msgbox.tcl (MessageBox): Force all non-button widgets to
	have the same background as the containing toplevel.  [Bug #552515]

2002-06-27  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* win/Makefile.in (install-binaries): Fix of troubled Makefile
	quoting introduced by [Patch 521356] causing the installed to
	fail.

2002-06-25  Don Porter <dgp@users.sf.net>

	* unix/tkUnixFont.c: (Tk_DrawChars) silence compiler warning.

2002-06-26  David Gravereaux <davygrvy@pobox.com>

	* generic/tkStyle.c: <eol> of the committing cvs client didn't
	match the <eol> of the file itself.  Windows users where getting
	\r\r\n.  Problem fixed.

2002-06-26  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* generic/tkFont.c (TkTextLayoutToPostscript): fixed potential
	buffer overflow which could be intentionally triggered from
	within safe interpreter -- malicious applet could modify
	tk::psglyphs array.

2002-06-26  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* tests/font.test (font-32.1): updated this test
	to expect the new behavior of canvas postscript.

2002-06-25  Don Porter <dgp@users.sf.net>

	* unix/Makefile.in:	Expanded install-binaries target to create
	* win/Makefile.in:	and install a pkgIndex.tcl file to enable
	Tk as a loadable package [Patch 521356]

2002-06-25  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/mkpsenc.tcl: (added) utilities to generate
	Postscript prolog for current system encoding.
	* generic/tkCanvPs.c (TkCanvPostscriptCmd): now
	uses mkpsenc.tcl to generate Postscript prolog.
	* generic/tkFont.c (TkTextLayoutToPostscript): modified
	according to patch #546910. Now outputs system-encoded
	characters (for unibyte) or Adobe glyph names (for
	multibyte or outside-locale).
	* tests/canvText.test (canvText-17.1): updated this test
	to expect the new behavior of canvas postscript.

2002-06-25  Reinhard Max  <max@suse.de>

	* unix/tcl.m4:       New macro SC_CONFIG_MANPAGES.
	* unix/configure.in: Added support for symlinks and compression
	* unix/Makefile.in:  when installing the manpages. [Patch 518052]
	Default is still hardlinks and no compression.

	* unix/mkLinks:      generated
	* unix/configure:

	* unix/README:       Added documentation for the new features.

	* unix/configure:                  Replaced ${exec_prefix}/lib
	* unix/tcl.m4 (SC_PATH_TCLCONFIG): by ${libdir}.

2002-06-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/winWm.test: Verify that both an unmapped
	and already mapped toplevel are raised and receive
	the focus when deiconified.
	* tests/wm.test: Add wm deiconify tests. Check that
	a toplevel that has never been mapped is not mapped
	by the deiconify command since it should be done
	at idle by MapFrame.
	* win/tkWinWm.c (Tk_WmCmd): Check the WM_NEVER_MAPPED
	flag while processing the wm deiconify command.
	The WM_UPDATE_PENDING flag should never be set when
	WM_NEVER_MAPPED is set, but double check so that
	the implementation is more explicit and matches
	the comment just above.
	Return without invoking TkWmRestackToplevel or
	TkSetFocusWin on a toplevel that has never been
	mapped. This fixes a bug where a toplevel is mapped
	with the wrong size and is then resized by the
	idle call to MapFrame. [Tk bug 233150]

2002-06-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (UpdateGeometryInfo): remove the check for a null
	wrapper introduced in r1.41 on 2002-06-15 because it prevented
	geometry setting from taking effect if the window was not on the
	screen.  Another check may go in it's place as IsIconic and
	IsZoomed should not be passed NULL.

2002-06-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Remove invalid minsize test. Add update
	calls to wm transient tests so that idle handlers get
	run. This is needed to get the tests to pass under Win32.
	* unix/tkUnixWm.c (WmWaitMapProc): Move the special
	transient withdrawn check into the if body to
	make it easier to set a breakpoint on this test
	inside a debugger. No functional changes.
	* win/tkWinWm.c (WmWaitVisibilityOrMapProc): Ditto.

2002-06-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/wm.n:                   TIP #95 Windows implementation and
	* mac/tkMacWm.c (Tk_WmCmd):   docs with mac and unix stubs.
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinWm.c (Tk_WmCmd):
	* tests/unixWm.test:
	* tests/winWm.test: more wm attr tests will be needed.

	* generic/tkGrid.c (GridReqProc): check that gridPtr is not NULL
	(may be when embedded). [Bug #548791] (halliday)

	* generic/tkFont.c (TkFontPkgFree): changed panic on freeing fonts
	to an assert, and wrapped panic in #ifdef PURIFY. [Bug #568701]

	* library/menu.tcl: corrected menus from being posted offscreen
	on Windows. [Bug #464451] (darley)

	* library/console.tcl: corrected the defaultPrompt substitution
	[Bug #553207] and made Tab a default expansion key (like Escape).

	* win/tkWinEmbed.c (EmbedWindowDeleted): added a check for a null
	containerPtr.  The core of this bug is likely elsewhere. [Bug #476176]

	* doc/text.n:                             TIP #93 implementation that
	* generic/tkText.c (TextWidgetCmd):       enhances the text get and
	* generic/tkTextIndex.c (TkTextGetIndex): delete methods to accept
	* tests/text.test:                        multiple range pairs.
	This handles the delete case in an atomic, fixed-index fashion.

2002-06-21  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Add tests to make sure a withdrawn
	transient does not get remapped by state changes
	in the master.
	* unix/tkUnixWm.c (Tk_WmCmd, WmWaitMapProc):
	* win/tkWinWm.c (Tk_WmCmd, WmWaitVisibilityOrMapProc):
	Add a WM_TRANSIENT_WITHDRAWN flag that gets set by the
	withdraw, deiconify, or state wm subcommands. Check
	this flag before mapping a transient when processing
	a MapNotify event. [Tk bug 570764]

2002-06-21  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* unix/tk.spec (version), README, win/configure.in, unix/configure.in:
	* generic/tk.h (TK_RELEASE_*, TK_PATCH_LEVEL): Bumped to beta1.

2002-06-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/text.n:          TIP #104 implementation which generalizes the
	* generic/tkText.c:    undo/redo stack to not be tied solely to the
	* generic/tkText.h:    text widget.  The APIs are still private.
	* generic/tkUndo.c:    This also adds a stack limiting ability and
	* generic/tkUndo.h:    a -maxundo option to the text widget (in
	* library/text.tcl:    addition to the options from TIP #26) should
	* mac/tkMacDefault.h:  users want to limit the undo/redo stack
	* tests/text.test:     (should not be necessary in most cases).
	* unix/Makefile.in:    [Patch #554763] (callewart)
	* unix/tkUnixDefault.h:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/tkWinDefault.h:

2002-06-21  Don Porter <dgp@users.sf.net>

	* unix/Makefile.in:	Removed unnecessary dependence of tktest
	* unix/tkAppInit.c:	executable on the tcltest executable on
	Unix.  If there are similar dependencies on other platforms, they
	can probably be removed as well.  [Bug 572134].

2002-06-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/listbox.n:
	* generic/tkListbox.c (DisplayListbox):
	* mac/tkMacDefault.h:   TIP #94 implementation adding -activestyle
	* tests/listbox.test:   option to the listbox.  This adds the ability
	* unix/tkUnixDefault.h: to have listboxes look native on Windows, and
	* win/tkWinDefault.h:   "nicer" elsewhere using the 'dotbox' style.

2002-06-20  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkGrid.c: Corrected the test for grid propagate change.
	[Bug #571433]

2002-06-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/panedwindow.test:
	* generic/tkPanedWindow.c: ensure that sash index is lower bounds
	checked. [Bug #548727]

2002-06-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkClipboard.c (TkClipCleanup): Add code
	to set dispPtr->clipWindow to NULL, this was
	accidently removed by last commit. Fixes
	a crash while running the tests under win32.

2002-06-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkBind.c (TkBindDeadWindow):
	Handle case where Tk_DestroyWindow is invoked
	on clipboard and send windows.
	* generic/tkClipboard.c (TkClipCleanup):
	Invoke Tk_DestroyWindow to cleanup the
	dispPtr->clipWindow. Call Tcl_Preserve
	and Tcl_Release on the window to avoid an
	invalid memory ref on shutdown.
	* generic/tkEvent.c (Tk_HandleEvent):
	Panic if XCreateIC is invoked twice for
	the same window. This should never happen,
	the check were just added to make sure it
	does not since this could lead to crashes
	in XCloseIM.
	* generic/tkFocus.c (TkFocusDeadWindow):
	Handle case where Tk_DestroyWindow is invoked
	on clipboard and send windows.
	* generic/tkOption.c (TkOptionDeadWindow): Ditto.
	* generic/tkWindow.c (TkCloseDisplay): Move
	deletion of dispPtr->winTable after TkpCloseDisplay
	call since Tk_DestroyWindow uses it and could
	be called by TkpCloseDisplay for clipboard/send windows.
	Also invoke ckfree for the dispPtr instead of
	doing it in TkpCloseDisplay.
	(Tk_DestroyWindow): Check for a null winPtr->mainPtr
	before doing certain cleanup tasks so the we can
	invoke Tk_DestroyWindow on clipboard and send windows.
	We need to do this so that XDestroyIC will get invoked
	for the input contexts of each window.
	* mac/tkMacXStubs.c (TkpCloseDisplay): Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	* unix/tkUnixEvent.c (TkpCloseDisplay, OpenIM): Remove
	conditional compilation around calls to XCloseIM
	since I am confident that the crashes related to
	input contexts has been fixed. Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	* unix/tkUnixSend.c (TkSendCleanup): Invoke the
	Tk_DestroyWindow method to cleanup the special
	send window. This will call XDestroyIC and thereby
	avoid a crash in XCloseIM. The send window needs
	to be Tcl_Preserve and Tcl_Release to avoid an
	invalid memory ref on shutdown.
	* win/tkWinX.c (TkpCloseDisplay): Don't free
	the displayPtr since this is now done in TkCloseDisplay.
	[Tk patch 570902]

2002-06-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkStyle.c: TIP#48 style engine.
	See http://purl.org/tcl/tip/48.html for details.

	* generic/tkConfig.c (GetOptionFromObj): Split to allow for access
	to option tables via name as well as via object.
	(TkGetOptionSpec): Semi-public interface to GetOption functionality.
	(DoObjConfig, Tk_RestoreSavedOptions, FreeResources)
	(GetObjectForOption): Basic style support for configure.

	* generic/tkWindow.c (TkCreateMainWindow, Tk_DestroyWindow): Added
	calls to set up and tear down the style subsystem.

	* generic/tk.decls, generic/tk.h: Many declarations forming TIP#48
	public interface.

	* generic/tkInt.decls (TkStylePkgInit,TkStylePkgFree):
	* generic/tkInt.h (TkGetOptionSpec): Supporting declarations.

	* unix/Makefile.in, win/Makefile.in, win/makefile.vc: Added
	tkStyle.c to list of generic source files.

2002-06-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/defs.tcl (makeFile): Defined the return value of this
	procedure to be the filename of the created file, as in the real
	tcltest package...

2002-06-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkImage.c (Tk_ImageObjCmd, DeleteImage): Call
	Tcl_Preserve and Tcl_Release for the masterPtr->winPtr
	window to avoid accessing memory that had already
	been deallocated in DeleteImage.

2002-06-17  David Gravereaux <davygrvy@pobox.com>

	Trims to support the removal of RESOURCE_INCLUDED from rc
	scripts from Tcl's accepted FR #565088.

	* generic/tk.h: Changed RESOURCE_INCLUDED to be RC_INVOKED
	as the RC tool defines this already by default.

	* win/rc/tk.rc:
	* win/rc/wish.rc: removed the #define RESOURCE_INCLUDED lines.

2002-06-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (dist): correct installation of
	wish.exe.manifest to DISTDIR target directory.

	* generic/tkCmds.c (Tk_TkObjCmd):
	* generic/tkInt.h (struct TkCaret):
	* mac/tkMacXStubs.c (Tk_SetCaretPos):
	* unix/tkUnixKey.c (TkpGetString, Tk_SetCaretPos):
	* win/tkWinX.c (Tk_SetCaretPos):
	* tests/tk.test:        Added 'tk caret' implementation of TIP#96
	* doc/SetCaret.3 (new): which adds a TkCaret structure element to
	* doc/tk.n:             TkDisplay for maintaining state.

	* unix/tkUnixSend.c (TkSendCleanup): special cleanup of
	inputContext to avoid bug in XCloseIM. (dejong)

2002-06-17  Don Porter <dgp@users.sf.net>

	* library/msgs/en_gb.msg:  Added catalog for UK English.
	Currently includes only Color -> Colour translation.

2002-06-17  D. Richard Hipp  <drh@hwaci.com>

	* doc/checkbutton.n:
	* doc/radiobutton.n:
	* generic/tkButton.c:
	* generic/tkButton.h:
	* mac/tkMacButton.c:
	* tests/button.test:
	* unix/tkUnixButton.c:
	* win/tkWinButton.c: Implementation of TIP#82 - Added the
	-offrelief option to checkbutton and radiobutton.

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkWindow.c (Tk_DestroyWindow): Set the pathName
	component of a window to NULL after its memory has been
	deallocated to avoid a possible illegal memory access
	as a result of a call to Tk_PathName() on a Tk_Window
	structure of a window that has already been destroyed.
	[Tk bug 521946]

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkOption.c (Tk_GetOption): Allocate
	memory with ckalloc not malloc. This keeps
	Tk from erroring out when built with
	TCL_MEM_DEBUG.

2002-06-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkBind.c (HandleEventGenerate):
	* generic/tkInt.h: changed warpInProgress boolean from int to a
	bit in the flags variable (TK_DISPLAY_IN_WARP)

	* generic/tkCmds.c (Tk_TkObjCmd):
	* unix/tkUnixKey.c (TkpGetString):
	* generic/tkEvent.c (Tk_HandleEvent):
	* generic/tkInt.h: changed useInputMethods boolean from int to a
	bit in the flags variable (TK_DISPLAY_USE_IM)

	* generic/tkInt.h:
	* generic/tkCmds.c (Tk_WmObjCmd):
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinWm.c (Tk_WmCmd): changed wmTracing from being an int to
	just a bit in the flags variable (TK_DISPLAY_WM_TRACING)

	* generic/tkEvent.c (Tk_HandleEvent):
	* unix/tkUnixEvent.c (OpenIM):
	* unix/tkUnixKey.c (TkpGetString):
	* generic/tkInt.h: added TK_DISPLAY_XIM_SPOT flag bit for TkDisplay
	and used this to allow a runtime check to see if over-the-spot XIM
	is possible.  If not it will try and fallback to the old-style
	input context, which handles things like dead keys input.

	* generic/tk.decls:     added TIP #84 implementation that adds a
	* generic/tkDecls.h:    Tk_CollapseMotionEvents API which controls Tk's
	* generic/tkEvent.c:    collapsing of incoming motion events on its
	* generic/tkInt.h:      windows.  The default remains to do collapsing.
	* generic/tkStubInit.c: Added a flags parameter to the internal display
	* generic/tkWindow.c:   structure to support this and be used in the
	* doc/QWinEvent.3:      future for other bits. [Tk patch 564642]

	* unix/mkLinks: updated from current docs

2002-06-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkEvent.c (TkXErrorHandler): Declare static
	function to avoid compiler error with VC++.
	* generic/tkBind.c (ExpandPercents): Cast argument to
	Tk_GetAtomName in order to avoid compiler warning.

2002-06-14  Joe English  <jenglish@users.sf.net>

	* doc/bind.n:
	* generic/tk.h:
	* generic/tkBind.c:
	* generic/tkCanvWind.c:
	* generic/tkCmds.c:
	* generic/tkEvent.c:
	* generic/tkFocus.c:
	* generic/tkGrab.c:
	* generic/tkGrid.c:
	* generic/tkImage.c:
	* generic/tkPack.c:
	* generic/tkPlace.c:
	* generic/tkPointer.c:
	* generic/tkTextWind.c:
	* generic/tkWindow.c:
	* mac/tkMacSubwindows.c:
	* mac/tkMacWindowMgr.c
	* mac/tkMacWm.c:
	* unix/Makefile.in:
	* unix/tkUnixEmbed.c:
	* unix/tkUnixWm.c:
	* win/tkWinScrlbr.c:
	* win/tkWinWindow.c:
	* win/tkWinWm.c: Implementation of TIP #47 by Neil McKay
	"Modifying Tk to Allow Writing X Window managers".
	Add CirculateRequest, Create, MapRequest, ResizeRequest,
	and ConfigureRequest event types;
	Split TK_TOPLEVEL flag into TK_TOPLEVEL, TK_HAS_WRAPPER,
	TK_WIN_MANAGED, and TK_TOP_HIERARCHY. [Tk patch 572978]

2002-06-14  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* unix/tkAppInit.c: Removed now unneeded and erroneous reference
	to 'matherr'. See Tcl ChangeLog entry 2002-05-31 Don Porter.

2002-06-14  David Gravereaux <davygrvy@pobox.com>

	* win/rules.vc: The test for compiler optimizations was in error.
	Thanks goes to Roy Terry <royterry@earthlink.net> for his
	assistance with this.

2002-06-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	Implement TIP 98  [Tk patch 566765]

	* doc/FindPhoto.3, generic/tk.h, generic/tk.decls:
	* generic/tkImgPhoto.c: Changed *_Old to *_NoComposite and
	USE_OLD_PHOTO_PUT_BLOCK to USE_COMPOSITELESS_PHOTO_PUT_BLOCK
	following a suggestion from Don Porter.

	* tests/imgPhoto.test: Added tests of -compositingrule

	* doc/photo.n: Added documentation for "-compositingrule".
	* generic/tkImgPhoto.c (ImgPhotoCmd, ParseSubcommandOptions): New
	"-compositingrule" option for [$photo copy] subcommand, using
	OPT_COMPOSITE flag and compositingRule field in SubcommandOptions
	structure.

	* doc/FindPhoto.3: Documented the extra argument for the
	compositing rule and the action to take if anyone wants to
	maintain total backward-compatability.

	* generic/tk.h (TK_PHOTO_COMPOSITE_*): Defined values for use as
	compositing rules.
	(USE_OLD_PHOTO_PUT_BLOCK): Added a way for users to select the old
	interface to Tk_PhotoPutBlock to provide an easier upgrade path.

	* generic/tk.decls: Alter Tk_PhotoPut*Block to Tk_PhotoPut*Block_Old
	and introduce new slots for the old name of function with an extra
	argument at the end for the compositing rule.

	* generic/tkImgPhoto.c (ImgPhotoCmd): Updated "transparency set"
	subcommand to use TkSubtractRegion().

	* win/tkWinRegion.c (TkSubtractRegion):
	* mac/tkMacRegion.c (TkSubtractRegion):
	* generic/tkInt.decls (TkSubtractRegion):
	* unix/tkUnixPort.h (TkSubtractRegion): Added function to perform
	the set-difference operation on regions; it seems all platforms
	can support it, and it makes removing rectangular bits from
	regions much easier.

	* generic/tkImgPPM.c (FileReadPPM): Reading a PPM/PGM always uses
	the SET compositing rule because it is faster and the format does
	not have any transparency information.

	* generic/tkImgGIF.c (FileReadGIF): Reading a GIF always uses the
	SET compositing rule because GIF files model transparency as a
	single special colour.

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock):
	Added a compositing rule to allow better control over what happens
	to transparent pixels when inserting data into a photo image.

2002-06-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/winfo.test: Add basic tests for winfo ismapped.

2002-06-13  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/unixWm.test:
	* tests/wm.test: Move wm minsize and wm maxsize
	usage tests into the cross platform wm tests.

2002-06-13  Don Porter <dgp@users.sf.net>

	* tests/cursor.test:  corrected error after cursor-2.2.
	* tests/defs.tcl: Added enhancements to Tk's fake version of
	tcltest required by recent cursor.test changes.

2002-06-13  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/cursor.test (cursor-2.[34]): Tests added to ensure that
	cursor specs really are well-behaved lists.  Also some general
	clean-up...
	* win/tkWinCursor.c (TkGetCursorByName): Undone Jeff's back-off
	and fixed things so that they should work now.  Cursor specs are
	lists first and foremost.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Clearly label wm transient changes as
	a POTENTIAL INCOMPATIBILITY.
	* doc/wm.n: Remove "some window managers will" text
	and explicitly state what behavior a transient
	window will display. Also mention that it is an
	error to make a window a transient of itself.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::file::chooseDir):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog): Remove the
	transient property on dialogs after they have been
	dismissed to insulate them from further state changes
	in the master. This keeps a withdrawn dialog from
	being mapped when the master is deiconified. [Tk patch 568278]

2002-06-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinCursor.c (TkGetCursorByName): reverted fix from
	2002-06-06 because it broke the ability to use built-in cursors
	like left_ptr.

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/choosedir.tcl (tk::dialog::file::chooseDir):
	* library/clrpick.tcl (tk::dialog::color):
	* library/dialog.tcl (tk_dialog):
	* library/msgbox.tcl (tk::MessageBox):
	* library/tkfbox.tcl (tk::dialog::file):
	* library/xmfbox.tcl (tk::MotifFDialog_Create):
	Only make the dialog window a transient if
	the master is visible. This check already
	appeared in some of the dialogs. This patch
	just copies the check into those that were
	lacking. [Tk patch 568253]

2002-06-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Add note about new transient behavior.
	* tests/unixWm.test: Check that the WM_TRANSIENT_FOR
	property for a transient window is being cleared
	when the master is destroyed.
	* tests/wm.test: Source defs.tcl instead of using
	tcltest to match the rest of Tk's test files.
	Add new tests that ensure that a transient's state
	mirrors the state of the master.
	* unix/tkUnixWm.c (WmInfo, TkWmNewWindow, TkWmMapWindow)
	(TkWmDeadWindow, Tk_WmCmd, WmWaitMapProc): Add numTransients
	member to WmInfo structure. Keep state of master and
	transient in sync using a callback that tracks MapNotify
	and UnmapNotify events. When the master is mapped, map
	the transient. When the master is unmapped or iconified,
	withdraw the transient.
	* win/tkWinWm.c (TkWmMapWindow, TkpWmSetState)
	(TkWmDeadWindow, Tk_WmCmd, WmWaitVisibilityOrMapProc):
	Keep state of master and transient in sync using a
	callback that tracks MapNotify and UnmapNotify events.
	Move masterPtr check from TkpWmSetState into TkWmMapWindow
	to deal with WM_NEVER_MAPPED transients. Cleanup
	numTransients and the callback in TkWmDeadWindow.
	Cleanup numTransients and the callback only after
	deleting a master in wm transient command to avoid
	deleting the callback when an error is raised.
	Add support for MapNotify and UnmapNotify events
	to the master callback. [Tk patch 561708]

2002-06-11  Joe English  <jenglish@users.sf.net>

	* library/menu.tcl: fix for bug report #530212 "Bad Window Path
	Name in tkMenuFind"

2002-06-10  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Fixed a win98 issue where the /exclude option
	for xcopy is unsupported.
	Reported by Roy Terry <royterry@earthlink.net>.

2002-06-10  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/tk.tcl: added utility functions to get "-underline" and
	"-text" for labels and buttons from translatable string containing
	"magic ampersand" [patch #566605]
	* library/clrpick.tcl:
	* library/msgbox.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: some places where msgcat is used to get
	translated label are modified to handle labels with magic ampersand.
	* library/msgs/ru.msg: russian translations added
	* library/msgs/cs.msg:
	* library/msgs/de.msg:
	* library/msgs/el.msg:
	* library/msgs/es.msg:
	* library/msgs/fr.msg:
	* library/msgs/it.msg:
	* library/msgs/nl.msg: all translation files now have labels with
	'magic ampersand' where appropriate. In el.msg some ampersands are
	missing, as I don't know which underline positions seems natural
	to "el" users.

2002-06-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/bgerror.tcl (tk::dialog::error::bgerror):
	Don't set the bgerror dialog as a transient of
	itself since this operation is ill defined.

2002-06-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* win/tkWinCursor.c (TkGetCursorByName): Fixed so that the reading
	of cursors from a file with a cursor spec was built using [list]
	works when the file has a space in instead of requiring fiddling
	with backslashes.

2002-06-06  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* library/msgbox.tcl (MessageBox): Add -default normal
	when creating non-default buttons for message box.
	They already get -default normal when they're
	unfocused, and dialog window size used to change suddenly
	in such cases.

2002-06-05  Anton Kovalenko <a_kovalenko@users.sourceforge.net>

	* unix/tkUnixFont.c (Tk_DrawChars): Don't assume that
	one char is always one byte, and that required
	subfont for the last character in any string is
	the same as for the previous character
	[Bug #559435] [Patch #559437]

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* changes: Document [wm transient .t .t] error.
	* tests/wm.test: Check that setting a window
	as a transient of itself raises an error. Check
	that passing a non-toplevel window to the wm
	transient command uses the enclosing toplevel.
	* unix/tkUnixWm.c (Tk_WmCmd): Raise an error
	if the user tries to make a toplevel a
	transient of itself.
	* win/tkWinWm.c (Tk_WmCmd): Raise an error
	if the user tries to make a toplevel a
	transient of itself. Test for other error
	before checking for the transient self error.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tkUnixWm.c (WmInfo, TkWmCleanup, TkWmNewWindow)
	(TkWmMapWindow, TkWmDeadWindow, Tk_WmCmd): Replace
	WmInfo's master and masterWindowName members with
	a masterPtr member. This implementation is much
	simpler and mirrors the Win32 implementation. This
	change makes it easy to check the flags of the
	master window. No user visible changes.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tkInt.decls: Add unix decl for TkpWmSetState.
	* generic/tkIntPlatDecls.h: Regen.
	* generic/tkStubInit.c: Regen.
	* tests/wm.test: Test state changes between iconic,
	normal, and withdrawn both before and after initial
	mapping.
	* unix/tkUnixWm.c (Tk_WmCmd, TkpWmSetState): Move
	state change code into TkpWmSetState to more closely
	match the Win32 implementation. No user visible changes.

2002-05-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/embed.test: Added cross platform embed tests.
	Check that window passed to -use has the -container
	option set.
	* tests/wm.test: Remove useless catch call. Deiconify
	. just in case, stackorder tests will not pass unless
	it is in the normal state. Add -container flag to
	embedded stackorder test.
	* unix/tkUnixEmbed.c (TkpUseWindow):
	* win/tkWinEmbed.c (TkpUseWindow): Lookup Tk window
	based on the id passed in as the value for -use.
	Generate an error if the Tk window did not have
	the -container option set.

2002-05-26  Peter Spjuth <peter.spjuth@space.se>

	* generic/tkButton.c (ConfigureButton): When creating
	a radiobutton with -value "" it was not drawn properly
	if the -variable was created by the radiobutton.
	[Bug #548765]

2002-05-26  Peter Spjuth <peter.spjuth@space.se>

	* generic/tkCanvText.c (ComputeTextBbox): Negative
	coordinates were rounded badly causing a 1 pixel
	displacement. [Bug #556526]

2002-05-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* mac/tkMacWm.c (Tk_WmCmd):
	* tests/unixWm.test: Move wm transient checks over
	to wm.test so they will be run on all systems.
	* tests/wm.test: Add tests to check for error when
	an iconwindow is passed to the wm transient command.
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinWm.c (Tk_WmCmd): Raise an error if one
	of the windows passed to the wm transient command
	is an iconwindow for another toplevel.

2002-05-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* mac/tkMacWm.c (TkWmStackorderToplevelWrapperMap):
	* tests/wm.test: Add embedded Window test case for
	the stackorder command.
	* unix/tkUnixWm.c (TkWmStackorderToplevelWrapperMap):
	* win/tkWinWm.c (TkWmStackorderToplevelWrapperMap):
	Ignore embedded windows during wm stackorder command.

2002-05-21  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Invoke SC_ENABLE_SHARED before
	calling SC_CONFIG_CFLAGS so that the SHARED_BUILD
	variable can be checked inside SC_CONFIG_CFLAGS.
	* unix/tcl.m4: Update from Tcl.

2002-05-20  Don Porter  <dgp@users.sourceforge.net>

	* library/tk.tcl:  A little namespace cleanup on Daniel Steffen's
	latest revisions to avoid defining new global commands.

2002-05-20  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacInit.c:
	* mac/tkMacTclCode.r: include msgcat package in resources
	as bgerror depends on it. Restores ability of mac static
	build to run standalone (except for encoding file issues).

	* mac/tkMacInit.c:
	* library/console.tcl:
	* library/tk.tcl: fix tk.tcl not sourcing library files
	that define bindings at startup on mac. (independent of
	tk library files being in resources or on auto_path)

2002-05-08  Don Porter  <dgp@users.sourceforge.net>

	* library/bgerror.tcl:
	* library/tclIndex:  Cleaned up namespace usage of the bgerror
	dialog.  Completes soft dependence on msgcat.  [FR 539309]

2002-05-07  David Gravereaux  <davygrvy@pobox.com>
	* win/makefile.vc: Problem with TCLDIR macro not accepting
	forward slash path seperators resolved.  Added the same logic
	to INSTALLDIR, too. [Bug #553208]

2002-04-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: change HP-11 SHLIB_LD_LIBS from "" to ${LIBS} so
	that the .sl knows its dependent libs.

2002-04-24  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacTclCode.r:
	* mac/tkMacResource.r: added check of
	TCLTK_NO_LIBRARY_TEXT_RESOURCES #define to allow disabling the
	inclusion of the tk library code in the resource fork of Tk
	executables and shared libraries.
	Moved tk library code inclusion to separate file like in tcl.
	Added 'panedwindow' resource.

2002-04-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl (ButtonLeave): corrected the 3
	implementations of ButtonLeave to check for Priv(relief) existing
	before trying to use it. [Patch #541849]

	* generic/tkTextDisp.c (DisplayLineBackground):
	* unix/tkUnix3d.c (Tk_3DHorizontalBevel):
	* unix/tkUnixFont.c (Tk_DrawChars): applied fixes to not overrun
	the X window 16-bit size limit. [Patch #541999] (bonfield)

2002-04-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkTextDisp.c (GetXView, GetYView): Comparison with
	previous values of scrollbar range are now done in a way that is
	sensitive to the bizarreness of floating-point on architectures
	where IEEE-FP is not used on the processor.  Also increased the
	size of the temporary buffer to take account of the fact that
	TCL_DOUBLE_SPACE is meant to only imply enough space to take a
	printed double and trailing '\0', and no more.  [Bug #223739]
	(FP_EQUAL_SCALE): New macro to help compare floating-point numbers
	for equality in a sane way, used in GetXView and GetYView.

2002-04-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (TkCloseDisplay): Added to centralize where a
	display was closed.  This handles freeing memory associated with a
	display and closing it.
	(DeleteWindowsExitProc): actually close displays.  This would also
	ideally be done in Tk_DestroyWindow when the last window on the
	display has been closed, but that still has unresolved order of
	cleanup problems.
	(Tk_DestroyWindow): added TkFocusFree call.

	* generic/tkStubInit.c:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkInt.decls: added TkFocusFree, TkClipCleanup and
	TkGCCleanup generic private procs, and TkWmCleanup, TkSendCleanup
	and TkFreeXId unix private procs.

	* generic/tkInt.h:
	* unix/tkUnixXId.c (TkFreeXId): frees XID resources.
	Made idCleanupScheduled a Tcl_TimerToken (was int) in TkDisplay
	structure to allow us to delete the timer scheduled for it.

	* unix/tkUnixWm.c (TkWmStackorderToplevel): ensure children
	structure is freed.
	(ConfigureEvent, ComputeReparentGeometry): Add extra wm tracing info
	(TkWmRestackToplevel): initialize changes to 0 to prevent UMR.
	Use WaitForConfigureNotify on all windows.  This part still
	requires fixing as it is the root of the 2 second raise delay on
	some window managers (those that use extra wrapper windows of
	their own).

	* unix/tkUnixSend.c (TkSendCleanup): free send-related resources

	* unix/tkUnixEvent.c (TkpCloseDisplay): call TkSendCleanup and
	TkWmCleanup.

	* unix/tkUnixSelect.c (SelRcvIncrProc): added missing Tcl_Release
	of interp

	* generic/tkGet.c (FreeUidThreadExitProc): free thread-specific
	resources on thread exit

	* generic/tkFocus.c (TkFocusFree): frees TkMainInfo data
	* generic/tkClipboard.c (TkClipCleanup): frees TkDisplay data
	* generic/tkGC.c (TkGCCleanup): frees TkDisplay data

	* unix/tkUnixFont.c (FontPkgCleanup): cleanup thread specific font
	resources on thread exit.

	* mac/tkMacXStubs.c (TkpOpenDisplay): memset the initial display
	structures to 0.

	* generic/tkOption.c (OptionThreadExitProc): freed tsd option
	stacks on thread exit.
	(Tk_GetOption): free mem used to get Tk_Uid

	* generic/tkMenu.c (ConfigureMenu): freed saved options in all
	error cases.

	* win/tkWinInt.h: declaration for TkWinGetUnicodeEncoding
	* win/tkWinDialog.c (GetFileNameW): use TkWinGetUnicodeEncoding
	* win/tkWinInit.c (TkpDisplayWarning): use TkWinGetUnicodeEncoding
	* win/tkWinFont.c: use TkWinGetUnicodeEncoding instead of static
	unicodeEncoding.

	* win/tkWinX.c (Tk_SetCaretPos): remove WM_IME_STARTCOMPOSITION
	and place the IME position within Tk_SetCaretPos.  Cache results in
	Tk_SetCaretPos to reduce unnecessary repositioning.  Also call
	DestroyCaret if we receive WM_KILLFOCUS.
	(TkpOpenDisplay): ZeroMemory the initial display structures.
	(TkWinGetUnicodeEncoding): Added so that Windows only needs to
	cache this value one, and then free it in TkWinXCleanup.
	(HandleIMEComposition): add support for Win98 and ATOK13
	IME. (yamamoto)

	* generic/tkConsole.c (ConsoleCmd): correct return that should
	have just set result code.

	* generic/tkImgPhoto.c: Added PhotoFormatThreadExitProc to clean
	up on thread exit. (Tk_PhotoPutBlock) slight code updates

	* generic/tkPanedWindow.c (DestroyPanedWindow, ConfigureSlaves):
	fix mem leaks in not freeing slave info

	* win/configure:
	* win/tcl.m4: Enabled COFF as well as CV style debug info with
	--enable-symbols to allow Dr. Watson users to see function info.
	More info on debugging levels can be obtained at:
	http://msdn.microsoft.com/library/en-us/dnvc60/html/gendepdebug.asp

2002-04-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* doc/wm.n:
	* mac/tkMacWm.c:
	* tests/wm.test:
	* unix/tkUnixWm.c:
	* win/tkWinWm.c: Update wm stackorder usage message
	to make it clear that either 1 or 3 arguments are
	required. [Bug 540013]

2002-04-08  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacProjects.sea.hqx: added tkPanedWindow.c to projects
	* mac/tkMacAppInit.c: fixes to MSL stdin/stdout hookup to the
	TkConsole when using shared MSL libraries; fix for crashing
	bug on exit: writing to stdin/sterr when console has already
	been destroyed. (both fixes need support in MSL, see
	'CW Pro6 changes' in tcl/mac/tcltkMacBuildSupport.sea.hqx)
	* mac/tkMacDialog.c: fixes to Navigation Services Dialog filter.
	* mac/tkMacDraw.c: add panic for overwide TkImages that would
	crash Tk on mac otherwise.

2002-04-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* mac/tkMacXStubs.c: added Tk_SetCaretPos stub (does nothing).
	* win/tkWinX.c: added Tk_SetCaretPos code to position IME windows
	correctly when WM_IME_STARTCOMPOSITION is received.
	* unix/tkUnixKey.c: added Tk_SetCaretPos and code for setting
	XIM caret in TkpGetString.

	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: added Tk_SetCaretPos declaration.  This command
	allows users to indicate the cursor position and is used by XIM
	(Unix) or IME (Windows) to place the caret box correctly.  It is
	also part of correct Accessibility style on Windows to make the
	magnifier jump to the focus point.

	* win/tkWinButton.c (TkpDisplayButton):
	* generic/tkTextMark.c (TkTextInsertDisplayProc):
	* generic/tkCanvText.c (DisplayCanvText):
	* generic/tkEntry.c (DisplayEntry): added Tk_SetCaretPos calls

	* generic/tkInt.h: added TK_XIM_SPOT #define (default 1).
	Added XFontSet attribute to TkDisplay when TK_XIM_SPOT is true.
	* generic/tkEvent.c (Tk_HandleEvent): made sure inputContexts are
	not getting created on DestroyNotify events (for dead windows).
	Added over-the-spot support if TK_XIM_SPOT is defined (default).
	The is the nicer XIM behavior, but uses a bit more memory.

	* unix/tkUnixEvent.c:
	* generic/tkWindow.c: moved OpenIM over to tkUnixEvent.c.
	Removed setting inputContext to null in Tk_MakeWindowExist as it
	was redundant.

	* unix/tkUnixWm.c (CreateWrapper): Removed redundat setting of
	inputContext to null.

	* win/Makefile.in: changed gdb and shell targets to properly build
	all binaries before running (otherwise an error often occured).

2002-03-28  David Gravereaux <davygrvy@pobox.com>

	* win/.cvsignore (new):
	* win/lamp.bmp (new):
	* win/makefile.vc:
	* win/nmakehlp.c (new):
	* win/rules.vc:  Brought the makefile up-to-date with Tcl's one.
	This now has support for Win9x issues and the winhelp target now
	exists.  Color scheme can be changed.  I'm just imparting a first
	suggestion using orange :)  I'll have to think about the install
	portion of the helpfile as I'll need to do some tricks to insert
	tk's contents file into Tcl's using some special winhlp32.exe
	switches.  [Bug 533862 527941]

	* win/makefile.vc:  Tk helpfile is now installing itself into Tcl's
	contents file as part of the install target and rebuilding the
	contents table as desired.  [Bug 527941]

	* doc/console.n:  Changed topic from "Tcl Built-In Commands" to
	"Tk Built-In Commands"

	* win/buildall.vc.bat:  Update to match Tcl.

2002-03-26  Andreas Kupries  <andreask_kupries@users.sourceforge.net>

	* unix/tkUnixFont.c: Added inclusion of <arpa/inet.h>. This fixes
	a GCC/HPUX problem with missing a "htons". See also
	"tclUnixPort.h" for equivalent code.

2002-03-21  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Changed optimize flag to -0ti instead of -02.
	[Bug 528441]

2002-03-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkButton.c (ButtonTextVarProc,ButtonVarProc):
	* generic/tkCmds.c (WaitVariableProc):
	* generic/tkEntry.c (EntryTextVarProc):
	* generic/tkListbox.c (ListboxListVarProc):
	* generic/tkMenu.c (MenuVarProc):
	* generic/tkMenubutton.c (MenuButtonTextVarProc):
	* generic/tkMessage.c (MessageTextVarProc):
	* generic/tkScale.c (ScaleVarProc): Updates to handle change in
	type of part2 argument of Tcl_VarTraceProc typedef. [TIP 27]
	[Patch 532644].

2002-03-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkOldConfig.c (Tk_ConfigureValue): prevent leaving
	interp->result as NULL.

2002-03-07  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/text.tcl (TextPasteSelection): Renaming of TextPaste to
	prevent confusion with tk_textPaste.  Stopped code from inserting
	selections twice, which seems to have happened with TIP#26, and
	reorganized code to reduce amount of stuff protected by catch
	which is tricky to maintain.
	(tk_textPaste): Reduce amount of code protected by catch.

2002-03-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinX.c: Define _WIN32_IE as 0x0300
	before including commctrl.h so that we can
	access the InitCommonControlsEx API when
	building Tk with mingw.

2002-03-06  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* README, generic/tk.h, unix/configure.in, unix/tk.spec:
	* win/configure.in: Bumped patchlevel; this might need to change
	in the future, but it will help us distinguish between the CVS
	version and the most recent released version.

2002-03-05  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4a4 TAGGED FOR RELEASE ***

	* unix/README: updated --* options docs.

	* unix/tk.spec: fixed URL refs to use www.tcl.tk or SF.

2002-03-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:
	* mac/README:
	* unix/README:
	* win/README: updated to use www.tcl.tk URL.

2002-03-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/entry.tcl: added catch around Triple-1 binding use of
	sel.last

2002-02-28  Don Porter  <dgp@users.sourceforge.net>

	* library/console.tcl (ConsoleBind): Corrected console <<Paste>>
	binding on Unix platforms.

2002-02-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

	* generic/tkWindow.c (Tk_MainWindow, Tk_GetNumMainWindows):
	protect against being called before Tcl stubs are init'ed.
	[Bug #220916] (porter)

2002-02-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (ConfigureText): reenable the blinking cursor
	on state change where necessary. [Bug #503772]

	* tests/listbox.test:
	* generic/tkListbox.c: corrected error handling when setting to an
	invalid listvar value. [Bug #503613]

	* library/scale.tcl: mirror B2 bindings to B3 on Windows to better
	accomodate two button mice. [Patch #493145]

	* library/panedwindow.tcl: improved proxy sash handling. (boudaillier)

2002-02-25  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/filebox.test: Reorganised and fixed so that tests are
	executed fewer times (!) and the automatic extension adding
	behaviour of tk_getSaveFile is tested.

2002-02-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2002-02-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkPanedWindow.c (PanedWindowWidgetObjCmd): fixed returns
	that should have been breaks instead.  Corrected .pw configure
	handling for insufficient args.  [Patch #521436] (boudaillier)

	* mac/tkMacDefault.h:
	* unix/tkUnixDefault.h:
	* win/tkWinDefault.h: changed panedwindow default relief to flat,
	a more natural outer relief.

	* library/panedwindow.tcl (ReleaseSash): changed to not pass x and
	y args at all (they aren't used).
	Added proc comments.  Made configuring sash cursor more efficient.
	Added Cursor timer that restores the default cursor when pointer
	is no longer over the sash.  This is necessary because Leave
	events won't be seen when moving into a paned child.

2002-02-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/widget: New section "Paned Windows"
	* library/demos/paned2.tcl, library/demos/paned1.tcl: New files.

	* library/panedwindow.tcl (ReleaseSash): Added missing arguments.
	* library/tk.tcl: Bindings for paned window were not being loaded
	by default.

	* unix/tkUnixMenu.c (GetMenuLabelGeometry,DrawMenuEntryLabel):
	Stop meaningless GCC warnings.

2002-02-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/panedwindow.n (new):
	* generic/tkPanedWindow.c (new):
	* generic/tkInt.h:
	* generic/tkWindow.c:
	* library/panedwindow.tcl (new):
	* mac/tkMacDefault.h:
	* tests/panedwindow.test (new):
	* unix/Makefile.in:
	* unix/tkUnixDefault.h:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/tkWinDefault.h: added implementation of TIP #41, panedwindow
	widget. [Patch #512503] (melski)

	* generic/tkOption.c (ReadOptionFile): fixed Tcl_Seek casting to
	remove warnings (we expect no option files with be > 2GB).

	* unix/configure: regenerated
	* unix/tcl.m4: updated to sync with Tcl's tcl.m4
	Added --enable-64bit support for AIX-4 using IBM's xlc (-q64 flag).

2002-02-19  Don Porter  <dgp@users.sourceforge.net>

	* changes: First draft of updated changes for 8.4a4 release.

2002-02-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImgPhoto.c (MatchFileFormat):  Tcl_Seek takes
	Tcl_WideInt offset (three places.)
	* generic/tkImgPPM.c (FileReadPPM): Tcl_Seek takes Tcl_WideInt offset.
	* generic/tkFrame.c (ConfigureFrame): Stop GCC warning.

	* generic/tkImgGIF.c: Made file meet the formatting rules from the
	Tcl Engineering Manual better; mostly differences in whitespace.

2002-02-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: regen'd
	* unix/tcl.m4:
	* unix/configure.in: added macros and calls to SC_TCL_EARLY_FLAGS
	and SC_TCL_64BIT_FLAGS, part of TIP #72.

2002-02-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* library/entry.tcl:
	* library/text.tcl: Adjust <Double-1> and <Triple-1> bindings
	so that no anchor point is set and the insertion cursor is
	set to the last character in the selection. [Bug 220943]
	* tests/event.test: Add test cases for double click and
	drag as well as triple click and drag in the text and
	entry widgets.

2002-02-14  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/event.test (_text_ind_to_x_y, _get_selection): Fix
	incorrect use of results from bbox invocation so that
	y center point for a give index is calculated correctly.
	Add new method to return the selection and use it in
	test cases. Always lappend to the result list to avoid
	case where initial result includes a space.

2002-02-07  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c:
	* mac/tkMacInit.c:
	* mac/tkMacKeyboard.c:
	* win/tkWinDialog.c:
	* win/tkWinTest.c: modified some callers of Tcl routines that
	were restored to return (char *) pointing into Tcl_DStrings.

2002-02-03  eric melski  <ericm@interwoven.com>

	* generic/tkImage.c (Tk_ImageObjCmd): Clean up bogus for loop in
	[image inuse] subcommand [Bug #485803].

2002-02-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkCmds.c (Tk_TkObjCmd): don't use 'bool' as an arg as it
	conflicts with the C99 spec. [Bug #511956] (ingham)

2002-02-01  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: unset macro located in the tktest target
	caused a failure to build.  [Bug 511652]

2002-01-30  Don Porter  <dgp@users.sourceforge.net>

	* win/stubs.c (XSetCommand):  Overlooked CONSTification.

2002-02-01  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/photo.n: Documented transparency subcommand.
	* tests/imgPhoto.test (imgPhoto-4.40...imgPhoto-4.68): Tests for
	the transparency subcommand.
	* generic/tkImgPhoto.c (ImgPhotoCmd): Added transparency
	subcommand (see TIP #14.)

2002-01-31  Todd Helfter <tmh@users.sourceforge.net>
	* generic/tkMenu.c (ConfigureMenuCloneEntries)
	* tests/menu.test (menu3.68)
	Correct and test for logic error when cloning menus. [Bug #508988]

2002-01-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.decls:  The POTENTIAL INCOMPATIBILITY in the changing
	interface of Tk_ParseArgv can now be removed by the -DUSE_NON_CONST
	compiler flag.
	* generic/tkDecls.h: make genstubs

2002-01-29  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* win/tkWinInit.c (TkpGetAppName): TIP 27 fixup. The code now does
	not write into the CONST path returned by "argv0" and
	Tcl_SplitPath anymore.

2002-01-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Don't set TCL_LIB_SPEC and
	TCL_STUB_LIB_SPEC variables since this breaks
	the AIX build. This was used in the past to
	support linking with Tcl from the build dir
	or the install dir, but it is no longer needed.

2002-01-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Remove commented out vars.
	* unix/configure: Regen.
	* unix/configure.in: Don't subst vars that are already
	taken care of in SC_LOAD_TCLCONFIG.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-01-27  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkFileFilter.c:
	* mac/tkMacInit.c:
	* mac/tkMacKeyboard.c:
	* mac/tkMacMenus.c: TIP 27 CONSTification induced changes

2002-01-25  Don Porter  <dgp@users.sourceforge.net>

	* All changes below are Patch 505159

	* doc/AddOption.3:
	* doc/CanvTkWin.3:
	* doc/GetPixels.3:
	* doc/Name.3:
	* doc/ParseArgv.3:
	* generic/tk.decls (Tk_AddOption,Tk_CanvasGetCoord,Tk_GetPixels)
	(Tk_GetScreenMM,Tk_NameToWindow,Tk_ParseArgv):
	* generic/tkArgv.c (Tk_ParseArgv):
	* generic/tkCanvLine.c (ParseArrowShape):
	* generic/tkCanvUtil.c (Tk_CanvasGetCoord,Tk_CanvasTagsParseProc)
	(Tk_CanvasTagsPrintProc,Tk_GetDash):
	* generic/tkCanvas.c (ConfigureCanvas):
	* generic/tkGet.c (Tk_GetPixels,Tk_GetScreenMM):
	* generic/tkImgPhoto.c (ImgPhotoCmd):
	* generic/tkMain.c (Tk_MainEx):
	* generic/tkOldConfig.c (FormatConfigInfo):
	* generic/tkOption.c (Tk_AddOption):
	* generic/tkText.c (TextWidgetCmd,TkTextGetTabs,DumpSegment):
	* generic/tkText.h (TkTextCreateTag):
	* generic/tkTextTag.c (TkTextCreateTag):
	* generic/tkWindow.c (Tk_NameToWindow,Initialize):
	* mac/tkMacCursor.c (FindCursorByName,TkGetCursorByName):
	* mac/tkMacWm.c (Tk_WmCmd):
	* unix/tkUnixCursor.c (TkGetCursorByName):
	* unix/tkUnixSend.c (ValidateName):
	* unix/tkUnixWm.c (Tk_WmCmd):
	* win/tkWinCursor.c (TkGetCursorByName):
	* win/tkWinWm.c (Tk_WmCmd): Updated callers of Tcl_SplitList and
	Tcl_Merge.
	* generic/tkDecls.h: make genstubs
	***POTENTIAL INCOMPATIBILITY***
	Includes a source incompatibility in the argv argument of Tcl_ParseArgv.

	* generic/tkBind.c (DeleteVirtualEvent):
	* generic/tkCanvas.c (ScrollFractions, CanvasWidgetCmd)
	(CanvasUpdateScrollbars):
	* generic/tkTestTag.c (TkTextTagCmd): Updated callers of
	Tcl_GetStringResult.  Rewrote PrintScrollFractions to
	ScrollFractions to stop scribbling directly on interp->result.

	* generic/tkInt.decls (TkGetDefaultScreenName, TkpDisplayWarning)
	(TkpOpenDisplay):
	* generic/tkCanvPs.c (Tk_PostscriptColor, Tk_PostscriptFont):
	* generic/tkEntry.c (EntrySetValue, EntryValidateChange)
	(ExpandPercents, EntryValueChanged, Tk_EntryObjCmd, DestroyEntry)
	(ConfigureEntry, EntryComputeGeometry, InsertChars, DeleteChars)
	(EntryFetchSelection, EntryTextVarProc, Tk_SpinBoxObjCmd)
	(SpinboxWidgetObjCmd):
	* generic/tkMain.c (Prompt):
	* generic/tkMenu.c (MenuVarProc):
	* generic/tkMenubutton.c (ConfigureMenuButton, MenuButtonTextVarProc):
	* generic/tkMessage.c (ConfigureMessage, MessageTextVarProc):
	* generic/tkWindow.c (GetScreen, Initialize):
	* mac/tkMacInit.c (TkpInit, TkpDisplayWarning):
	* mac/tkMacXStubs.c (TkGetDefaultScreenName, TkpOpenDisplay):
	* unix/tkUnix.c (TkGetDefaultScreenName):
	* unix/tkUnixEvent.c (TkpOpenDisplay):
	* unix/tkUnixInit.c (TkpGetAppName, TkpDisplayWarning):
	* unix/tkUnixSend.c (SendEventProc):
	* win/tkWinInit.c (TkpGetAppName, TkpDisplayWarning):
	* win/tkWinX.c (TkGetDefaultScreenName,TkpOpenDisplay): Updated
	callers of Tcl_GetVar, Tcl_GetVar2
	* generic/tkIntDecls.h: make genstubs

	* generic/tkCanvPs.c (TkCanvPostscriptCmd):
	* generic/tkImgBmap.c (TkGetBitmapData):
	* generic/tkOption.c (ReadOptionFile):
	* mac/tkMacInit.c (TkpInit, TkpGetAppName):
	* win/tkWinInit.c (TkpGetAppName): Updated callers of
	Tcl_SplitPath, Tcl_JoinPath, and Tcl_TranslateFileName.

2002-01-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Rewrite stackorder tests that
	deal with toplevels that have the overrideredirect
	flag set. [Tk bug 492259]

2002-01-18  Don Porter  <dgp@users.sourceforge.net>

	* win/tkWinDialog.c: Overlooked Tcl_GetIndexFromObj callers.

2001-01-18  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tkMacDialog.c:
	* mac/tkMacSend.c: TIP 27 CONSTification broke the mac
	build in a few places.

2002-01-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkListbox.c (ChangeListboxOffset): improved tracking
	when scrolling on x axis with entry/text.  [Bug #225025] (voskuil)

2002-01-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk3d.c (Tk_GetReliefFromObj):
	* generic/tkBind.c (Tk_EventObjCmd, HandleEventGenerate):
	* generic/tkButton.c (ButtonWidgetObjCmd):
	* generic/tkCanvas.c (CanvasWidgetCmd, FindItems):
	* generic/tkClipboard.c (Tk_ClipboardObjCmd):
	* generic/tkCmds.c (Tk_BellObjCmd, Tk_TkObjCmd, Tk_TkwaitObjCmd)
	(Tk_UpdateObjCmd, Tk_WinfoObjCmd, Tk_WmObjCmd):
	* generic/tkConfig.c (DoObjConfig):
	* generic/tkEntry.c (EntryWidgetObjCmd, SpinboxWidgetObjCmd):
	* generic/tkFocus.c (Tk_FocusObjCmd):
	* generic/tkFont.c (Tk_FocusObjCmd, ConfigAttributesObj):
	* generic/tkFrame.c (Tk_FrameObjCmd):
	* generic/tkGet.c (Tk_GetAnchorFromObj, Tk_GetJustifyFromObj):
	* generic/tkGrab.c (Tk_GrabObjCmd):
	* generic/tkGrid.c (Tk_GridObjCmd, GridRowColumnConfigureCommand)
	(GridSlavesCommand, ConfigureSlaves):
	* generic/tkImage.c (Tk_ImageObjCmd):
	* generic/tkImgBmap.c (ImgBmapCmd):
	* generic/tkImgGIF.c (FileReadGIF):
	* generic/tkImgPhoto.c (ImgPhotoCmd):
	* generic/tkListbox.c (ListboxWidgetObjCmd, ListboxSelectionSubCmd)
	(GetListboxIndex):
	* generic/tkMenu.c (MenuWidgetObjCmd, MenuAddOrInsert, MenuCmd)
	(ConfigureMenu, CloneMenu):
	* generic/tkMenubutton.c (MenuButtonWidgetObjCmd):
	* generic/tkMessage.c (MessageWidgetObjCmd):
	* generic/tkOption.c (Tk_OptionObjCmd):
	* generic/tkPack.c (Tk_PackObjCmd, ConfigureSlaves):
	* generic/tkPlace.c (Tk_PlaceObjCmd):
	* generic/tkScale.c (ScaleWidgetObjCmd):
	* generic/tkSelect.c (Tk_SelectionObjCmd):
	* generic/tkSquare.c (SquareWidgetObjCmd):
	* generic/tkTest.c (TestobjconfigObjCmd, TrivialConfigObjCmd)
	(TestfontObjCmd): Updates to handle change in type of tablePtr
	argument of Tcl_GetIndexFromObj(Struct) from (char **) to
	(CONST char **).  [TIP 27] [Patch 504705]

	* generic/tkCanvText.c (GetSelText):
	* generic/tkEntry.c (Entry{FetchSelection,Setvalue},ExpandPercents):
	* generic/tkSelect.c (HandleTclCommand):
	* generic/tkText.c (TextSearchCmd):
	* generic/tkTextIndex.c (TkTextMakeByteIndex, TkTextIndexBackChars):
	* mac/tkMacFont.c (Tk_MeasureChars, BreakLine):
	* unix/tkUnixMenu.c (DrawMenuUnderline):
	* win/tkWinMenu.c (GetEntryText, DrawMenuUnderline):  Updated
	callers of Tcl_Utf* and Tcl_Regexp* APIs to reflect TIP 27 API
	changes (see Tcl Patch 471509). [Patch 471513]

2002-01-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2002-01-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c (Tk_MainEx):  Updated callers of CONSTified
	Tcl interfaces Tcl_EvalFile and TclGetStartupScriptFileName.

	* generic/tkConsole.c (ConsoleOutputProc, TkConsolePrint):
	* generic/tkInt.h (TkConsolePrint):
	* mac/tkMacAppInit.c (TkConsolePrint): Updated Tk's console to
	CONSTified channel driver interface.  [Tcl Patch 503565, Tk Patch
	503983]

2002-01-11  Mo DeJong  <mdejong@users.sourceforge.net>

	Use ${libdir} instead of ${exec_prefix}/lib. [Tcl bug 489370]

	* unix/configure: Regen.
	* unix/configure.in: Define and use libdir.
	* win/configure: Regen.
	* win/configure.in: Define libdir.

2002-01-11  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Burn Tcl and Tk build
	directories into tktest executable to avoid crashes
	caused by ld loading a previously installed version
	of the tcl or tk shared libraries. Remove setting
	of LD_LIBRARY_PATH, LIBPATH, and SHLIB_PATH
	before running tktest since it should no
	longer be required.

2002-01-11  Mo DeJong  <mdejong@users.sourceforge.net>

	Enable use of Tcl stubs when building Tk as
	a shared library. This should fix the build
	under AIX. [Bugs 220858, 220955, 220921]

	* unix/Makefile.in: Add TCL_STUB_LIB_SPEC and
	TCL_STUB_LIB_FLAG variables.
	* unix/configure: Regen.
	* unix/configure.in: Pass TCL_STUB_LIB_SPEC into
	Makefile and use it when linking the tk shared library.
	Define USE_TCL_STUBS when building shared. Subst
	TCL_STUB_LIB_SPEC and TCL_STUB_LIB_FLAG.

2002-01-08  D. Richard Hipp  <drh@hwaci.com>

	* win/tkWinMenu.c: Fix the following bug: If you select an entry
	on a cascade menu then the next time the parent menu is posted, the
	cascade entry was active.  Also, if you traverse to a disabled entry
	using keystrokes and press ENTER on the disabled entry, then that
	entry appears active the next time the menu is posted.  The same
	patch fixes both problems.

2002-01-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkBind.c (TkBindFree):
	* generic/tkGrid.c (ResolveConstraints,CheckSlotData,DestroyGrid):
	* generic/tkSelect.c (Tk_DeleteSelHandler,TkSelDeadWindow): Replaced
	Tcl_Free calls with ckfree so that memory debugging is fully supported.

2001-12-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* test/winButton.test:
	* win/tkWinButton.c: added updated patch #463234 which returns the
	default sizing behavior (not so native), but enables native L&F
	with negative sizing (-11 for example).

	* library/text.tcl (tk::TextButton1): made text receive focus even
	in disabled state for Windows to show selection and allow
	mouse-wheel scrolling.

	* win/tkWinInit.c (TkpDisplayWarning): added Tcl_DStringFree's

	* win/tkWinInt.h:
	* win/tkWinX.c: added TkWinProcs that represent a function table
	to switch between unicode and ansi procs on Windows.  This is
	analogous to the TclWinProcs.  Using Tcl_WinUtfToTChar, we can
	easily take advantage of using unicode functions where available
	without having to switch on the platform id each time.

	* win/tkWinWm.c (InitWindowClass): corrected init routines to
	allow unicode in window titles on Windows (for Win2K/XP).
	(TkWmStackorderToplevel): Corrected casts to enable debug compile

	* win/configure: regen'ed
	* win/tcl.m4: added shell32.lib to link libs, as these are
	necessary for new directory chooser (when enabled).

	* win/tkWinDialog.c (Tk_MessageBoxObjCmd): use MessageBoxW for
	proper display of unicode errors.
	Added patch which uses new OLE based directory chooser.  This
	still has some issues, so is disabled by default. [Patch #468139]
	(ColorDlgHookProc) Corrected ability to use unicode chars in
	tk_chooseColor -title.

2001-12-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinInit.c (TkpDisplayWarning): Use MessageBoxW in case the
	error displayed has unicode chars. [Bug #485986]

2001-12-27  Daniel Steffen <das@users.sourceforge.net>

	* mac/tkMacInit.c:
	* mac/tkMacResource.r: synced up tkInit features to unix/win:
	use existing tkInit proc if defined. Added spinbox.tcl resource.
	Used TclGetEnv() instead of Tcl_GetVar2(interp, env)
	* mac/tkMacApplication.r:
	* mac/tkMacLibrary.r: minor version resources cleanup

2001-12-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkButton.c (ButtonTextVarProc): guard against being
	called while the *button/label is being deleted. [Bug #490051]

	* library/entry.tcl:
	* library/spinbox.tcl:
	* library/text.tcl: added extra checks against bug #220269 and
	made spinbox reuse more of the entry procedure code.

2001-12-20  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2001-12-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2001-12-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Move EXP file changes over from
	Tcl configure script to fix AIX build with gcc. [Bug 220955]

2001-12-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	* win/Makefile.in: Use $(MAKE) instead of make
	in the tcltest rule.

2001-12-18  Don Porter  <dgp@users.sourceforge.net>

	* tests/event.test (event-click-drag-1.2): Corrected test that
	failed on Solaris/CDE due to text scrolling.  [Bug 413735]

2001-12-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/spinbox.tcl (ButtonDown): added catch to ignore
	possible error in after cancel when Priv(afterId) isn't defined.

	* doc/spinbox.n: corrected spin(up|down) -> button(up|down)

2001-12-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/getOpenFile.n: Documented change.
	* library/tkfbox.tcl (SetFilter): Added code to guess the correct
	default extension from whatever value was selected in the
	filetypes option menu.  Adapted from code by Chris Nelson
	submitted in Patch #492220.

2001-12-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixWm.c (TkWmStackorderToplevelWrapperMap): added static

2001-12-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c:
	* generic/tkText.h: changed TkTextEditType enums to be prefaced
	with TK_EDIT_ to prevent name collision.

2001-12-05  Daniel Steffen <das@users.sourceforge.net>

	* mac/tkMacWm.c: mac implementation of wm stackorder
	(patch 481148, TIP 74)

2001-12-03  Mo DeJong  <mdejong@users.sourceforge.net>

	Add TK patch 481148 to implement TIP 74, the
	wm stackorder command.

	* doc/winfo.n: Update documentation for the winfo
	children command to indicate that top-level windows
	are not returned in stacking order.
	* doc/wm.n: Add documentation for wm stackorder.
	* generic/tkInt.decls (TkWmStackorderToplevel):
	Add decl for new function.
	* generic/tkIntDecls.h: Regen.
	* generic/tkStubInit.c: Regen.
	* tests/unixWm.test: Add stackorder command to test
	for wm command usage message.
	* tests/wm.test: Add new set of tests for generic
	window manager methods.
	* unix/tkUnixWm.c (Tk_WmCmd, TkWmStackorderToplevelWrapperMap)
	(TkWmStackorderToplevel): Add unix implementation of
	new wm stackorder command.
	* win/tkWinWm.c (Tk_WmCmd, TkWmStackorderToplevelEnumProc)
	(TkWmStackorderToplevelWrapperMap, TkWmStackorderToplevel): Add
	windows implementation of new wm stackorder command.

2001-12-03  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: install target changes by request from
	Ryan Casey <scfiead@hotmail.com>.

2001-11-30  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/widget: Further overhauling; shrank fonts, made
	better use of fonts, added an icon, fixed the About box.  Prompted
	by Bug #487442 from Vincent Wartelle.

2001-11-29  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/palette.tcl (tk_setPalette): Added heuristic to guess
	from the background whether to use black or white for the
	foreground when not told specifically.  Suggested by Chris Nelson,
	this makes the command fit the documentation better!

2001-11-27  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: Fixed CAT32 target.  cat.c is located in the Tcl
	source, not the Tk source.

2001-11-27  D. Richard Hipp <drh@hwaci.com>

	* library/menu.tcl: Do not allow keyboard traversal of torn-off
	menus to visit the (invisible) tearoff bar.

2001-11-26  D. Richard Hipp <drh@hwaci.com>

	* win/tkWinMenu.c: disabled menu items show the activebackground
	color in their background.  This change makes menu behavior
	consistent with what native windows does.

2001-11-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in: Add comments to better describe
	TCL_EXE and when it should be available. Add
	rule that prints message about running `make genstubs`
	when tkStubInit.c is out of date.
	* win/Makefile.in: Add TCL_TOOL_DIR and TCL_EXE
	variables to better match the Tcl Makefile. Add
	genstubs rule so tkSTubInit.c can be regenerated.

2001-11-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Don't AC_SUBST CFLAGS_DEBUG, CFLAGS_OPTIMIZE,
	or CFLAGS_WARNING since it is now done in SC_CONFIG_CFLAGS.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): AC_SUBST DL_LIBS, CFLAGS_DEBUG,
	CFLAGS_OPTIMIZE, and CFLAGS_WARNING.

2001-11-23  Daniel Steffen <das@users.sourceforge.net>

	Up-port to 8.4 of mac code changes for 8.3.3 & various new
	changes for 8.4, some already backported to 8.3.4 (patch #435660)

	* library/tk.tcl: added <Key-F1> binding for <<Undo>> on the mac (TIP26)

	* library/button.tcl: fixed undefined $Priv(repeated) error for button
	without -repeatdelay support

	* generic/tkConsole.c:
	* library/console.tcl:
	* mac/tkMacInit.c:
	* mac/tkMacResource.r: corrected how mac deals with tcl library
	files present both in resources and in $tk_library directory.

	* generic/tkConsole.c: crashing bug fix when printing to console
	at program exit after the console has already been closed.
	Now setting gStdoutInterp=NULL in ConsoleClose().

	* mac/tkMacInit.c: correct use of Tcl_JoinPath in tk_library
	initialization

	* mac/tkMacMenu.c: special MDEF_PROC_OFFSET only needed for
	exactly one specific version of the MWERKS 68k compiler .

	* mac/tkMacShLib.exp: removed file

	* unix/Makefile.in: removed reference to .exp files

	* mac/MWTkBuildLibHeader.h:
	* mac/MW_TkBuildLibHeader.pch:
	* mac/MW_TkHeaderCommon.h:
	* mac/MW_TkOldImgStaticHeader.h:
	* mac/MW_TkStaticHeader.h:
	* mac/MW_TkStaticHeader.pch: new precompiled header files

	* mac/MW_TkHeader.pch:
	* mac/MW_TkOldImgHeader.h:
	* mac/MW_TkTestHeader.pch: revised precompiled header handling: now
	include a common header file 'MW_TkHeaderCommon.h' from all .pch files,
	the .pch files themselves now only setup #defines (e.g. BUILD_tk,
	STATIC_BUILD, TCL_DEBUG, TCL_THREADS) like in makefiles on other
	platforms.

	* mac/tkMac.h:
	* mac/tkMacPort.h:
	* mac/tkMacInt.h: use of BUILD_tk and TCL_STORAGE_CLASS like on other
	platforms, standardize #include'd files to what's done on other
	platforms, removed use of #pragma export, changed extern to EXTERN
	where appropriate to enable DLL export via the TCL_STORAGE_CLASS
	mechanism.

	* mac/tkMacAppearanceStubs.c: removed use of #pragma export

	* mac/widget.r: new resource file for 'Widget Demos'

	* mac/tkMacProjects.sea.hqx: updated mac build project files:
	build support for CodeWarrior Pro6, UnivIntf 3.4 & shared runtime
	libraries (see Tcl ChangeLog for details).
	changed weak linking so that CFM68k binaries now work on all OS
	versions from the free 7.5.5 onwards, with or without AppearanceMgr
	and/or NavigationMgr installed.
	added target to automatically build 'Widget Demos'
	included XML versions of the projects for CW Pro5 or Pro7 users.
	use compat/strtod.c instead of MSL's strtod()

	* generic/tkInt.decls:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkStubInit.c:

	* mac/tkMacInt.h: MAC_TCL tk stub support was badly broken due to
	multiply defined (mac specific) names in tk.decls and tkInt.decls,
	removed the duplicates from the internal unsupported interfaces
	"interface tkInt" and "interface tkIntPlat"; moved declaration of
	TkpIsWindowFloating from tkMacInt.h to tkInt.decls: interface tkIntPlat.
	- these changes to the stub tables might require you to recompile your
	Tk extensions if they turn out to reference one of the removed routines
	in the wrong table (should be unlikely).

	* generic/tkMain.c: MAC_TCL: workaround for broken/non-standard isatty
	on MW Pro6, #include <unistd.h> instead of defining isatty

	* generic/tkPointer.c: MAC_TCL: #include tkMacInt.h

	* generic/tkStubLib.c: MAC_TCL: removed obsolete special casing of mac
	headers, standardize #include'd files to what's done on other platforms

	* mac/tclets.r:
	* mac/tkMacWindowMgr.c:
	* mac/tkMacScrlbr.c:
	* mac/tkMacMenu.c:
	* mac/tkMacMenus.c:
	* mac/tkMacFont.c:
	* mac/tkMacDialog.c:
	* mac/tkMacButton.c: renamed obsolete apple API names to modern
	equivalents; UH3.4 support: added #include <ControlDefinitions.h>;
	fixed munged non-ASCII chars in sources due to bungled latin1<->mac
	roman encoding in CVS repository.

	* mac/tkMacDialog.c: added support for -filetypes option (fix for bug
	tcl #221636); added update event handling for background windows while
	in a NavigationMgr dialog; fixed nasty bug when calling CustomGetFile
	(missing addr operator) (fix for bug tk #220911 & tcl #219367); renamed
	routines conflicting with standard MoreFiles headers (see Tcl ChangeLog
	for details)

	* mac/tkMacApplication.r:
	* mac/tkMacLibrary.r:
	* mac/tkMacResource.r: fixed obsolete copyrights/dates in version
	strings, updated version strings to standard usage, added support for
	'(Support Libraries)' subfolder for shared runtime libraries in
	unmerged binaries, commented out demo setting of "Tcl Environment
	Variables"; reorganized resources among these files to avoid
	multiple copies in applications and shared libraries, the script
	libraries/Xcursors etc are now no longer duplicated in Wish but are
	only included in the resources of Tk.shlb.

	* mac/tkMacMenu.c:
	* mac/tkMacMDEF.r: changes to support MW Pro 6 68k (vers 0x2400 only)
	compiler producing different offset to start of MDEF; fix to static 68k
	presence testing when calling the custom MDEF

	* mac/tkMacWm.c.c:
	* mac/tkMacWindowMgr.c: added/fixed AppearanceMgr checks; override
	AppearanceMgr version detection on static 68k to ensure static 68k Wish
	runs on PPCs with recent AppearanceMgr

	* mac/tkMacButton.c: fixed misplaced/missing variable initialization.

2001-11-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (TextGetText): reworked to use DString for
	improved speed. (callewaert, darley)
	(DestroyText): plugged mem leak when not clearing stack (callewaert)
	(TextGetText): more efficient string size calculation (darley)

2001-11-19  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/entry3.tcl: New demo showing off validation and
	password entry.

	* library/demos/widget: Some reorganization to make the code
	simpler, plus a new entry demo.

2001-11-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinButton.c (TkpComputeButtonGeometry): corrected the
	default size of Windows buttons to conform to the Windows style.
	This changes the default size of buttons on Windows.
	[Patch #463234] (nelson)
	**** POTENTIAL VISUAL INCOMPATABILITY ****

2001-11-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/menu.tcl: corrected menu traversal code on Unix to
	better handle entering cascades.  [Patch #481219] (oleinick)

2001-11-16  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc:  Install target repaired.

2001-11-15  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/image2.tcl: Many improvements to this
	image-viewing demo; now uses labelframes and tk_chooseDirectory

	* library/palette.tcl (::tk::RecolorTree): Made this work better
	with CDE, which does some extremely annoying things with the
	option database that interact badly with Tk's way of handling
	options.

	* doc/text.n: Overhauled the documentation of undo to make it
	easier to understand.
	* library/tk.tcl (::tk::EventMotifBindings): Added Emacs-like undo
	binding, but not behaviour (we separate undo and redo.)
	* library/demos/text.tcl: Show off our undo capability!

2001-11-12  David Gravereaux <davygrvy@pobox.com>

	* win/mkd.bat:
	* win/rmd.bat:  Removed -kb CVS attribute and added changes
	from Llyod Lim for better stability.  [Patch #456761]

	* win/rules.vc(new):
	* win/buildall.vc.bat(new):
	* win/makefile.vc:  large rewrite following Tcl's makefile.vc as
	a guide and Patch #456761.  Appears BugFree(tm).

2001-11-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/text.n:
	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextTag.c:
	* library/text.tcl:
	* library/tk.tcl:
	* mac/tkMacDefault.h:
	* tests/text.test:
	* unix/tkUnixDefault.h:
	* win/tkWinDefault.h: added TIP #26 implementation of simple
	built-in undo/redo of text editing in the text widget.
	[Patch #458879] (callewaert)

2001-11-12  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/menu.tcl: Show off -compound support in menus.

	* library/demos/radio.tcl: Added some code to both show off the
	extra capabilities of the buttons and also show what can be done
	with compound images on the sly.

2001-11-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	* win/Makefile.in: Add "make gdb" target. This target
	can run wish inside either gdb or insight.

2001-11-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/clrpick.tcl: changed a few parameters so that the full
	0..255 range could be accessed via the mouse. [Bug #478498]

	* unix/configure:
	* unix/tcl.m4: added -lc to AIX libs, fixed path to ldAix

	* win/configure:
	* win/tcl.m4:
	* win/makefile.vc: add comctl32.lib to build libs.
	* win/tkWinX.c (TkWinXInit): added InitCommonControlsEx call.
	* win/rc/tk.rc:
	* win/rc/wish.rc:
	* win/rc/wish.exe.manifest: added resources that specify using v6
	of the MS Common Controls library when available (WinXP+).  This
	enables use of the themeable widgets (like scrollbars) to be used
	in Tk. [Patch #478933]

2001-11-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure:
	* unix/tcl.m4: Update from Tcl.

2001-11-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/Makefile.in:
	Avoid adding libc to the LIBS and WISH_LIBS
	variables since it is not needed when linking with CC.
	If required when linking with LD it should be done
	on a case by case basis in tcl.m4.

2001-11-05  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/dialog2.tcl: Typo-fix.
	* library/demos/browse, library/demos/ixset, library/demos/rolodex:
	Installation does version number fixup, so we shouldn't.  Thanks
	to wohnivec@iol.cz for pointing these (thankfully minor) problems
	out.

2001-10-30  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/widget: Integrated labelframe item into the labels
	section and added a spinbox demo to the (retitled) entry section.

	* library/demos/labelframe.tcl: Adjusted so as to show off the
	labelframe widget to better effect and have a better description.

	* library/demos/spin.tcl: New demo to show off spinbox capabilities.

	* library/demos/rolodex: Changes up-ported from core-8-3-1-branch
	to make the script use more 8.*-isms, but not menus due to the way
	the context help system works.

	* library/demos/ixset: Changed to use the labelframe widget and
	the grid geometry manager.

2001-10-29  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/browse: Changes up-ported from core-8-3-1-branch
	to make the script much more robust, particularly when neither the
	current version of wish or the script are on the path.

	* library/demos/hello: Added emacs trailing tag-line.

	* library/demos/tcolor: Changes up-ported from core-8-3-1-branch
	to make the script compliant with current good practise, as well
	as extensive use of the new labelframe widget.

	* library/demos/timer: Changes up-ported from core-8-3-1-branch to
	make the script look and work better.

	* library/demos/rmt: Changes up-ported from core-8-3-1-branch to
	use more 8.* features and make the demo script more generally
	useful to people.

2001-10-23  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkCursor.c (Tk_GetCursorFromData): Fixed uninit nextPtr
	field.  [adapted from Patch 473875]
	(GetCursor): Removed double-assignment to nextPtr field.

2001-10-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/console.tcl: removed transpose ability until the console
	can get a proper rewrite of tag handling.

2001-10-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/defs.tcl: removed threaded build warning under X.

	* library/console.tcl (ConsoleOutput): fixed undefined widget
	argument.

2001-10-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/xmfbox.tcl: fixed filtering in motif file dialog.
	[Patch #469670] (nelson)

	* generic/tkWindow.c (OpenIM): Added simple XIM patch to enable
	basic XIM input on Unix. [Patch #412727] (fabian)

2001-10-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/configure.in:
	* win/configure:
	* win/configure.in:
	* win/tkConfig.sh.in: reworked to be a little cleaner in
	comparison to each other, and to AC_SUBST even empty vars for
	win/tkConfig.sh

2001-10-12  Todd M. Helfter <tmh@purdue.edu>

	* ChangeLog:
	* doc/menu.n:
	* generic/tkMenu.c:
	* generic/tkMenu.h:
	* generic/tkMenubutton.c:
	* generic/tkMenubutton.h:
	* mac/tkMacDefault.h:
	* mac/tkMacMenu.c:
	* mac/tkMacMenubutton.c:
	* tests/menu.test:
	* unix/tkUnixDefault.h:
	* unix/tkUnixMenu.c:
	* win/makefile.vc:
	* win/tkWinDefault.h:
	* win/tkWinMenu.c:
	* win/tkWinWm.c: Implementation of TIP #63, the addition of
	a -compound option to menu entries allowing text and an image to
	be displayed at the same time.

2001-10-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/console.tcl: added more smarts extracted from tkcon to
	the default console.

2001-10-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinTest.c: better error reporting from testclipboard

	* win/tkWinDialog.c: minor cast changes to support Win64

	* win/tkWinWindow.c: made use of standard Tk_GetHWND instead of
	older, private TkWinGetHWND.

	* win/configure: regen'ed
	* win/tcl.m4:
	* win/makefile.vc: updated for Win64 SDK RC1 compilation support

2001-09-30  Peter Spjuth <peter.spjuth@space.se>

	* doc/grid.n:
	* generic/tkGrid.c:
	* tests/grid.test: Added -uniform option to grid's row/column-
	configure. [TIP 37] [Patch 459343]

2001-09-26  Peter Spjuth <peter.spjuth@space.se>

	* win/tkWinFont.c (Tk_DrawChars): Added support for clipping text.

	* doc/frame.n:
	* doc/labelframe.n:
	* doc/toplevel.n:
	* generic/tkFrame.c:
	* generic/tkInt.h:
	* generic/tkWindow.c:
	* library/demos/radio.tcl:
	* library/demos/labelframe.tcl:
	* library/demos/widget:
	* mac/tkMacDefault.h:
	* tests/frame.test:
	* unix/tkUnixDefault.h:
	* win/tkWinDefault.h: Added labelframe widget. Added -padx/y
	options to frame and toplevel.

	* tests/grid.test:
	* tests/pack.test:
	* tests/place.test: Used labelframe to test geometry manager changes.
	[TIP 18] [Patch 429164]

2001-09-26  Peter Spjuth <peter.spjuth@space.se>

	* doc/GeomReq.3:
	* doc/WindowId.3:
	* generic/tk.decls:
	* generic/tk.h:
	* generic/tkDecls.h:
	* generic/tkGeometry.c:
	* generic/tkGrid.c (ArrangeGrid):
	* generic/tkInt.h:
	* generic/tkPack.c (ArrangePacking):
	* generic/tkPlace.c (RecomputePlacement):
	* generic/tkStubInit.c:
	* generic/tkUtil.c (TkComputeAnchor):
	* generic/tkWindow.c (TkAllocWindow):
	* unix/mkLinks: Geometry manager changes to support TIP#18.
	Allows a widget to set different internal border widths on
	different sides, and to set a minimum requested size.
	POTENTIAL INCOMPATIBILITY.  [Patch 429164]

2001-09-25  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkBind.c:
	* generic/tkInt.decls (TkpScanWindowId):
	* unix/tkUnixPort.h (Tkp{Print,Scan}WindowId):
	* unix/tkUnixXId.c (TkpScanWindowId):
	* win/tkWinWindow.c (TkpScanWindowId): Corrected definition of
	TkpScanWindowId to handle situation where types Window and int
	do not have the same number of bits.  CONST-ified too.

	* generic/tkIntPlatDecls.h:
	* generic/tkStubInit.c: make genstubs

2001-09-24  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c (StdinProc): Update to handle change in
	return type of Tcl_DStringAppend() from (char *) to (CONST char *).
	[TIP 27]

2001-09-23  Peter Spjuth  <peter.spjuth@space.se>
	* generic/tkPack.c (ConfigureSlaves):
	* tests/pack.test:
	* tests/grid.test:  Pack accepted asymmetric values for -ipadx/y.
	Only -padx/y supports asymmetry. [Bug #462348]

2001-09-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWindow.c (TkpPrintWindowId, TkpScanWindowId): fixed to
	work on Win64 with 64bit XIDs.

	* generic/tkWindow.c (Tk_CreateAnonymousWindow):
	* generic/tkEntry.c (GetSpinboxElement): fixed unreachable returns.

	* win/tkWinX.c (TkGetServerInfo): added recognition of Win64.

	* xlib/X11/X.h: made XID __int64 type for Win64.

	* unix/tkUnixPort.h:
	* mac/tkMacPort.h: add (int*) cast to TkpScanWindowId.
	These may need to be changed to Window* (ulong).

	* generic/tkCmds.c (Tk_WinfoObjCmd):
	* generic/tkBind.c (NameToWindow):
	correct Window id's to be of type Window

	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkInt.decls (TkpScanWindowId): changed decl to use
	Window* instead of int*.

	* xlib/xcolors.c:
	* generic/tkPack.c,tkWindow.c:
	* win/tkWinFont.c,tkWinMenu.c:
	* unix/tkUnixScale.c: minor cast fixes to prevent 64bit warnings.

	* tests/scrollbar.test (scrollbar-6.27): marked knownBug because
	it is skewed by bad dimensions returned by Windows.

	* tests/textDisp.test (textDisp-4.12): corrected test to work
	properly on Windows.

	* tests/id.test,macFont.test,macMenu.test,macscrollbar.test:
	* tests/send.test,winClipboard.test,winDialog.test,winFont.test:
	improved use of test constraints

	* win/tkWinWm.c (WinSetIcon): fixed SetClassLong for 64bit support.

2001-09-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure: regen'ed
	* unix/tcl.m4: added --enable-64bit support for HP-11 with the
	64-bit kernel.

2001-09-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkGrid.c (ConfigureSlaves):
	* generic/tkPack.c (PackAfter):  Corrected type definition of
	argument passed to Tcl_GetStringFromObj() from size_t to int.
	Incorrect type broke [pack] and [grid] on systems where
	sizeof(size_t) != sizeof(int).  [Bugs 462375, 462342, 462338]

2001-09-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/choosedir.tcl (DblClick):
	* library/tkfbox.tcl (OkCmd, ListInvoke): Rewrote so as to avoid
	the highly confusing string "text" and to be consistent about what
	is and what is not a list.  [Bug 459895, reported by fandom]

2001-09-14  Andreas Kupries  <andreas_kupries@users.sourceforge.net>

	* generic/tkImgGIF.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c:
	* generic/tkMenu.c: Applied patch [461578], provided by Vincent
	Darley. This fixes several memory leaks in the image code. They
	happen if there are errors during the initialization of the
	channel the image is supposed to be read from.

2001-09-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure:
	* unix/tcl.m4: Update from Tcl.

2001-09-12  D. Richard Hipp  <drh@hwaci.com>

	* library/tkfbox.tcl: fixed error that appeared when you would
	click on the canvas while viewing an empty directory.

2001-09-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure:
	* unix/tcl.m4: Update from Tcl.

2001-09-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/Makefile.in: Fix Windows Makefile so that
	tcltest will automatically be compiled if the
	user tries to build tktest.

2001-09-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/Makefile.in: Use TKTEST variable directly
	instead of depending on the tktest alias.

2001-09-08  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/mkd.bat:
	* win/rmd.bat:
	Apply binary property (cvs admin -kb) to files and convert
	to CRLF linefeed format to fix the VC++ build. [Tcl Bug #219409]

2001-08-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/menu.test:
	* tests/send.test:
	* tests/select.test: corrected to use testConfig constraints in
	the TK_ALT_DISPLAY case

	* tests/unixSend.test: removed test file completely identical to
	send.test.  Removed platform specific named file in case somebody
	gets send working on Win/Mac in the future.

	* tests/config.test: added config-14.1 to test namespace import
	evaluation of widgets.
	* generic/tkButton.c (ButtonCreate):
	* generic/tkFrame.c (CreateFrame):
	* generic/tkMenubutton.c (Tk_MenubuttonObjCmd):
	* generic/tkPlace.c (Tk_PlaceObjCmd):
	* generic/tkScale.c (Tk_ScaleObjCmd):
	* generic/tkMessage.c (Tk_MessageObjCmd):
	* generic/tkEntry.c (Tk_EntryObjCmd, Tk_SpinboxObjCmd):
	* generic/tkSquare.c (SquareObjCmd): redid the handling of
	optionTables in widgets to allow them to be imported into other
	namespaces. [Bug #456632]

2001-08-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (ChooseDirectoryHookProc): work-around for MS
	bug that caused crashing in tk_chooseDirectory on Win95.
	[Bug #224936] (baker)

	* unix/tkUnixWm.c (TkWmRestackToplevel): reworked how
	ConfigureNotify requests were handled in relation to the parent to
	avoid the problem with potential 'raise' delays on some wms.
	[Bug #220260] (baker) wms that were affected should notice the
	difference in tests unixWm-51.* not failing that failed before.

2001-08-26  Don Porter  <dgp@users.sourceforge.net>

	* library/text.tcl (<Shift-Up> binding):  Corrected TIP 44 typo
	that broke binding.  Thanks to "Michal" for the fix.
	[Bug 455468]

2001-08-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: added QNX-6 build support. [Bug #219410] (loverso)

	* doc/CrtPhImgFmt.3: removed bogus note about including tkPhoto.h

2001-08-22  Peter Spjuth  <peter.spjuth@space.se>

	* generics/tkGrid.c (ConfigureSlaves):
	* tests/grid.test: Fixed a bug where adjacent 'x' and '^' where
	not handled properly. [Bug #452040]

2001-08-22  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkPack.c (TkParsePadAmount): added lint init for sepChar.

	* tests/dialog.test (HitReturn): fixed failing dialog-2.1 test
	because it wasn't always getting focus properly.

2001-08-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/unixFont.test (unixFont-2.[234]): fixed to be more
	sensitive on systems that have more installed fonts.

	* library/dialog.tcl (tk_dialog): changed dialog to show bar on
	Windows as well and added some y padding between the buttons and
	the bar. [Patch #442835] (harrismh)

2001-08-20  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkInt.h:
	* generic/tkWindow.c:
	* generic/tkGrid.c:
	* generic/tkPack.c:
	* tests/grid.test:
	* tests/oldpack.test:
	* tests/pack.test: Objectified grid and pack commands.

2001-08-20  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkObj.c (TkGetWindowFromObj): Rewrote window code to
	reuse a previously worked-out set of window information exactly
	when the reference window is the same and no window deletions have
	occurred since the object was allocated (display has same epoch
	counter.)  Required changing the internal rep of the window quite
	a bit as now need to save three words-worth of information in the
	internal rep (this window, reference window, display epoch.)
	* generic/tkObj.c (SetWindowFromAny, DupWindowInternalRep)
	(FreeWindowInternalRep): Code to support new internal rep for
	window objects.
	* generic/tkInt.h: Added epoch counter to TkDisplay structure
	* generic/tkWindow.c (GetScreen, Tk_DestroyWindow): Epoch counter
	is incremented every time a window is deleted.

2001-08-18  Peter Spjuth <peter.spjuth@space.se>

	* doc/grid.n:
	* tests/grid.test:
	* generic/tkGrid.c: Grid configure rejected initial "x" and "^".
	[Bug #418664]

2001-08-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkObj.c (TkGetWindowFromObj): Was failing to reuse
	cached window objects, forcing a call to Tcl_GetStringFromObj and
	Tk_NameToWindow every time.  This fault has been in there for
	nearly three years...

2001-08-15  Don Porter <dgp@users.sourceforge.net>

	* changes: Labelled the TIP 44 changes as "POTENTIAL INCOMPATIBILITY".
	Although technically internal changes are not incompatible, they'll
	be perceived as such by those who get bitten, and this will help
	them find the cause of their trouble.

2001-08-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tk{Util,Font,Cursor,Color,Bitmap,3d}.c: Modified
	objtype declarations so that they can be picked up in tkObj.c and
	the names are now prefixed with "tk" too.
	* generic/tkObj.c (TkRegisterObjTypes):
	* generic/tkWindow.c (Initialize):
	* generic/tkInt.h: Added code to register Tk's object types with
	the Tcl runtime.  [Tcl Bug 450545]

2001-08-12  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.

2001-08-10  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/image2.tcl (loadDir): Converted non-portable
	[glob [file join $dirName *]] to [glob -directory $dirName *]
	which is both fully portable and more reliable when directory
	names contain glob-significant characters.  [Bug 223313]

2001-08-08  Don Porter <dgp@users.sourceforge.net>

	* tests/dialog.test:  New file testing [tk_dialog].

	* library/dialog.tcl:
	* library/tkfbox.tcl: Corrections to problems introduced by
	the TIP 44 changes.  [Bug 449261]

	* README:
	* generic/tk.h:
	* unix/configure:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure:
	* win/configure.in: Bumped up patchlevel to 8.4a4 to distinguish
	CVS snapshots from the 8.4a3 release.  This does not necessarily
	mean there will be an 8.4a4 release.  [Bug 448938].

2001-08-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (dist): added {unix,win}/tcl.m4 and
	library/msgs/*.msg to dist target.  [Bug: #448802]

2001-08-06  Jeff Hobbs  <jeffh@ActiveState.com>

	8.4a3 RELEASE

	* changes:
	* README: updated for 8.4a3 release

	* unix/configure: regenerated
	* unix/tcl.m4: added GNU (HURD) configuration target. (brinkmann)
	[Patch: #442974]

2001-08-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:
	* generic/tkWindow.c:
	* library/bgerror.tcl:
	* library/dialog.tcl:
	* library/msgbox.tcl:
	* library/unsupported.tcl:
	* mac/tclets.tcl:
	* mac/tkMacHLEvents.c:
	* mac/tkMacWm.c:  TIP 44 changes specific to the Mac and
	Windows platforms that were overlooked before: tkOpenDocument,
	tkConsoleExit, tkConsoleOutput, unsupported1 out of namespace :: .
	Thanks to Vince Darley for prompting another look.

2001-08-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/winMain.c (WishPanic): fixed CONST changes to go with
	CONST-ification in Tcl.

	* win/configure: regenerated
	* win/tcl.m4: fixed DLLSUFFIX definition to always be ${DBGX}.dll.
	This is necessary for TEA compliant builds that build shared
	against a static-built Tk.
	* win/Makefile.in ($(WISH)): added $(TK_STUB_LIB_FILE) to build
	target, otherwise it wouldn't get generated in a static build.

2001-08-01  Don Porter  <dgp@users.sourceforge.net>

	* doc/console.n:
	* doc/menu.n:
	* doc/text.n:
	* doc/tkvars.n:
	* generic/tkBind.c:
	* generic/tkMenu.c:
	* library/bgerror.tcl:
	* library/button.tcl:
	* library/choosedir.tcl:
	* library/clrpick.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/optMenu.tcl:
	* library/palette.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/spinbox.tcl:
	* library/tclIndex:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/unsupported.tcl:
	* library/xmfbox.tcl:
	* mac/tkMacMenu.c:
	* tests/clrpick.test:
	* tests/filebox.test:
	* tests/macMenu.test:
	* tests/menu.test:
	* tests/menuDraw.test:
	* tests/msgbox.test:
	* tests/text.test:
	* tests/unixMenu.test:
	* tests/winMenu.test:
	* tests/xmfbox.test:
	* unix/mkLinks:
	* unix/tkUnixDialog.c: Merged changes from feature branch
	dgp-privates-into-namespace, implementing TIP 44.  All
	Tk commands and variables matching tk[A-Z]* are now in the
	::tk namespace.  See "BRANCH: dgp-privates-into-namespace"
	entries below for details.  [FR 220936]

2001-07-24  Mo DeJong  <mdejong@redhat.com>

	* generic/default.h: Include tkWinDefault.h
	when built with Cygwin or Mingw.

2001-07-18  Don Porter	<dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* doc/console.n:  Updated names of private console commands.

2001-07-16  Don Porter	<dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* library/console.tcl:
	* library/unsupported.tcl: Renamed tk::histNum to tk::HistNum
	as directed by the Tcl Style Guide.

2001-07-10  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Add AR and STLIB_LD variables.
	* unix/configure:
	* unix/configure.in: Use STLIB_LD when defining MAKE_LIB
	and MAKE_STUB_LIB. Subst STLIB_LD, RANLIB, and AR.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-07-06  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-07-05  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Subst DEPARG directly instead
	of relying on a variable. This will make Cygwin
	build faster since an extra exec will be avoided.
	* win/configure: Regen.
	* win/configure.in: Subst DEPARG.
	* win/tcl.m4: Update from Tcl.

2001-07-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:
	* mac/README:
	* unix/README:
	* win/README: updated READMEs with purls

2001-07-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/canvas.test:
	* generic/tkCanvPoly.c (PolygonToArea): Added patch that respects
	the polygon difference of including points in the polygon even
	when fill is empty.  [Bug #226357]

2001-07-03  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Remove PATHTYPE variable.
	* win/configure: Regen.
	* win/configure.in: Don't subst PATHTYPE.
	* win/tcl.m4: Update from Tcl.

2001-07-03  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Don't use VPSEP, instead just use :
	in the VPATH.
	* win/configure: Regen.
	* win/configure.in: Don't subst VPSEP.

2001-07-03  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/xmfbox.tcl (tkMotifFDialog_ActivateSEnt): Added missing
	backslash [Bug #438247]

2001-07-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (Tk_DestroyWindow): changed to use
	Tcl_EventuallyFree instead of ckfree so that widgets that have
	references to a tkwin can use them.

	* generic/tkCanvArc.c:
	* generic/tkCanvBmap.c:
	* generic/tkCanvLine.c:
	* generic/tkCanvPoly.c:
	* generic/tkCanvText.c:
	* generic/tkCanvWind.c:
	* generic/tkRectOval.c: corrected argument handling in
	Create<Item> functions that could lead to ABRs or FMRs and
	corrected names of argc/argv to objc/objv.

	* generic/tkImgGIF.c (Mgetc): corrected screwy use of ternary
	operator and possible FMR.

	* generic/tkEntry.c: corrected missing Tcl_Release that caused
	font not freed complaints when trying valid cleanup calls.
	* generic/tkListbox.c: made use of Tcl_Preserve/Tcl_Release to
	prevent FMR errors in Display functions.

	* unix/tkUnixScale.c (TkpDisplayScale): corrected FMR when scale
	was deleted while calling its command.

	* library/console.tcl:
	* library/entry.tcl:
	* library/spinbox.tcl:
	* library/text.tcl:
	* library/tk.tcl: added private ::tk::GetSelection command to
	handle requesting selection.  This is to support requesting
	UTF8_STRING before generic STRING on Unix.  Changed Text, Spinbox,
	Entry and Console to use this command.

	* tests/select.test:
	* generic/tkSelect.c (Tk_CreateSelHandler, Tk_DeleteSelHandler):
	on Unix, a UTF8_STRING handler will be created when the user
	requests a STRING handler (in addition to the STRING handler).
	This provides implicit support for the new UTF8_STRING selection
	target.
	* unix/tkUnixSelect.c (TkSelEventProc, ConvertSelection): Added
	support for UTF8_STRING target. [RFE #418653, Patch #433283]

	* generic/tkInt.h: added utf8Atom to TkDisplay structure.

	* tests/listbox.test: changed 'darkblue' to 'white' in a test
	because it isn't a portable color name.

	* generic/tkEntry.c (DestroyEntry): used Tcl_EventuallyFree
	instead of ckfree for entryPtr to prevent FMRs. [Bug #413904]

2001-06-26  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in:
	* win/Makefile.in: Add `make shell` target. This target
	will set the proper env vars before invoking wish
	from the build directory.

2001-06-26  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/configure.in: Revert cross compiling change
	accidently added during last checkin.

2001-06-26  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/configure.in: Fix last checkin by removing
	export since that only works in bash.
	* win/configure: Regen.
	* win/configure.in: Ditto.

2001-06-26  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/configure.in: Set CFLAGS to "" if the user
	did not set CFLAGS in the env. This keeps AC_PROG_CC
	from adding "-g -O2" to the CFLAGS by default.
	* win/configure: Regen.
	* win/configure.in: Ditto.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/configure.in: Use RC_DEFINE flag from tcl.m4.
	* win/tcl.m4: Update from Tcl.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Link to the
	imm32 library when building with mingw gcc.
	* win/tkWinX.c: Include the imm.h header
	to fix compiling with mingw gcc.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/configure.in: Add resource compiler fix from
	8.3.3 to fix compiling with mingw.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/tcl.m4: Fix silly typo in last checkin.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Set CFLAGS to @CFLAGS@ and @CFLAGS_DEFAULT@.
	Set LDFLAGS to @LDFLAGS@ and @LDFLAGS_DEFAULT@. Add LDFLAGS_DEBUG
	and LDFLAGS_OPTIMIZE to match the way CFLAGS_DEFAULT works. Use
	new LDFLAGS variable in the Makefile instead of @LDFLAGS@.
	* unix/configure: Regen.
	* unix/configure.in: Don't set CFLAGS to CFLAGS_DEFAULT, instead
	subst CFLAGS_DEFAULT into the Makefile. Add AC_SUBST for CFLAGS_DEBUG,
	CFLAGS_OPTIMIZE, LDFLAGS_DEFAULT, LDFLAGS_DEBUG, and LDFLAGS_OPTIMIZE.
	Remove unused LD_FLAGS subst.
	* unix/tcl.m4: Update from Tcl.
	* win/Makefile.in: Set CFLAGS to @CFLAGS@ and @CFLAGS_DEFAULT@.
	Set LDFLAGS to @LDFLAGS@ and @LDFLAGS_DEFAULT@.
	* win/configure: Regen.
	* win/configure.in: Don't set CFLAGS or LDFLAGS, instead subst
	CFLAGS_DEFAULT and LDFLAGS_DEFAULT into the Makefile.
	* win/tcl.m4: Update from Tcl.

2001-06-22  Mo DeJong  <mdejong@redhat.com>

	* win/configure:
	* win/tcl.m4: Update From Tcl.

2001-06-21  eric melski  <ericm@interwoven.com>

	* doc/colors.n: Corrected bogus documentation with respect to
	several shades of blue, all of which were listed as RGB 0 0 0.
	[Bug #432104].

2001-06-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/demos/floor.tcl, library/demos/filebox.tcl,
	* library/demos/clrpick.tcl, library/demos/vscale.tcl,
	* library/demos/twind.tcl, library/demos/ruler.tcl,
	* library/demos/plot.tcl, library/demos/items.tcl,
	* library/demos/hscale.tcl, library/demos/ctext.tcl,
	* library/demos/cscroll.tcl, library/demos/arrow.tcl,
	* library/xmfbox.tcl, library/msgbox.tcl,
	* library/clrpick.tcl, library/bgerror.tcl: Braced expressions.

2001-06-06  Mo DeJong  <mdejong@redhat.com>

	* win/configure: Regen.
	* win/configure.in: Handle the --prefix option correctly
	it should default to /usr/local like the unix version.

2001-06-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/selection.n:
	* doc/clipboard.n: added SEE ALSOs to cross-reference selection
	and clipboard, with extra note for clipboard command in selection
	docs.  [Patch #422256]

	* unix/tkUnixFont.c: Corrected support for iso10646 (X11 Unicode)
	fonts on Unix. This adds a ucs-2be (UCS-2 Big Endian) encoding in
	Tk on Unix that is used for those fonts (X11 requires
	big-endianness). (welch) [Patch #406411; Bug #220890 #220899]
	This differs from the 8.3.3 patch by not adding ucs-2be in the
	preferred encodingList (seems works fine without).
	Added alias for jisx0201* fonts to jis0201 encoding. [Bug #414033]

2001-05-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinKey.c (TkpSetKeycodeAndState): removed old debug info

2001-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinX.c: moved the initialization of tkPlatformId from
	TkWinXInit to TkWinGetPlatformId because static builds could call
	it before it was initialized. [Bug #427278]

2001-05-28  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkFrame.c:
	* generic/tkWindow.c:
	* tests/frame.test: Upgraded frame to use the newer TK_OPTION
	style when processing configuration options. Some cleanup of
	bad comments and bad code. [part of patch #420861]

2001-05-23  Mo DeJong  <mdejong@redhat.com>

	* unix/configure:
	* unix/tcl.m4:
	* win/configure:
	* win/tcl.m4: Sync from Tcl sources.

2001-05-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4: sync'ed up wih Tcl tcl.m4. [Bug #419812]

	* doc/TkInitStubs.3:
	* generic/tk.h:
	* generic/tkStubLib.c: CONST'ified Tk_InitStubs to match CONST
	changes to Tcl_PkgRequireEx.

2001-05-21  Todd M. Helfter  <tmh@purdue.edu>

	* doc/menubutton.n:
	* generic/tkMenubutton.c:
	* generic/tkMenubutton.h:
	* mac/tkMacMenubutton.c:
	* tests/menubut.test:
	* unix/tkUnixMenubu.c: Implementation of TIP #11, the addition of
	a -compound option to the menubutton allowing text and an image to
	be displayed at the same time.  This behavior is identical to the
	behavior of the button widget.

2001-05-16  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/console.n: Added - was erroneously placed in Tcl before...

2001-04-25  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/tcl.m4: Update from Tcl.
	* win/configure: Regen.
	* win/tcl.m4: Update from Tcl.

2001-04-25  Mo DeJong  <mdejong@redhat.com>

	* unix/configure: Regen.
	* unix/configure.in: Use $@ in MAKE_LIB and MAKE_STUB_LIB
	commands instead of using a delayed subst variable. Replace
	instances of STUB_LIB_FILE with TK_STUB_LIB_FILE.

2001-04-25  Mo DeJong  <mdejong@redhat.com>

	* unix/Makefile.in: Use TCL_STUB_LIB_FILE instead of STUB_LIB_FILE.
	* unix/configure: Regen.
	* unix/configure.in: Don't subst STUB_LIB_FILE, use TCL_STUB_LIB_FILE
	instead.

2001-04-12  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tkImage.c (Tk_ImageObjCmd,DeleteImage): Better detection
	of deletion when world is falling apart. [Bug #220819]

2001-04-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkWinHandleMenuEvent): corrected reseting of
	service mode to only occur when it was set. [Bug #220948]

2001-04-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/winClipboard.test: improved results for understanding when
	tests fail.

	* tests/winDialog.test: string totitle'd some results that
	expected [pwd] to return a capital drive letter.

	* tests/cursor.test: changed tests to use 'heart' cursor because
	'arrow' on windows has a pre-skewed use count.

	* win/tkWinDialog.c (GetFileNameA): initialize multi to 0.

2001-04-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure:
	* win/tcl.m4 (SHLIB_LD): added -incremental:no. [Bug #219381]

	* generic/tkMenu.c (TkInvokeMenu): checked for menu deletion
	before calling associated menu entry command.  [Bug #220821]

	* doc/image.n: added warning about names chosen for images.

	* generic/tkImgPhoto.c (ImgPhotoCmd): corrected the src and dest
	values for $imageName put when -format and -to are used.
	[Bug #232741]

	* tests/listbox.test: added test listbox-27.1, delete during
	scrollbar update
	* generic/tkListbox.c (DestroyListbox, ListboxEventProc):
	corrected listbox to make proper use of Tcl_EventuallyFree and
	protect against unusual listbox deletion.

	* tests/entry.test: added tests entry-20.*, delete during widget
	activity
	* generic/tkEntry.c (DestroyEntry, EntryEventProc): fixed the
	entry widget to survive deletion while processing scrollbar
	updates and validation.

	* tests/canvas.test: test of canvas delete during event
	* generic/tkCanvas.c (DestroyCanvas, CanvasEventProc): fixed the
	canvas to survive deletion during event processing. [Bug #228024]

2001-04-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:
	* mac/README: updated patchlevel to 8.4a3 and corrected links and
	notes.

	* generic/tk.h:
	* unix/configure.in (TK_PATCH_LEVEL):
	* unix/configure:
	* unix/tk.spec:
	* win/configure.in (TK_PATCH_LEVEL):
	* win/configure: updated patchlevel to 8.4a3

2001-03-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/safe.test: added note about correcting failures in
	safe.test.
	* library/tk.tcl: moved package require msgcat inside if case to
	not be used in safe interps.

	* win/makefile.vc:
	* win/configure:
	* win/tcl.m4: added imm32.lib to LIBS_GUI for Tk IME support.
	* win/tkWinInt.h:
	* win/tkWinKey.c:
	* win/tkWinX.c: added support for changing IME on the fly in
	Windows (2000).  (lam) [Patch #402993]

	* tests/bind.test (bind-22.18):
	* generic/tkBind.c (NameToWindow): handled the error case where a
	valid-looking but invalid identifier could be passed in certain
	event generate options causing a crash. [Bug #411307]

	* win/tkWinWm.c (UpdateWrapper): ensured that the passed in winPtr
	had an existent window to operate on. [Bug #409172]

	* win/Makefile.in (install-*): improved install-* targets to use
	their base build dependency.

	* generic/tkImage.c (Tk_ImageObjCmd, EventuallyDeleteImage):
	added casts to allow compiling on Windows with debbuging.

2001-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/msgs/de.msg: fixed translations. [Patch #403525]

	* doc/canvas.n: Noted ability to specify coords as a list in the
	docs. (techentin) [Patch #403660]

	* tests/canvas.test: added test case to check obj conversion
	* generic/tkObj.c (UpdateStringOfMM, SetMMFromAny): better
	obj-aware screen distances.  (pgbaum, hobbs) [Patch #403327]

	* library/bgerror.tcl (bgerror): allow focus into details window
	for Windows C&P to work. [Bug #220929]

	* library/tk.tcl: put a catch around adding <hpBackTab> to the
	<<PrevWindow>> virtual event as it doesn't seem to work on all HP
	systems. [Bug #411669]

	* library/tkfbox.tcl: fixed selecting directories and single files
	with spaces using tk_getOpenFile -multiple 1. [Bug #411640]

	* win/tkWinDialog.c (GetFileNameA): added support for -multiple to
	ascii-based tk_getOpenFile (Win9*). (haneef) [Patch #403047]
	(GetFileNameW): increased number of files that could be returned
	by tk_getOpenFile -multiple. [Patch #412042]

2001-03-29  Mo DeJong  <mdejong@redhat.com>

	* library/entry.tcl (tkEntryMouseSelect):
	* library/text.tcl (tkTextSelectTo): When
	the mouse is dragged with the button down,
	move the insertion cursor to the current
	mouse position.
	* tests/event.test: Add a series of tests
	for event generation. Add tests for selection,
	check the position of the insertion cursor.

2001-03-28  Jeff Hobbs  <jeffh@gimlet.activestate.com>

	* unix/configure:
	* unix/tcl.m4: corrected IRIX-5.x config to not use -n32.
	(english) [Patch 403626]

2001-03-28  Don Porter  <dgp@users.sourceforge.net>

	* tests/focus.test (focus-6.1):
	* tests/macEmbed.test (unixEmbed-5.1):
	* tests/macMenu.test (macMenu-21.3):
	* tests/menu.test (menu-27.1):
	* tests/unixEmbed.test (unixEmbed-8.2):
	* tests/unixWm.test (unixWm-50.4):  Replaced all [load {} tk]
	in Tk test suite with [load {} Tk].  [Bug 220940, Patch 411952]

2001-03-12  Don Porter  <dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* doc/menu.n:
	* unix/mkLinks: Added documentation for [tk_menuSetFocus].

2001-03-12  Don Porter  <dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* doc/text.n:
	* doc/tkvars.n:
	* unix/mkLinks: Added documentation for commands and variables
	matching tk_text*.

2001-03-08  Don Porter  <dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* generic/tkTextDisp.c:
	* library/unsupported.tcl:
	* tests/textDisp.test: Restored the global variables tk_textRedraw
	and tk_textRelayout.  Since they match tk_*, they should remain
	publicly available until at least Tk 9.

2001-03-01  Don Porter  <dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:
	* library/unsupported.tcl: New file for Tk's unsupported
	interfaces.  Contains [tk::unsupported::ExposePrivateCommand]
	and [tk::unsupported::ExposePrivateVariable] that restore the
	availability of an old public name of one of Tk's private
	commands and variables, respectively, for those applications
	and extensions that depend on the old names against advice.

2001-02-28  Don Porter  <dgp@users.sourceforge.net>

	BRANCH dgp-privates-into-namespace:  Feature branch to move all
	of Tk's private commands and variable into the ::tk namespace
	and its children.

	* doc/tkvars.n:  Documented private variable tkPriv renamed tk::Priv.

	* generic/tkBind.c:
	* generic/tkMenu.c:
	* generic/tkTextDisp.c:
	* library/bgerror.tcl:
	* library/button.tcl:
	* library/choosedir.tcl:
	* library/clrpick.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/optMenu.tcl:
	* library/palette.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/spinbox.tcl:
	* library/tclIndex:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:
	* mac/tkMacMenu.c:
	* tests/clrpick.test:
	* tests/filebox.test:
	* tests/macMenu.test:
	* tests/menu.test:
	* tests/menuDraw.test:
	* tests/msgbox.test:
	* tests/text.test:
	* tests/textDisp.test:
	* tests/unixMenu.test:
	* tests/winMenu.test:
	* tests/xmfbox.test:
	* unix/tkUnixDialog.c:  All Tk commands matching ::tk[A-Z]* and
	all Tk private variables in the global namespace were renamed to
	live in the namespace ::tk or one of its children.

2001-02-13  Eric Melski  <ericm@interwoven.com>

	* doc/photo.n: [Bug 132213] Added clarification on interpretation
	of ranges for "photoName data -from" subcommand.

2001-02-12  D. Richard Hipp  <drh@hwaci.com>

	TIP #21: Asymmetric padding in the pack and grid geometry managers.
	With this changes, you can now say "-padx {10 20}" to put 10 pixels
	of padding on the left and 20 on the right.  Similar rules apply
	for vertical padding.  See the revised documentation for details.

2001-01-02  Andreas Kupries  <a.kupries@westend.com>

	Everything below belongs together and implements TIP#8 (SF patch#102833)

	* win/tkWinWm.c (line 56f): Added icon structures.
	* win/tkWinWm.c (struct WmInfo, line 242): Added reference to
	optional icon for titlebar.
	* win/tkWinWm.c (struct ThreadSpecificData, line 335): Added
	reference to optional default icon for toplevel windows.
	* win/tkWinWm.c (line 387 ... 1169): All the new functions required
	to deal with icon specifications, 'InitWm' changed.
	* win/tkWinWm.c (TkWmNewWindow, UpdateWrapper, TkWmDeadWindow, Tk_WmCmd):
	Added initialization and handling of the new fields.
	* doc/wm.n: Documentation updated to explain the newly available
	functionality.

2000-12-13  jeff hobbs  <jhobbs@interwoven.com>

	* generic/tkObj.c (SetMMFromAny): Added ability to recognize
	double type object to speed up canvas coord calculations.
	[Patch 403327]

2000-12-12  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/entry.n: Improved documentation of interplay between the
	-state and -textvariable options.

2000-11-29  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/image.test (image-1.10): Improved this test, which
	previously only worked if the command failed to delete the root
	window, and caused *major* trouble otherwise...
	* generic/tkImage.c (EventuallyDeleteImage): Created this function
	so that images that get deleted during the creation of an image
	won't cause a nasty core dump.  Properly fixes bug #120819.

2000-11-28  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/image.n:
	* generic/tkImage.c (Tk_ImageObjCmd): Backed out previous change.
	Bug #120819 is back again in force.  Left the test in there
	though.

2000-11-23  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/image.n:
	* tests/image.test (image-1.10):
	* generic/tkImage.c (Tk_ImageObjCmd): Prohibited image names that
	start with "." since they can cause some really obscure crashes.
	Fixes Bug #120819.

2000-11-21  Eric Melski  <ericm@ajubasolutions.com>

	Overall change:  Implemented TIP 5, which exports
	TkClassProcs/TkSetClassProcs as Tk_ClassProcs/Tk_SetClassProcs,
	adding a size field to Tk_ClassProcs to allow for future
	expansion, and renaming the geometryProc to worldChangedProc,
	which is more in keeping with the actual use of the callback.

	* unix/mkLinks: Added link for Tk_SetClassProcs.

	* doc/SetClassProcs.3: Documentation for
	Tk_ClassProcs/Tk_SetClassProcs.

	* generic/tkCanvas.c:
	* generic/tkEntry.c:
	* generic/tkFrame.c:
	* generic/tkListbox.c:
	* generic/tkMenu.c:
	* generic/tkMessage.c:
	* generic/tkScale.c:
	* generic/tkText.c: Updated to use Tk_ClassProcs/Tk_SetClassProcs
	instead of TkClassProcs/TkSetClassProcs.

	* generic/tkMenubutton.c:
	* generic/tkScrollbar.c:
	* generic/tkButton.c: Updated to use Tk_SetClassProcs instead of
	TkSetClassProcs.

	* generic/tkMenubutton.h:
	* generic/tkScrollbar.h:
	* generic/tkButton.h:
	* win/tkWinButton.c:
	* win/tkWinScrlbr.c:
	* mac/tkMacButton.c:
	* mac/tkMacMenubutton.c:
	* mac/tkMacScrlbr.c:
	* unix/tkUnixButton.c:
	* unix/tkUnixMenubu.c:
	* unix/tkUnixScrlbr.c: Updated to use Tk_ClassProcs instead of
	TkClassProcs.

	* generic/tkDecls.h:
	* generic/tkStubInit.c:
	* generic/tkIntDecls.h: Regenned from tk.decls, tkInt.decls.

	* generic/tk.h: Added declaration of Tk_ClassProcs, with size
	field.  Added typedef's for Tk_ClassCreateProc,
	Tk_ClassWorldChangedProc, Tk_ClassModalProc.  Added definition of
	Tk_GetClassProc macro, shorthand for extracting a member of the
	Tk_ClassProcs structure.

	* generic/tkInt.h: Removed declaration of TkClassProcs,
	TkClassGeometryProc, etc.

	* generic/tkBind.c (Tk_BindEvent): Updated to use Tk_GetClassProc
	macro to extract modalProc; added check that the modalProc is non-NULL.

	* generic/tkFont.c (RecomputeWidgets): Updated to use
	Tk_GetClassProc macro to extract worldChangedProc; added comment
	about the choice of a recursive versus iterative algorithm for
	propagating world changed messages.

	* generic/tkWindow.c (Tk_MakeWindowExist): Updated to use
	Tk_GetClassProc macro to extract createProc from Tk_ClassProcs.

	* generic/tk.decls: Added declaration for Tk_SetClassProcs.

	* generic/tkInt.decls: Commented out declaration for
	TkSetClassProcs, which is made public by this change.  The entry
	is left in place, but commented, so that future developers will
	know not to reuse it's stub number.

2000-11-21  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/ConfigWidg.3: Added deprecation note from Bug #120944 - use
	Tk_SetOption() instead.

	* generic/tkImgPhoto.c (TkPhotoGetValidRegion): Applied patch to
	create this function and add it to tkInt stubs.  Should now be
	possible to write an extension that accesses the transparency data
	in a photo image.  Bug #120930

2000-11-03  Jeff Hobbs  <hobbs@ajubasolutions.com>

	8.4a2 RELEASE

	* generic/tkWindow.c (Initialize): added call to Tcl_SetMainLoop.
	This only has effect when tclsh is run (not wish), and then Tk is
	loaded in interactively.

2000-11-02  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* win/tkWinButton.c:
	* win/tkWinDialog.c:
	* win/tkWinScrlbr.c:
	* win/tkWinWm.c: fixed up code for Win64 support.  This mostly
	remains in _WIN64 #ifdef's, until updated compilers are standard.

	* win/tcl.m4:
	* win/makefile.vc: updated for Win64 compile support

	* unix/configure:
	* win/configure: checked in configure scripts so people doing
	CVS checkouts aren't required to have autoconf.  Changes to
	configure.in in the future will require the corresponding
	configure script to also be re-autoconf'ed and checked in.

	* doc/event.n: added note that key events require window focus.

2000-11-01  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* win/tkWinDialog.c (GetFileNameW, GetFileNameA)
	(Tk_ChooseDirectoryObjCmd): created
	work-around for change in NT5.0/98 that caused no initialdir
	setting to open the browser up in the user's documents dir.

	* tests/color.test: marked color-2.6 nonPortable as we can't
	reliably assume what 'red' maps to.

2000-11-01  Eric Melski  <ericm@ajubasolutions.com>

	* tests/winDialog.test: Corrected expected results for bad option
	tests (5.2, 5.5) to include -multiple option.

	* win/tkWinDialog.c: Added branch for 0 return from
	CommDlgExtendedError() switches; this was formerly treated as an
	error, but it actually is not, since it just means the user hit
	cancel or closed the dialog.  (GetFileNameW): Added better smarts
	such that -multiple is not considered a valid option for
	tk_getSaveFile.
	Removed CommDlgExtendedError() checks for color and choosedir
	dialogs, and removed all except the explicit invalid filename
	checks for the file dialogs.

2000-10-30  David Gravereaux  <davygrvy@ajubasolutions.com>

	* win/configure.in:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/rc/tk.rc:
	* win/rc/tk_base.rc (new):
	* win/rc/wish.rc: Added logic to derive filenames better in the
	resource scripts based on compile options along with better
	support for building a static wish shell with cursor resources.

2000-10-27  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* unix/tcl.m4: added support for AIX-5.

	* tests/tk.test:
	* doc/tk.n: updated to reflect default on status of useinputmethods.
	* library/tk.tcl: tk useinputmethods is set to 1 by default.  This
	enables Kanji and dead-char input by default.  Intro'd in
	1999-12-16 with default off to avoid some problems with older X
	servers that would slow down widget creation over time.

	* win/Makefile.in (test, winhelp, tktest): corrected the
	TCL_LIBRARY path specification.

2000-10-18  Eric Melski  <ericm@ajubasolutions.com>

	* win/tkWinDraw.c (RenderObject): Applied patch from [Bug: 6368],
	which corrects rendering of 1-pixel wide stippled lines on Windows.

	* generic/tkCanvLine.c (DisplayLine): Applied patch from
	[Bug: 6368], corrects bugs relating to use of active- and
	disabledwidth values for displaying lines (disabledwidth was never
	used, and activewidth/disablewidths would only possibly be used
	when greater than default width, rather than when simply not equal
	to default width).

	* library/tkfbox.tcl (OkCmd): Applied patch from [Bug: 6365],
	which adds safety for directory names containing spaces or which
	are non-lists.

	* win/tkWinDialog.c (GetFileNameW, GetFileNameA)
	(Tk_ChooseColorObjCmd, Tk_ChooseDirectoryObjCmd): Added error
	checking for the return value from the common dialog functions, so
	that the commands will not silently fail if the common dialog
	returns an error. [Bug: 6369].

2000-10-10  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkConfig.c (Tk_InitOptions): Added
	Tcl_IncrRefCount/Tcl_DecrRefCount calls on valuePtr, to prevent
	memory leaks when the value object comes from the option
	database.  [Bug: 6275].

2000-10-06  Jeff Hobbs  <hobbs@ajubasolutions.com>

	* win/Makefile.in (cat32.${OBJEXT}): add win/ subdirectory to
	cat32 target to correctly find the source file.

2000-10-05  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkCmds.c (Tk_WinfoObjCmd): Added check for
	TK_ANONYMOUS_WINDOW flag in the [winfo children] subcommand; if
	set, the window will not be printed in the list of children.

	* doc/CrtWindow.3: Added entry for Tk_CreateAnonymousWindow.

	* generic/tkWindow.c
	(Tk_CreateAnonymousWindow): New API for creating anonymous
	windows.  These windows are manipulable from C, but not from Tcl,
	because they have no pathname associated with them.  They are used
	initially by widgets that do rubber-band resizing (panedwindow,
	multi-column listbox, etc.), and may be useful for other widgets
	as well (dropbox, combobox).
	(Tk_DestroyWindow): Added check for TK_ANONYMOUS_WINDOW flag when
	determining whether to generate a DestroyNotify event.

	* generic/tkStubInit.c:
	* generic/tkDecls.h: Regen'd from tk.decls.

	* generic/tk.decls: Added Tk_CreateAnonymousWindow declaration.

	* generic/tk.h: Added TK_ANONYMOUS_WINDOW flag for Tk_Window's.

2000-10-04  Eric Melski  <ericm@ajubasolutions.com>

	* doc/MaintGeom.3: Noted that Tk_MaintainGeometry handles direct
	descendants properly.

	* generic/tkGeometry.c (Tk_MaintainGeometry): Added a check for
	the case in which the slave window is a direct descendant of the
	master window.  In this case, we need not set up the additional
	infrastructure normally provide by Tk_MaintainGeometry, because we
	can rely on the parent/child relationship to handle it for us
	implicitly.  In this case, Tk_MaintainGeometry just calls directly
	to Tk_MoveResizeWindow.  This allows geometry managers to simply
	always use Tk_MaintainGeometry to maintain geometry for slaves,
	and avoid doing the direct descendant check themselves.
	(Tk_UnmaintainGeometry): Added a matching check for the direct
	descendant case; in this case, Tk_UnmaintainGeometry simply
	returns immediately.

2000-10-01  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkButton.c (ConfigureButton): Added tests for -compound
	option, so that when there is a textvariable and an image, and
	-compound is not none, the button will display both the
	textvariable and the image.

	* doc/SetOptions.3: Added note that restoreProc and freeProc may
	be NULL.

	* generic/tkConfig.c (Tk_RestoreSavedOptions): For custom options,
	added test that the restoreProc is not NULL, to allow for custom
	options that don't care about supporting Tk_RestoreSavedOptions.

2000-09-29  D. Richard Hipp <drh@hwaci.com>

	* generic/tkBitmap.c: Changes to prevent a BadMatch error from the
	Xserver when the same bitmap is used on two or more screens of the
	same display.

	* tests/menu.test: Print a warning if the TK_ALT_DISPLAY environment
	variable is not configured so as to test for the bug fix above.

	* library/tk.tcl (::tk::SetGrabFocus): "Catch" the grab in case
	another application already holds the grab and the "grab" command
	fails.

2000-09-29  Jeff Hobbs  <hobbs@scriptics.com>

	* win/Makefile.in: commented use of TESTFLAGS
	* unix/Makefile.in: added TESTFLAGS to test and testlang targets to
	conform with Windows makefile and TEA style.

2000-09-29  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkTest.c: Fixed tests to use updated API.

	* doc/SetOptions.3:
	* generic/tk.h:
	* generic/tkConfig.c: Changed interface for Tk_CustomOptionSetProc
	and Tk_CustomOptionGetProc; these now take a pointer to the start
	of the widget record, and an integer offset to the slot for the
	option value, instead of just a pointer to the slot.  This allows
	more sophisticated options to do interesting things based on other
	data in the widget record.

2000-09-17  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tk.h: Added declaration of Tk_ObjCustomOption structure,
	used for TK_OPTION_CUSTOM, and typedef's of the functions
	Tk_CustomOptionSetProc, Tk_CustomOptionGetProc,
	Tk_CustomOptionRestoreProc, and Tk_CustomOptionFreeProc, used for
	TK_OPTION_CUSTOM.

	* doc/SetOptions.3: Added documentation of TK_OPTION_CUSTOM, and
	section "CUSTOM OPTION TYPES" explaining how to create and use
	custom options.

	* tests/config.test: Added tests for custom option type.

	* generic/tkTest.c: Added test support for TK_OPTION_CUSTOM to
	TestobjconfigObjCmd.  Added CustomOption* functions to implement a
	test custom option.

	* generic/tkConfig.c: Added new option type TK_OPTION_CUSTOM,
	which allows the definition of custom option types by creating
	parsing, printing, freeing, and restoring procedures for a custom
	option.  This is needed by the text and canvas widgets if they are
	to be fully objectified.

2000-09-07  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/Tk_Init.3:
	* doc/bell.n:
	* doc/loadTk.n: minor doc cleanup

2000-09-06  Eric Melski  <ericm@ajubasolutions.com>

	* doc/HWNDToWindow.3:
	* doc/GetHWND.3: Changed synopsis to indicate the tkPlatDecls.h
	should be included, not tk.h.

	* generic/tkPlatDecls.h: Removed #include <windows.h> for Windows,
	a better solution for now is to update the docs and have extension
	authors #include <tkPlatDecls.h>.

	* generic/tk.h: Removed '#include "tkPlatDecls.h"', as the
	incorrect inclusion order between windows.h/tkPlatDecls.h causes
	build conflicts on Windows.

	* generic/tkPlatDecls.h: Added #include <windows.h> for Windows,
	so that HWND, etc., are defined properly.

2000-09-06  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/canvas.n: fixed doc bug (ellson). [Bug: 6218]

	* README:
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in: updated to patchlevel 8.4a2

	* generic/tkMessage.c (MessageWidgetObjCmd): initialized result to
	avoid pedantic warning.

	* generic/tkGrab.c (Tk_GrabObjCmd): changed len arg from size_t to
	int to fix pedantic warning.

2000-09-01  Eric Melski  <ericm@ajubasolutions.com>

	* win/makefile.vc (install-libraries):
	* win/Makefile.in (install-libraries):
	* unix/Makefile.in (install-libraries): Added tkPlatDecls.h to
	list of header files to install.

	* generic/tk.h: Added #include "tkPlatDecls.h", which declares the
	platform specific component of the public Tk stubs API's.

2000-08-29  Eric Melski  <ericm@ajubasolutions.com>

	* win/tkWinMenu.c (DrawWindowsSystemBitmap): Use scratchDC
	for determining the source's logical coordinates.  Patch from
	[Bug: 6134 (Markus Oberhumer)].

	* win/tkWinMenu.c (SetDefaults): Compute the indicatorDimensions[]
	under Windows NT/2000 in the same way as under Windows 95/98.
	Patch from [Bug: 6134 (Markus Oberhumer)].

	* win/tkWinFont.c (GetScreenFont): Added a memset() to
	pacify memory checkers.  Patch from [Bug: 6134 (Markus Oberhumer)].

	* library/tkfbox.tcl (::tk::dialog::file::Update): Corrected
	handling of multi-pattern filters (eg, "* *.*"), which was broken
	by the getOpenFile performance patches applied earlier.

2000-08-24  Eric Melski  <ericm@ajubasolutions.com>

	* doc/toplevel.n:
	* doc/spinbox.n:
	* doc/scrollbar.n:
	* doc/scale.n:
	* doc/menubutton.n:
	* doc/menu.n:
	* doc/listbox.n:
	* doc/entry.n:
	* doc/frame.n:
	* doc/message.n:
	* doc/checkbutton.n:
	* doc/radiobutton.n:
	* doc/button.n:
	* doc/label.n:
	* doc/canvas.n:
	* doc/text.n: Fixed Standard Options section to make best use of
	new tab settings in man.macros.

2000-08-24  Mo DeJong  <mdejong@redhat.com>

	* unix/README: Update to account for removal of --enable-gcc.
	* unix/configure.in:
	* unix/tcl.m4 (SC_ENABLE_GCC): Remove --enable-gcc option.
	* win/configure.in:
	* win/tcl.m4 (SC_ENABLE_GCC): Remove --enable-gcc option.
	Remove quick hack that provided cross compile support for
	windows builds.

2000-08-23  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkButton.c (ButtonTextVarProc): reversed change below,
	it was not correct.

2000-08-22  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkButton.c (ButtonTextVarProc): changed order of
	incr/decr of new value object, in case they are equal.

2000-08-18  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkImgPhoto.c (ImgPhotoGet): Removed redundant call to
	DitherInstance; this call was formerly being made from
	ImgPhotoGet->ImgPhotoConfigureInstance->DitherInstance, and
	ImgPhotoGet->DitherInstance.  The second call was removed.

2000-08-10  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/SetOptions.3: added missing ')'.

2000-08-09  Eric Melski  <ericm@ajubasolutions.com>

	* doc/SetOptions.3: Updated documentation to reflect support for
	TK_OPTION_NULL_OK for TK_OPTION_DOUBLE and TK_OPTION_PIXELS.

	* generic/tkConfig.c: Added for TK_OPTION_NULL_OK support for
	TK_OPTION_DOUBLE and TK_OPTION_PIXELS.

	* doc/place.n: Updated, reformatted manual entry.

	* tests/place.test: Added many tests.

	* generic/tkPlace.c (Tk_PlaceObjCmd): Updated to use Tk
	widget-option management facilities to manage place options (-x,
	-y, etc.), which simplifies the placer code.  Added support for
	[place configure pathName] and [place configure pathName -option],
	similar to the behavior of the configure subcommand supported by
	widgets.

2000-08-08  Eric Melski  <ericm@ajubasolutions.com>

	* tests/place.test: Extended test suite to test error returns from
	[place].

	* generic/tkInt.h: Replaced Tk_PlaceCmd prototype with
	Tk_PlaceObjCmd prototype.

	* generic/tkWindow.c: Updated [place] command entry to use new
	Tcl_Obj interface.

	* generic/tkPlace.c (Tk_PlaceObjCmd): Tcl_Obj'ified [place] command.

2000-08-07  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkWindow.c: Updated [selection] command entry to use
	new Tcl_Obj interface.

	* generic/tkInt.h: Replaced Tk_SelectionCmd prototype with
	Tk_SelectionObjCmd prototype.

	* tests/select.test: Updated test suite to recognize standardized
	error messages.

	* generic/tkSelect.c (Tk_SelectionObjCmd): Tcl_Obj'ified
	[selection] command.

2000-08-07  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/cursors.n: changed .SS to more compatible macros.

2000-08-05  Jeff Hobbs  <hobbs@scriptics.com>

	* library/safetk.tcl: rationalized the setting of tk_library when
	initialized Tk in a safe interpreter.

2000-08-03  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkWindow.c: Updated "grab" command entry to use
	Tcl_Obj'ified command.

	* generic/tkInt.h: Replaced Tk_GrabCmd prototype with
	Tk_GrabObjCmd prototype.

	* tests/grab.test: Initial suite of tests for [grab] command.

	* generic/tkGrab.c (Tk_GrabObjCmd): Tcl_Obj'ified [grab] command.

	* generic/tkInt.h: Removed Tk_AfterCmd function prototype; the
	function does not exist (since 4.0p3).  Cleaned up some line
	wrapping.

	* generic/tk.h: Removed "#define Tk_AfterCmd Tcl_AfterCmd";
	nothing in the core uses Tk_AfterCmd, and Tcl_AfterCmd doesn't exist
	anymore anyway.

	* generic/tkInt.h: Replace Tk_BindCmd prototype with
	Tk_BindObjCmd prototype.

	* generic/tkWindow.c: Updated "bind" command entry to use
	Tcl_Obj'ified command.

	* generic/tkCmds.c (Tk_BindObjCmd): Tcl_Obj'ified [bind] command.

	* tests/bind.test: Tweaked expected error messages for [bindtags]
	to comply with updated error messages.

	* generic/tkMenu.c (CloneMenu): Replaced calls to Tk_BindtagsCmd
	with equivalent calls to Tk_BindtagsObjCmd.

	* generic/tkInt.h: Replace Tk_BindtagsCmd prototype with
	Tk_BindtagsObjCmd prototype.

	* generic/tkWindow.c: Updated "bindtags" command entry to use
	Tcl_Obj'ified command.

	* generic/tkCmds.c (Tk_BindtagsObjCmd): Tcl_Obj'ified [bindtags]
	command.

2000-08-02  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkCmds.c (Tk_TkwaitObjCmd): Tcl_Obj'ified [tkwait] command.

	* generic/tkWindow.c: Updated "tkwait" command entry to use
	Tcl_Obj'ified command.

	* generic/tkInt.h: Replace Tk_TkwaitCmd prototype with
	Tk_TkwaitObjCmd prototype.

	* generic/tkGrid.c (Tk_GridCmd): Split [grid] subcommands into
	separate functions instead of inlining them all in Tk_GridCmd.

2000-08-01  Eric Melski  <ericm@ajubasolutions.com>

	* generic/tkInt.h: Replaced prototype for Tk_MessageCmd with
	prototype for Tk_MessageObjCmd.

	* generic/tkWindow.c: Marked message command as using the new
	MessageObjCmd instead of the old MessageCmd.

	* tests/message.test: Added tests for the message widget.

	* generic/tkMessage.c: Obj'ified the message widget.

	* generic/tkInt.h: Removed prototype for Tk_ClipboardCmd, added
	prototype for Tk_ClipboardObjCmd.

	* generic/tkWindow.c: Updated function pointers for clipboard
	command to use Tcl_Obj version.

	* tests/clipboard.test: Updated tests to expect standard error
	messages.

	* generic/tkClipboard.c (Tk_ClipboardObjCmd): Obj'ified
	Tk_ClipboardCmd -> Tk_ClipboardObjCmd.

2000-07-28  Eric Melski  <ericm@ajubasolutions.com>

	* unix/tkUnixButton.c (TkpDisplayButton): Added bits to change
	the indicator color when radio-/check-buttons are disabled.  This
	reduces the visual incongruity when a group of these controls are
	disabled together.

	* win/tkWinMenu.c (ReconfigureWindowsMenu): Added MF_GRAYED bit
	for disabled menu entries, to ensure that those which are drawn by
	the system are shown grayed (such as entries on menubars) [Bug: 4372].

	* doc/label.n: Added -disabledforeground to list of options [Bug:
	6053].

	* mac/tkMacDefault.h:
	* unix/tkUnixDefault.h: Added default values for listbox
	disabledforeground and state.

	* win/tkWinDefault.h: Changed default listbox background color to
	white and listbox selection borderwidth to 0, in keeping with the
	"Microsoft Windows User Experience"; added default values for
	listbox disabledforeground and listbox state.

	* doc/listbox.n: Added documentation for -state option.

	* generic/tkListbox.c: Added support for -state to listbox. [RFE:
	6052].

	* tests/listbox.test: Tests for listbox disabled state.

2000-07-27  Mo DeJong  <mdejong@redhat.com>

	* win/configure.in: TCL_STUB_LIB_FLAG and
	TK_STUB_LIB_FLAG should not include ${TCL_DBGX}
	in win/tkConfig.sh, fix that.

2000-07-25  Joe English  <jenglish@flightlab.com>

	* doc: CanvPsY.3, ConfigWidg.3, CrtImgType.3, CrtItemType.3,
	FontId.3, GetFont.3, canvas.n, font.n, options.n, text.n:
	Documentation fix: Replaced references to XFontStruct *
	and Tk_FontStruct with Tk_Font.

2000-07-24  Eric Melski  <ericm@ajubasolutions.com>

	* tests/text.test: Added tests for -regexp -nocase searches with
	backslash character classes.

	* generic/tkText.c (TextSearchCmd): Text search did not work
	properly when -regexp and -nocase were used, in combination with
	backslash character classes represented by capital letters (ie,
	\W, \M); altered implementation of -regexp -nocase searches to use
	new regexp interfaces to fix this problem.  [Bug: 5988].

2000-07-21  Eric Melski  <ericm@ajubasolutions.com>

	* tests/text.test: Added tests for searching when text is elided.

	* generic/tkText.c (TextSearchCmd): Text search was not returning
	the correct index when the search covered (but did not search)
	elided characters; corrected this by adjusting the match index by
	the number of elided characters preceeding the start of the match,
	just as is done with embedded windows, etc. [Bug: 5470].

2000-07-21  Mo DeJong  <mdejong@redhat.com>

	* win/configure.in: Add TK_STUB_LIB_FLAG and
	TK_BUILD_STUB_LIB_SPEC. These are needed to build a stub enabled
	extension.

2000-07-20  Eric Melski  <ericm@ajubasolutions.com>

	* unix/tkUnixDraw.c (TkScrollWindow): Replaced a use of a trinary
	operator with an if/else, to avoid build problems on some
	platforms [Bug: 5819].

	* win/makefile.vc: Applied patch from Don Porter to enhance nmake
	support on NT/Alpha [RFE: 5939].

2000-07-19  Eric Melski  <ericm@ajubasolutions.com>

	* library/text.tcl: Enhanced <Tab> binding to behave like normal
	<Tab> bindings when the text widget is disabled (ie, it advances
	focus to the next widget).

	* generic/tkText.c (TextSearchCmd): Added a test for a NULL
	segment pointer when doing backwards searches for "" on an empty
	text widget. [Bug: 6007].

2000-07-18  Mo DeJong  <mdejong@redhat.com>

	* unix/aclocal.m4: Use tcl.m4.

	* unix/configure.in: Properly quote LOCALES variable. Properly quote
	argument to m4 macro.

	* unix/tcl.m4: Add updated file from tcl.

	* win/tcl.m4: Updated file from tcl.

2000-07-18  Eric Melski  <ericm@ajubasolutions.com>

	* library/tkfbox.tcl: Fixed keyboard navigation in the iconlist.

	* unix/configure.in (MAKE_LIB): Corrected definition of MAKE_LIB
	for shared builds, with patch from Mike Hopkirk.

2000-07-18  Mo DeJong  <mdejong@redhat.com>

	* win/Makefile.in: Fix TCL_GENERIC_DIR variable
	so that it uses the TK_SRC_DIR in the same way
	as the unix version.

2000-07-17  David Gravereaux  <davygrvy@ajubasolutions.com>

	* generic/tkConsole.c: Added comments for a Win2K OS bug with
	GetStdHandle(STD_OUTPUT_HANDLE).  No change was done to the code
	as the resulting behaviour of ShouldUseConsoleChannel() was
	correct, anyways. [BUG: 5971]

2000-07-17  Eric Melski  <ericm@scriptics.com>

	* generic/tkStubImg.c (Tk_InitImageArgs): Applied patch from [Bug:
	5990], from Anselm Lingnau, which correctly sets the value of
	useNewImage to 0 when the new image system is not to be used,
	instead of leaving it at -1, which causes the check to be
	performed more times than is really necessary.

	* library/bgerror.tcl: Fixed a typo in one of the bgerror dialog
	label.

	* library/msgs/it.msg: Italian message catalog, from Paolo
	Brutti. [RFE: 6012].

2000-07-07  Eric Melski  <ericm@ajubasolutions.com>

	* library/msgs/el.msg: Greek message catalog, from George Petasis.

2000-07-07  Mo DeJong  <mdejong@redhat.com>

	* win/configure.in: Fix subst of TK_SHARED_BUILD
	variable in tkConfig.sh.in. Fix definition of
	TK_SRC_DIR variable so that it matches the
	unix version.

2000-07-05  Mo DeJong  <mdejong@redhat.com>

	* generic/tkFileFilter.c (AddClause): Cast to match function prototype.
	* win/stubs.c (_XInitImageFuncPtrs): Add return value for function.
	* win/tkWinButton.c (buttonStyles, ButtonBindProc, ComputeStyle):
	Remove unused declarations.
	* win/tkWinColor.c (GetColorByName, GetColorByValue): Remove unused
	function declarations.
	* win/tkWinDialog.c (TrySetDirectory): Remove unused function
	declaration.
	* win/tkWinEmbed.c (TkWinEmbeddedEventProc): Cast to match function
	prototype.
	* win/tkWinMenu.c (winMenuMutex, MenuExitProc): Remove unused
	declaration.
	* win/tkWinWindow.c (StackWindow): Remove unused declaration.
	* win/tkWinWm.c (ConfigureEvent): Remove unused declaration.
	* win/tkWinX.c (winXMutex): Remove unused declaration.
	* xlib/ximage.c (XCreateBitmapFromData): Cast to match function
	prototype.

2000-07-05  Eric Melski  <ericm@ajubasolutions.com>

	* tests/imgPhoto.test: Added test for GIF writing code [Bug: 5823].

	* generic/tkImgGIF.c: Applied patch from Jan Nijtmans to fix a
	problem with the GIF writing code [Bug:	5823].

	* generic/tkCursor.c: Added initialization for nextPtr field of
	TkCursor, patch from Nijtmans/Howlett.

2000-07-05  Eric Melski  <ericm@ajubasolutions.com>

	* library/msgs/nl.msg: Dutch message catalog for dialogs, from Jan
	Nijtmans.

2000-06-30  Eric Melski  <ericm@scriptics.com>

	* doc/keysyms.n:
	* doc/colors.n: Added extra .CE/.CS pairs to break up the large
	text block, so that the generated Windows help file could
	accomodate the manual entry. [Bug: 5862]

	* tests/filebox.test: Adjusted tests to accomodate -multiple.

	* library/xmfbox.tcl: Adjusted arguments list construction such
	that -multiple is not presented as an option for tk_getSaveFile.

	* library/tk.tcl: Added test for safe interpreter status before
	attempting to load message catalogs (which is impossible in a
	standard safe interpreter).  This means that SafeTk will not have
	localized dialogs, unless a means is found for loading the message
	catalog files.

2000-06-29  Eric Melski  <ericm@scriptics.com>

	* library/msgs/de.msg: German message catalog.

	* library/msgs/en.msg: English message catalog.

	* library/msgs/es.msg: Spanish message catalog.

	* library/msgs/fr.msg: French message catalog.

	* unix/Makefile.in:
	* unix/configure.in:
	* library/tk.tcl:
	* library/clrpick.tcl:
	* library/choosedir.tcl:
	* library/console.tcl:
	* library/msgbox.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:
	* library/bgerror.tcl: Applied patches from Laurent Duperval to
	provide localization of Tk dialogs. [RFE: 2671].

2000-06-27  Eric Melski  <ericm@scriptics.com>

	* generic/tkMenu.c (DeleteMenuCloneEntries): Applied fix from
	[Bug: 5275], which corrected a segfault-causing indexing problem
	when deleting entries from torn-off menus.

2000-06-22  Eric Melski  <ericm@ajubasolutions.com>

	* doc/getOpenFile.n: Updated with information about -multiple.

	* library/choosedir.tcl: Tweaked to handle modified tkIconList API's.

	* library/tkfbox.tcl: Preliminary implementation of multiple
	selection; based on patch from [RFE: 604].  Some of the tkIconList
	functions changed to support this and to make the dialog faster.

	* library/xmfbox.tcl: Added support for multiple selection, from
	patch in [RFE: 4999].

2000-06-21  Eric Melski  <ericm@scriptics.com>

	* library/text.tcl: Corrected behavior of text widget with respect
	to this sequence of events:  click, shift-click.  Previously, the
	shift-click just moved the cursor and anchor; now, the shift-click
	will select the text between the click and the shift-click, which
	is the behavior most users expect. [Bug: 5929].

2000-06-19  Eric Melski  <ericm@scriptics.com>

	* library/bgerror.tcl: Added auto-truncation for long error
	messages (more than 30 characters wide, or more than 4 lines
	long), so that the dialog remains a manageable size. [RFE: 5782]

2000-06-15  Eric Melski  <ericm@scriptics.com>

	* win/tkWinDialog.c: Patched to support tk_getOpenFile
	-multiple. [RFE: 604].

2000-06-13  Eric Melski  <ericm@scriptics.com>

	* win/aclocal.m4:
	* win/configure.in:
	* win/Makefile.in: Applied patch from [RFE: 5844], to provide
	support for the mingw compile environment for Windows.

2000-06-06  Jeff Hobbs  <hobbs@scriptics.com>

	8.4a1 RELEASE

2000-06-03  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/CrtCmHdlr.3: new doc for ClientMessage handler procs
	* generic/tk.h: added typdef for Tk_ClientMessageProc
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: Added Tk_CreateClientMessageHandler and
	Tk_DeleteClientMessageHandler declarations.
	* generic/tkEvent.c (Tk_HandleEvent): Added
	Tk_CreateClientMessageHandler and Tk_DeleteClientMessageHandler to
	allow adding event handlers that invoke for ClientMessage events.
	This is necessary to support unix dnd protocols.

2000-06-02  Jeff Hobbs  <hobbs@scriptics.com>

	* canvas.test: added test for 5783.
	* generic/tkCanvPoly.c (DisplayPolygon): added checks for the
	polygon fillGC not being empty to prevent segfault. [Bug: 5783]

2000-05-31  Eric Melski  <ericm@scriptics.com>

	* library/bgerror.tcl: Improved bgerror based on work by Donal
	K. Fellows; no longer dependant on tk_dialog; features a
	Windows-esque "Details" button, and a customizable extra function
	button that allows the user to (for example) save the stack trace
	to a file.

2000-05-30  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Changed defines for GIF87a/GIF89a to be
	static char arrays with integer initialization, to address EBCIDIC
	vs. ASCII encoding issues and to handle compilers that don't deal
	with "\xAB" syntax for specifying hex values in strings.

2000-05-28  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/spinbox.n: (new file) docs for spinbox widget
	* generic/tkInt.h: added Tk_SpinboxObjCmd declaration
	* generic/tkEntry.c: added 'spinbox' widget - an extension of the
	entry widget type.
	* generic/tkWindow.c: added 'spinbox' to core Tk commands
	* library/spinbox.tcl: (new file) binding and helper procs for spinbox
	* library/tk.tcl: added spinbox.tcl to list of files to source
	* tests/entry.test: updated changed error messages
	* tests/spinbox.test: (new file) test suite for spinbox

	* generic/tkPlace.c (Tk_PlaceCmd): reworked place master/slave
	table init'n to prevent seg fault when using place on multiple
	displays.

	* generic/tk.h: added comments ot Tk_FakeWin structure

2000-05-26  Eric Melski  <ericm@scriptics.com>

	* generic/tkOption.c (Tk_GetOption): Extended Tk_GetOption to
	support a new syntax for option names in option tables.  If the
	option name has an embedded ".", it indicates that the name field
	contains both an option name and an overriding widget class, in
	the form "class.option".  The lookup for the option value will be
	performed as though the widget class is that specified, rather
	than the actual widget class.
	(SetupStacks): Replaced several lines of array element copying
	with a for loop for conciseness.

2000-05-25  Eric Melski  <ericm@scriptics.com>

	* library/button.tcl: Tweaks for -overrelief handling on Windows.

	* doc/radiobutton.n: Added documentation for -overrelief option.

	* doc/checkbutton.n: Added documentation for -overrelief option.

	* doc/label.n: Added documentation for -state option.

	* generic/tkButton.c: Added -overrelief option for checkbuttons,
	and radiobuttons.

	* library/button.tcl (tkButtonDown, macintosh version): Added
	protection against querying the -repeatdelay option from a widget
	that doesn't support it (ie, checkbuttons, radiobuttons, etc).
	Other platforms use a different binding script for checkbuttons
	and radiobuttons, so they don't have this issue.
	(tkCheckRadioEnter, windows version):  Added code to handle
	-overrelief for check/radiobuttons on windows.

2000-05-22  Eric Melski  <ericm@scriptics.com>

	* generic/tkButton.c: Added -activeforeground, -activebackground
	for labels, for the -state option.

	* doc/label.n: Added documentation for -state option,
	-activeforeground, -activebackground.

2000-05-22  Jeff Hobbs  <hobbs@scriptics.com>

	* win/Makefile.in (install-libraries): corrected to install X
	headers [Bug: 5516]

	* doc/bind.n:
	* doc/canvas.n:
	* doc/entry.n:
	* doc/listbox.n:
	* doc/photo.n: doc fix-ups [Bug: 5396]

2000-05-17  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/bell.n:
	* tests/bell.test:
	* generic/tkCmds.c (Tk_BellObjCmd): added -nice option to
	optionally avoid resetting screen saver [Bug: 4279]

2000-05-15  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c (Tk_WmCmd): changed wm deiconify from using idle
	callback to calling restack and focus code immediately.

2000-05-17  Eric Melski  <ericm@scriptics.com>

	Overall change:  Added "-readonlybackground" option for entries,
	to enable a visual change when state goes to readonly.

	* mac/tkMacDefault.h (DEF_ENTRY_READONLY_BG_COLOR)
	(DEF_ENTRY_READONLY_BG_COLOR):
	* win/tkWinDefault.h (DEF_ENTRY_READONLY_BG_COLOR)
	(DEF_ENTRY_READONLY_BG_COLOR):
	* unix/tkUnixDefault.h (DEF_ENTRY_READONLY_BG_COLOR)
	(DEF_ENTRY_READONLY_BG_COLOR): Added default values for entry
	-readonlybackground option.

	* generic/tkEntry.c: Added -readonlybackground option, cleaned up
	excessive use of graphics contexts.

	* tests/entry.test: Added configuration test for
	-readonlybackground option.

	* doc/entry.n: Added documentation for -readonlybackground option.

	Overall change:  changed implementation of "link" relief for
	buttons.  Instead of a new relief style (-relief link), there is a
	new option, -overrelief, which if set is used when the mouse is
	over the button.

	* doc/SetOptions.3: Added information about TK_OPTION_NULL_OK with
	TK_OPTION_RELIEF.

	* win/tkWinButton.c: Removed bits about TK_RELIEF_LINK.

	* tests/button.test: Added tests for -overrelief; removed tests
	for -relief link.

	* mac/tkMacButton.c: Removed bits about TK_RELIEF_LINK.

	* generic/tkOldConfig.c: Removed bits about TK_RELIEF_LINK.

	* generic/tkConfig.c: Removed bits about TK_RELIEF_LINK; added
	support for TK_OPTION_NULL_OK for TK_OPTION_RELIEF.

	* library/button.tcl: Added binding support for -overrelief.

	* generic/tk3d.c (Tk_GetRelief): Added branch for TK_RELIEF_NULL.

	* generic/tkButton.c: Added -overrelief option; removed
	Enter/Leave EventProc masks and handlers.

	* generic/tk.h: Added TK_RELIEF_NULL definition, removed
	TK_RELIEF_LINK.

	* mac/tkMacDefault.h (DEF_BUTTON_OVER_RELIEF):
	* win/tkWinDefault.h (DEF_BUTTON_OVER_RELIEF):
	* unix/tkUnixDefault.h (DEF_BUTTON_OVER_RELIEF): Added default
	value for the -overrelief option.

2000-05-16  Eric Melski  <ericm@scriptics.com>

	* win/tkWinMenu.c (ReconfigureWindowsMenu): Added code to add the
	MF_SEPARATOR bit for SEPARATOR_ENTRY menu items.  This causes
	separator entries on the system menu to be drawn correctly [Bug: 5451].

2000-05-15  Eric Melski  <ericm@scriptics.com>

	* doc/image.n: Added documentation for [image inuse] command.

	* tests/image.test: Added tests for [image inuse] command.

	* generic/tkImage.c (Tk_ImageObjCmd): Added [image inuse] command,
	which provides a means for programmers to determine if a given
	image is in use by any widgets. [RFE: 3327].

2000-05-14  Eric Melski  <ericm@scriptics.com>

	* doc/clipboard.n: Added documentation for "clipboard get".

	* generic/tkClipboard.c (Tk_ClipboardCmd): Added "clipboard get"
	subcommand [RFE: 4628].

	* tests/clipboard.test: Updated to use "clipboard get" instead of
	"selection get -s CLIPBOARD".

	* library/entry.tcl: Adjusted Button-1 binding to set focus to the
	entry when it is readonly or normal.

	* doc/entry.n: Added documentation for readonly state,
	-disabledforeground, -disabledbackground.

	* tests/entry.test: Added tests for readonly state.

	* generic/tkEntry.c: Added support for "readonly" state, and
	redefined "disabled" state.  A disabled entry will display its
	text in a dimmed color and possibly with a different background,
	and will be completely unusable (no selection, no editing).  A
	readonly entry will look like a normal entry, but it will not be
	editable; selection is still allowed. [RFE: 4239].  To support the
	new disabled state properly, "-disabledforeground" and
	"-disabledbackground" options were added.
	*** THIS IS A BACKWARDS INCOMPATIBLE BEHAVIOR CHANGE ***

	* win/tkWinDefault.h:
	* mac/tkMacDefault.h:
	* unix/tkUnixDefault.h: Added DEF_ENTRY_DISABLED_FG,
	DEF_ENTRY_DISABLED_BG_COLOR, DEF_ENTRY_DISABLED_BG_MONO.

2000-05-12  Eric Melski  <ericm@scriptics.com>

	* unix/tkUnixButton.c (TkpDisplayButton, TkpComputeButtonGeometry):
	* mac/tkMacButton.c (TkpDisplayButton, TkpComputeButtonGeometry):
	* win/tkWinButton.c (TkpDisplayButton, TkpComputeButtonGeometry):
	Added code for drawing compound buttons.

	* tests/button.test: Added configuration tests for -repeatdelay,
	-repeatinterval, -compound.

	* library/button.tcl: Added support for -repeatedelay,
	-repeatinterval options.

	* generic/tkOldConfig.c: Changed handling of link relief so that
	proper error messages are used.

	* generic/tkButton.h: Added -compound, -repeatdelay,
	-repeatinterval options.

	* generic/tkButton.c: Added event watchers for enter/leave events,
	for link relief support.

	* generic/tk3d.c: Changed handling of link relief so that proper
	error messages are used.

	* generic/tk.h: Changed values of
	TK_OPTION_LINK_OK/TK_CONFIG_LINK_OK for link relief support.

2000-05-12  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinFont.c (LoadFontRanges): improved support for all chars
	in 0-255 range for bitmap ANSI fonts.  May be improved to handle
	bitmap non-ANSI fonts in the future. [Bug: 2172]

	* win/tkWinWm.c (RaiseWinWhenIdle): added TK_DONT_DESTROY_WINDOW
	to flag check to prevent timing related core dump. [Bug: 5438]

2000-05-11  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinTest.c (TestclipboardObjCmd): ensured CloseClipboard
	would always get called for each OpenClipboard.

	* tests/focus.test (focusSetupAlt): removed wm withdraw from proc
	as it would cause a hang for tkwait visibility

	* tests/menu.test:
	* generic/tk3d.c:
	* generic/tkColor.c:
	* generic/tkCursor.c: corrected handling of 3DBorder, Cursor and
	Color objects on multiple screens. [Bug: 5454]

2000-05-09  Eric Melski  <ericm@scriptics.com>

	* doc/button.n: Added documentation for link relief.

	* tests/button.test: Added tests for link relief for buttons.

	* generic/tk.h (TK_CONFIG_LINK_OK): Added definition of
	TK_RELIEF_LINK, TK_OPTION_LINK_OK and TK_CONFIG_LINK_OK. [RFE: 4348]

	* generic/tk3d.c: Added support for link relief. [RFE: 4348]

	* mac/tkMacButton.c (TkpDisplayButton):
	* unix/tkUnixButton.c (TkpDisplayButton): Added support for link
	relief. [RFE: 4348]

	* generic/tkOldConfig.c (Tk_ConfigureWidget):
	* generic/tkConfig.c (DoObjConfig): Added understanding of link
	relief, which is allowed only for widgets that have
	TK_OPTION_LINK_OK or TK_CONFIG_LINK_OK set for the "-relief"
	option. [RFE: 4348]

	* generic/tkButton.c: Added TK_OPTION_LINK_OK to "-relief" option
	for buttons. [RFE: 4348]

	* win/tkWinWm.c (EX_TRANSIENT_STYLE): Removed WS_EX_TOOLWINDOW
	style bit, so that transient windows have full-size titlebars
	(like the tk_getOpenFile dialog).

	* win/tkWinMenu.c (GetMenuSeparatorGeometry): Tweaked height
	requested for separator bars to be (linespace - (2*descent))
	instead of just (linespace); this makes the separator occupy a
	more correct amount of vertical space. [Bug: 5303].

2000-05-09  Jeff Hobbs  <hobbs@scriptics.com>

	* library/focus.tcl: fixed calling of takeFocus proc [Bug: 5372]

2000-05-02  Jeff Hobbs  <hobbs@scriptics.com>

	* README:
	* generic/tk.h:
	* library/tk.tcl:
	* mac/README:
	* unix/README:
	* unix/configure.in:
	* unix/tk.spec:
	* win/README:
	* win/aclocal.m4:
	* win/configure.in:
	* win/makefile.vc: updated patchlevel to 8.4a1

	* unix/Makefile.in: added tk.spec to dist target

2000-04-27  Eric Melski  <ericm@scriptics.com>

	* doc/Tk_Init.3: Added Tk_SafeInit information [Bug: 1884].

	* doc/keysyms.n: Man page enumerating keysyms [RFE: 1645].

	* doc/colors.n: Man page enumerating valid color names [RFE: 1645].

	* doc/cursors.n: Man page enumerating valid cursor values [RFE: 1645].

	* library/msgbox.tcl: Corrected Unix tk_messageBox implementation
	to make the first button the default when no default is specified
	[Bug: 2218].

	* doc/messageBox.n: Updated documentation with regards to
	selection of default button when none is specified (now it will
	use the first button as the default in that case) [Bug: 2218].

2000-04-26  Jeff Hobbs  <hobbs@scriptics.com>

	8.3.1 RELEASE

	* README:
	* mac/README:
	* unix/README:
	* unix/tk.spec:
	* win/README: Updating URLs to reference dev.scriptics.com

2000-04-25  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/Makefile.in:
	* win/Makefile.in: makefile cleanup

2000-04-25  Eric Melski  <ericm@scriptics.com>

	* generic/tkMain.c: Fixed function header comment for Tk_MainEx.

	* unix/mkLinks:
	* doc/GetScroll.3: Added information about Tk_GetScrollInfoObj
	[Bug: 1866].

2000-04-24  Eric Melski  <ericm@scriptics.com>

	* unix/mkLinks:
	* doc/Grab.3: Man page for Tk_Grab and Tk_Ungrab [Bug: 1868, 1889]

	* unix/mkLinks:
	* doc/MainWin.3: Added entry for Tk_GetNumMainWindows [Bug: 1865].

	* unix/mkLinks:
	* doc/GetHINSTANCE.3: Man page for Tk_GetHINSTANCE [Bug: 1862].

2000-04-24  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImage.c (Tk_PostscriptImage): added check to create
	necessary prolog for photos
	* generic/tkCanvPs.c: added Tk_PostscriptPhoto that outputs PS for
	photo images
	* generic/tkImgPhoto.c: new func ImgPhotoPostscript and added that
	in as ps proc in tkPhotoImageType.
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: added Tk_PostscriptPhoto

	* generic/tkConfig.c (DoObjConfig): removed direct setting of
	interp->result.

	* mac/tkMacWm.c (Tk_WmCmd): initialized gotToplevel in
	colormapwindows case (bug found by Reasoning, Inc's automated code
	testing).

2000-04-24  Eric Melski  <ericm@scriptics.com>

	* unix/mkLinks:
	* doc/GetHWND.3: Man page for Tk_GetHWND [Bug: 1863].

	* unix/mkLinks:
	* doc/HWNDToWindow.3: Man page for Tk_HWNDToWindow [Bug: 1869].

	* unix/mkLinks:
	* doc/AddOption.3: Man page for Tk_AddOption [Bug: 1854]

2000-04-22  Jim Ingham	<jingham@cygnus.com>

	* mac/tkMacDialog.c (Tk_MacGetOpenFile): Add empty bodies for the
	"-initialfile" and "-defaultextension" options.

	* mac/tkMacDialog.c (NavServicesGetFile): Only cons the result up
	into a list if multiple is true.

	* mac/tkMacMenus.c (SourceDialog): Use the "tk_getOpenFile"
	instead of hand-coding the dialog with StandardGetFile.  This way
	we get the Navigation dialogs for free.

	* doc/getOpenFile.n: Document the -multiple and -message flags
	which are only implemented on the Mac.  Also note that the -title
	works on the Mac with Nav Services installed.

2000-04-19  Eric Melski  <ericm@scriptics.com>

	* doc/WinViewable.3:
	* unix/mkLinks: Removed docs for Tk_IsViewable.

	* win/tkWinDialog.c: Removed calls to Tk_IsViewable.

	* generic/tkUtil.c:
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tkCmds.c:
	* generic/tk.decls: Removed Tk_IsViewable function (it was not
	actually needed).

2000-04-19  Jeff Hobbs  <hobbs@scriptics.com>

	* win/aclocal.m4: made SC_PROG_TCLSH search specifically for
	tclsh*.exe type files to find an executable.

	* win/Makefile.in: fixed up cleanup, winhelp, cat32 targets

	* library/console.tcl: made console use systemfixed font on Win

	* generic/tkEntry.c: removed unnecessary ENTRY_VALIDATE #define

2000-04-19  Eric Melski  <ericm@scriptics.com>

	* generic/tkRectOval.c (ConfigureRectOval): Added checks for valid
	outline settings before creating of outline GC; this means that it
	is really possible now to have an oval or rectangle with no
	outline.  [Bug: 5029].

2000-04-19  Jeff Hobbs  <hobbs@scriptics.com>

	* library/choosedir.tcl (::tk::dialog::file::chooseDir::Config):
	* library/tkfbox.tcl (::tk::dialog::file::Config): removed the
	extraneous glob on -initialdir after file isdir already returned 1
	and moved cd trick into this case as the else already uses [pwd].
	[Bug: 5181]

	* win/winMain.c: moved extern call out of WinMain func

	* README:
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in: bumped to version 8.3.1

	* library/msgbox.tcl (tkMessageBox): changed to use grid in some
	places, realign icon to anchor nw.

	* mac/tkMacScale.c: reverted tkMacScale.c to 1.5 equivalent (it
	was accidentally bumped forward).

2000-04-18  Eric Melski  <ericm@scriptics.com>

	* win/tkWinPointer.c: Changed Mod2Mask in TkWinGetModifierState to
	ALT_MASK, to fix some event problems [Bugs: 1160, 5088].

	* win/tkWinX.c: Changed Mod2Mask in GetState to ALT_MASK, to fix
	some event problems [Bugs: 1160, 5088].

	* generic/tkInt.h: Moved definition of ALT_MASK and META_MASK here
	so that it would be accessible from other modules than tkBind.c.

	* generic/tkBind.c: Added code in BindEvent to check for ALT_MASK
	and META_MASK in the event state field, as this field may not be
	set up with the correct display modifier mask bits if the XEvent
	structure was created by [event generate] or by the Windows X
	emulation. [Bugs: 1160, 5088].

2000-04-18  Scott Redman  <redman@HILO>

	* win/tk.rc:
	* win/wish.rc:
	* win/wish.ico:  Modified copyright dates in Windows resource
	files.  Updated the icon for wish.exe.

2000-04-17  Eric Melski  <ericm@scriptics.com>

	* win/tkWinDialog.c: Added checks for visibility of parent window
	before creating MessageBox and ChooseColor dialogs; this prevents
	the application from locking when the parent is withdrawn and the
	message box is created.  In these cases, the window will be
	created without a parent.

	* unix/mkLinks: Added WinViewable.3.

	* tests/msgbox.test: Added tests for patch from [Bug: 4997].

	* library/msgbox.tcl:
	* library/dialog.tcl: Applied patch from [Bug: 4997]; detaches
	dialog window from parent if parent is not viewable.

	* library/bgerror.tcl: Removed workaround from [Bug: 4370]; this
	is superceeded by patches to dialog.tcl.

	* generic/tkCmds.c: Changed WinfoObjCmd to use Tk_IsViewable
	function to determine visibility of windows instead of inlining
	the code.

	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tk.decls: Added Tk_IsViewable declaration.

2000-04-17  Eric Melski  <ericm@scriptics.com>

	* library/text.tcl: Tweaked double-/triple-click selection;
	previously, anchor and insert marks were placed in unexpected
	locations following a double or triple click.  Now they are placed
	logically.  Also tweaked the extension of selection via
	shift-double-clicks so that it no longer selects the contiguous
	whitespace on the side of the selection opposite the
	double-click. [RFE: 4253].

	* doc/menu.n: Added note regarding rendering of
	checkbuttons/radiobuttons in menubars on different platforms --
	some systems do not draw indicators for check/radiobuttons in
	menubars.

	* library/menu.tcl: Corrected behavior of
	checkbuttons/commands/radiobuttons in menubars [Bug: 630].

	* tests/grid.test: Added test for [grid propagate . 0] to not toggle.

	* generic/tkGrid.c: Fixed bogus logic in [grid propagate] that
	caused [grid propagate . 0] to act as a toggle instead of an
	absolute set. [Bug: 2286].

2000-04-16  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinColor.c (FindSystemColor): correct calculation of
	colors when shifting value. [Bug: 4919]

2000-04-16  Jim Ingham  <jingham@cygnus.com>

	* mac/tkMacPort.h: protect against strncasecmp already defined -
	it is in the Pro5 version of MSL.

	* mac/tkMacWindowMgr.c (GenerateKeyEvent): Check for a null tkWin.
	If the hidden window we use for double-buffering controls manages
	to percolate to the top (should never happen, but...) this will
	keep us from crashing.

	* mac/tkMacButton.c (InitSampleControls): Hide the
	double-buffering window BEHIND the first "." window you can find.
	This will keep it from ever being the front window, and thus a
	black hole for events.  * mac/tkMacButton.c (ButtonEventProc):
	Disable the controls when the window is in the background.  This
	is required by the MacOS HIG. This doesn't always get called when
	it should, it still needs more work.

	* mac/tkMacDialog.c: Pretty substantial rewrite to include
	Navigation Services support for systems which have it.

2000-04-14  Eric Melski  <ericm@scriptics.com>

	* win/tkWinKey.c: Added check for ASCII delete character in
	KeycodeToKeysym, to fix [Bug: 5090].  See comment in code for more
	information.

	* generic/ks_names.h: Added Scroll_Lock and Sys_Req definitions.

	* win/tkWinKey.c: Changed implementation of KeycodeToKeysym,
	et. al., to use a keycode table for lookups; this will result in
	faster keycode -> keysym translations for non-ASCII keys like
	Control, Alt, etc.

2000-04-14  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c (WmProc): added check in WM_MOUSEACTIVATE so we
	correctly activate native menus when clicking in when we didn't
	have focus [Bug: 2272]

	* generic/tkCanvas.c (CanvasEventProc:2451): corrected cast

	* generic/tkEntry.c (Tk_EntryObjCmd): adjusted finishing error
	cases and changed TK_CONFIG_NULL_OK to TK_OPTION_NULL_OK

	* tests/scale.test:
	* generic/tkScale.c:
	* generic/tkScale.h:
	* unix/tkUnixScale.c:
	* mac/tkMacScale.c: moved (PixelToValue|ValueToPixel|SetScaleValue)
	to tkScale.c.  Caused an associated variable to be immediately set
	[Bug: 4833]

	* library/scale.tcl (tkScaleActivate): reduced number of scale
	redisplays by checking current value of state before setting it
	again.  [Bug: 4191]

	* tests/winDialog.test: tk_chooseDirectory seems to get a noop
	from GetOpenFileName in the static build, hanging some tests.
	The tests were fixed to timeout (noop cause unknown).

	* unix/aclocal.m4 (SC_ENABLE_THREADS): enhanced the detection of
	pthread_mutex_init [Bug: 4359] and (SC_CONFIG_CFLAGS) added
	--enable-64bit-vis switch for Sparc VIS compilation [Bug: 4995]

2000-04-13  Eric Melski  <ericm@scriptics.com>

	* win/tkWinKey.c: Added smarts to check whether the left or right
	Control, Shift, or Alt key was pressed.  [Bug: 870].

	* win/tkWinMenu.c: Corrected code that created separator items on
	menus; originally, it requested that the system be responsible for
	drawing those items, so it would ignore configuration items like
	the widget background.  Now, we draw the separators ourselves (as
	we do with every other kind of menu item already). [Bug: 1166].

	* win/tkWin3d.c:
	* unix/tkUnix3d.c: Applied patch from [RFE: 2501]: adds more
	sophisticated smarts to TkpGetShadows, so that the highlight of a
	very bright color is actually distinguishable from the color, and
	the shadow of a very dark color is similarly distinguishable from
	the color.

	* generic/tkCanvas.c: Applied patch from [Bug: 4202]; adds a check
	for NULL tkwin in Tk_CanvasEventuallyRedraw.

2000-04-12  Jeff Hobbs  <hobbs@scriptics.com>

	* test/winClipboard.test:
	* win/tkWinInt.h:
	* win/tkWinClipboard.c (UpdateClipboard):
	* win/tkWinX.c (GenerateXEvent): added updatingClipboard tsd and
	TkWinUpdatingClipboard accessor function to allow us to flag
	ourselves when we are the ones updating the clipboard.  This
	corrected inability to create our own clipboard types within a Tk
	application.  [Bug: 2338 4318]
	* win/tkWinTest.c (TestclipboardCmd): improved TestclipboardCmd
	with better error handling and obj'ification

2000-04-11  Eric Melski  <ericm@scriptics.com>

	* msgcat.n: Added docs for new behavior from patch in [Bug: 4158].

	* msgcat.test: Added tests for new behavior from patch in [Bug:
	4158].

	* msgcat.tcl: Applied patch from [Bug: 4158], which enables
	msgcat::mc to search the entire namespace ancestry chain for
	message translations (ie, first it checks the current namespace,
	then the parent, then the parent's parent, etc).  Also allows the
	specification of additional args for msgcat::mc; if extra args are
	given, the [format] command is used to substitute the additional
	args in the translated message.

	* library/bgerror.tcl: Moved check for withdrawn state after check
	for tkerror; this was causing problems when tkerror was used.

2000-04-10  Eric Melski  <ericm@scriptics.com>

	* library/bgerror.tcl: Added check for withdrawn state of . and
	unsetting of transient bit for .bgerrorDialog if . is not
	viewable; this protects against the application hanging on systems
	like Windows, where transient windows are withdrawn with their
	parents. [Bug: 4370].

	* tests/event.test: Added test for [event generate $widget
	<Alt-z>] [Bug: 4611].

	* tests/choosedir.test: Changed "namespace import ::tcltest" to
	"namespace import -force ::tcltest".

	* win/tkWinKey.c:
	* unix/tkUnixKey.c:
	* mac/tkMacKeyboard.c: Changed InitKeymapInfo to
	TkpInitKeymapInfo. [Bug: 4611].

	* generic/tkStubInit.c:
	* generic/tkIntDecls.h: Re-gen'd from tkInt.decls.

	* generic/tkInt.decls: Added TkpInitKeymapInfo to list of function
	decls.

	* generic/tkBind.c (HandleEventGenerate): Added code to initialize
	keymap info if necessary, and to correctly set modifier bits in
	XEvent structure create to handle [event generate] calls.
	Previously, the alt/meta bits were not set correctly, so [event
	generate $widget <Alt-z>] would always fail. [Bug: 4611]

2000-04-07  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkGrid.c (InitMasterData): fixed uninit'd data in
	GridMaster struct [Bug: 4387]

	* library/safetk.tcl (disallowTk): made disallowTk work in the
	simple case.

	* library/comdlg.tcl (tkFocusGroup_In): fixed key navigation
	problems in dialogs under CDE [Bug: 2960]

	* tests/winDialog.test: removed knownBug constraint from 5.16

	* win/tkWinFont.c (GetScreenFont): corrected adjustment against
	LC_FACESIZE limitation for NT [Bug: 4931]

	* win/makefile.vc (TKTEST_OBJS):
	* win/Makefile.in (TKTEST_OBJS): moved tkWinTest.c from normal
	objs to TKTEST_OBJS where it belonged.

2000-04-03  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkTest.c: fixed incorrect platform inclusion for
	TkplatformtestInit (it would never get called).

	* unix/Makefile.in (MAN_INSTALL_DIR): patch to accept --mandir
	correctly [Bug: 4085]

	* library/clrpick.tcl (tkColorDialog_Config): error now thrown
	when -initialcolor "" specified. [Bug: 4198]

2000-03-31  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/DrawFocHlt.3: doc name correction

	* generic/tkEntry.c: set TK_OPTION_NULL_OK bit on -invcmd option
	and removed #ifdef ENTRY_VALIDATE expressions

	* library/menu.tcl (tkMenuInvoke): corrected naming of tearoffs
	[Bug: 4506]

	* library/tkfbox.tcl (tkIconList_Goto): caused browsecmd to be
	called in tkIconList_Select.  This causes the entry to be set
	properly when using the type-in-name-in-listbox bindings.

	* win/tkWinDialog.c: added unicode-aware open/save file dialogs

	* win/tkWinFont.c (TkpFontPkgInit): move private ref to platformId
	to TkWinGetPlatformId

	* win/tkWinMenu.c (SetDefaults): moved private use of versionInfo
	to TkWinGetPlatformId and removed all code for
	(versionInfo.dwMajorVersion < 4) (== Win32s)

	* win/tkWinX.c:
	* win/tkWin32Dll.c: moved TkWinGetPlatformId to tkWinX.c
	* win/tkWinInit.c: added TkWinXInit to TkpInit to ensure that its
	called for static Windows shells. [Bug: 3647]

	* win/tkWinInt.h:
	* win/tkWinX.c:
	* win/tkWinDraw.c (SetUpGraphicsPort):
	* win/tkWinScrlbr.c (UpdateScrollbar): removed use of tkpIsWin32s

	* win/tkWinInt.h (TkWinDCState struct): added bkmode value
	* win/tkWinDraw.c (TkWinGetDrawableDC, et al): added support for
	properly transparent dashed lines on Windows. [Bug: 4617]

2000-03-30  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Fixed some ANSI specific bits to avoid
	compile problems with non-ANSI compilers (ie, replace const with
	CONST, etc).  [Bug: 4223].

	* unix/configure.in: Applied patch from [Bug: 4237]; ensures that
	srcdir is fully qualified.

	* unix/Makefile.in: Applied patch from [Bug: 4237]; if tcltest was
	not compiled, make test/tktest failed.  Now it has a rule to build
	tcltest if it has not been built.

2000-03-28  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Moved an overlooked tkFDialog* function in
	::tk::dialog::file namespace.

	* tests/unixWm.test: Added tests for memory leak conditions in
	tkUnixWm.c.

	* tests/canvas.test: Added test for bad configuration options on
	empty and non-empty canvas.

	* generic/tkCanvas.c: Removed bad code in CANV_CONFIGURE block of
	CanvasWidgetCmd; this was causing non-empty canvases to improperly
	handle bad configuration options [Bug: 4456].

2000-03-27  Eric Melski  <ericm@scriptics.com>

	* unix/tkUnixWm.c: Applied patch from [Bug: 4405]; fixes memory
	leak in Unix wm command.

2000-03-24  Eric Melski  <ericm@scriptics.com>

	* tests/filebox.test:
	* tests/choosedir.test: Updated tests.

	* library/xmfbox.tcl: Updated to stash data array in
	::tk::dialog::file namespace instead of in global namespace.

	* library/tkfbox.tcl: Extended some functions to support creation
	of a choosedir dialog, to allow greater code reuse between the two
	dialogs.  Moved tkFDialog* functions into a namespace
	(::tk::dialog::file).  Because these are private Tk functions (and
	should thus not be used directly by users), this should not impact
	anybody (the tk_getOpenFile and tk_getSaveFile commands still
	exist at the global scope).

	* library/tk.tcl:
	* library/tclIndex: Updated function names for tkFDialog*
	functions and choosedir functions.

	* library/choosedir.tcl: New and improved implementation of
	tk_chooseDirectory dialog.  Based on tk_getOpenFile dialog.

2000-03-23  Eric Melski  <ericm@scriptics.com>

	* generic/tkWindow.c:
	* generic/tkInt.h: Updated Tcl_OptionCmd -> Tcl_OptionObjCmd

	* generic/tkOption.c: Tcl_Obj'ectified the "option" command.

2000-03-22  Eric Melski  <ericm@scriptics.com>

	* library/listbox.tcl (tkListboxCancel): Added a check for empty
	string value for tkPriv(listboxPrev).  Without this check, it's
	possible to get a stack trace under certain conditions. [Bug: 4373].

2000-03-15  Sven Delmas  <sven@scriptics.com>

	* win/tkWinDialog.c: Changed the behavior for the
	tk_chooseDirectory dialog under Windows. Instead of trying to
	return the currently selected listbox entry (which didn't work in
	case the user selected the initial directory anyway), we now
	return the value shown in the entry. This seems to be in
	accordance with the expected behavior for this dialog.

2000-03-14  Eric Melski  <ericm@scriptics.com>

	* tests/choosedir.test: Marked test 3.1 and 3.2 as bad until the
	issue with those tests on IRIX can be determined.

2000-03-10  Eric Melski  <ericm@scriptics.com>

	* library/menu.tcl: Applied patch from [Bug: 4155]; protects
	against grabs on non-viewable windows.

2000-03-08  Eric Melski  <ericm@scriptics.com>

	* tests/choosedir.test: Modified test 3.1 (-mustexist works) to be
	more careful about cleaning up its potentially troublesome after
	events.

2000-03-07  Eric Melski  <ericm@scriptics.com>

	* tests/button.test:
	* generic/tkButton.c: Added -disabledforeground/-state to labels.

2000-03-07  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/entry.test:
	* generic/tkEntry.c (EntrySetValue): malloc the value when
	validating because validation could cause the pointer to become
	invalid.  Also fixed configure to not trigger focus-based
	validation.  Improved use of Tcl_WrongNumArgs. [Bug: 4320]

2000-03-06  Eric Melski  <ericm@scriptics.com>

	* library/menu.tcl: Added a check in tkMenuFirstEntry that changes
	menu behavior to only auto-post an immediate child cascade if we
	are currently on a menubar menu.  This prevents massive
	auto-cascading in cases where the first entry of the cascade is
	itself a cascade, and the first entry of that cascade is a
	cascade, and the first entry of that cascade is a cascade
	... [Bug: 676].

	* generic/tkOldConfig.c: Added check for NULL tkwin value in
	Tk_ConfigureWidget [Bug: 4079]

	* generic/tkWindow.c: Added check for NULL tkwin value in
	Tk_NameToWindow [Bug: 4079]

2000-03-02  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/color.test:
	* xlib/xcolors.c (XParseColor FindColor):
	* win/tkWinColor.c (XAllocColor): Fixed bit fiddling for colors to
	return "correct" values for color mapping. [Bug: 4282]

	* unix/Makefile.in (SCRIPT_INSTALL_DIR): removed extraneous '/'
	* unix/aclocal.m4: corrected TCL_NEEDS_EXP_FILE to be 1 for AIX

	* win/tkWinInt.h: change extern to EXTERN for TkWinChildProc
	declaration with extra #defs. [Bug: 4240]

	* library/focus.tcl: fixed tkFocusOK to protect $w in
	uplevel with list. [Bug: 4208]

	* doc/CrtItemType.3: fixed docs for Tk_CreateItemType to reflect
	changes made in 8.3.0 (but old style would still work as well).
	[Bug: 4252]

	* tests/config.test: extra test to check object cleanup when
	destroying the widget
	* generic/tkListbox.c (DestroyListbox): fixed crash in
	DestroyListbox due to null tkwin.  [Bug: 4207]

	* tests/entry.test: added test suite for entry validation
	* doc/entry.n: improved docs discussing caveats and gotchas when
	mixing textvar with widget validation
	* generic/tkEntry.c (EntryValidateChange): improved handling of
	validation with relation to -textvariable.  Previously, it would
	turn off whenever the textvar was set.  Now it will it will turn
	off only when the textvar is set and validation returns 0.  Added
	%V (type of validation occuring) to %-subs to help work with
	trickier validation.

2000-03-01  Eric Melski  <ericm@scriptics.com>

	* tests/clrpick.test:
	* library/clrpick.tcl: Added code to make color chooser dialog
	inherit screen setting from parent (bug #2334)

2000-02-25  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c (RaiseWinWhenIdle): Checked for the possibility
	that the window could be destroyed (can occur with
	wm deiconify .toplevel; destroy .toplevel).

2000-02-25  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Applied "spirit of" the patch in 1605 (the
	submitted patch was more complicated than necessary and did not
	extend to writing GIF's, only reading), to allow reading/writing
	of GIF files on EBCDIC and other non-ASCII based systems.

2000-02-14  Eric Melski  <ericm@scriptics.com>

	* unix/tk.spec: RPM specification for producing a binary Tk RPM
	for Linux.

	* unix/Makefile.in: Added rpm target to generate Tk
	binary RPM.

2000-02-10  Jeff Hobbs  <hobbs@scriptics.com>

	8.3.0 RELEASE

	* changes: updated for 8.3.0 release

	* generic/tkImgGIF.c (FileReadGIF): added cast for trashBuffer

	* generic/tkIntXlibDecls.h:
	* generic/tkInt.decls: declared some Xlib emulation calls for
	the Mac

	* generic/tkFrame.c (TkInstallFrameMenu): added extra panic to
	inform user of bad call when framePtr is NULL [Bug: 2530]

	* generic/tkMenu.c (DestroyMenuInstance): Placed checks around
	menu name objects before trying to incr the ref.  [Bug: 3402]

	* generic/tkTest.c: removed USE_OLD_IMAGE def for Mac

	* library/listbox.tcl:
	* library/text.tcl: added support for <4> and <5> for mousewheel
	style scrolling on Unix for mice that map to these buttons.

	* tests/scrollbar.test: fixed check of testmetrics command to
	allow unix tests to run (testmetrics is mac/pc only)

	* unix/tkUnixWm.c (Tk_CoordsToWindow): qualified delete of error
	handler as the goto label is reached from above and below.

	* unix/configure.in:
	* unix/aclocal.m4: cleaned up macros to coincide with tcl.m4,
	added -export-dynamic to LDFLAGS for FreeBSD-3+ [Bug: 2998]

	* unix/README:
	* unix/Makefile.in (dist): removed porting.notes and porting.old
	from distribution and CVS.  The information was very outdated.  Now
	refer to http://dev.scriptics.com/services/support/platforms.html

	* xlib/xgc.c: #def'd out XDrawSegments for the Mac, and added
	some extra include info for the Mac

2000-02-09  Jim Ingham  <jingham@cygnus.com>

	* mac/tkMacButton.c: Stop removing the appearance window from the
	Window List.  It is not clear why Ray did this, and it causes the
	Appearance manager to crash at random times.

	* mac/tkMacWM.c: Add support in unsupported1 style for the Appearance
	specification of window styles, including floating window support.
	* mac/tkMacWindowMgr.c: Operate on the front non-floating window,
	unless the mouse is directly over the floating window.  Also,
	keystrokes go to the front non-floating window.
	* mac/tkMacAppInit.c: Initialize floating window support.
	* mac/tkMacScrlbr.c:
	* mac/tkMacmenu.c: Fixes for floating windows - operate on the
	FrontNonFloatingWindow.
	* mac/tkMacLibrary.r: Fix typo in File info string.
	* mac/tkMacApplication.r: Fix typo in file info string.  Add
	Finder balloon help for no apparent reason.

	* mac/tkMacSubwindows.c: Change panic in tkMacGetDrawablePort to
	Debugger.  This is only a temporary fix.  The panic is only
	triggered when a safeTk interpreter is torn down, and ignoring it
	does no harm.  I haven't figured out how to avoid it yet, however.
	Also use the Appearance MoveWindowStructure call when available.

	New Files:
	* MW_TkOldImageHeader.h: Handle #defining USE_OLD_IMAGE for tkImgPPM.c.
	* MW_TkTestHeader.h:
	* MW_TkTestHeader.pch:
	* MW_TkHeader.h: Add separate prefix files for test & release
	versions of Tk, so we can just have separate targets w/o having to
	edit files.

	* tclets.r: The D&D Tclets icon in rez form so we can have a
	target for this.

	The above are curtesy of Daniel Steffen (steffen@math.mq.edu.au)

	* tkMacAppearanceStubs.c: Stubs of the Mac Appearance calls I use
	so I can link the static 68K Shell without putting ifdef's all
	over the code.

2000-02-08  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.decls:
	* generic/tkBind.c:
	* generic/tkInt.decls:
	* generic/tkIntDecls.h:
	* generic/tkStubInit.c:
	* mac/tkMacKeyboard.c:
	* unix/tkUnixKey.c:
	* win/tkWinKey.c: Fix for keyboard handling of "dead" keys and
	caps lock from Peter Spjuth. [Bug: 4105 3359 2493]
	Split functions into platform specific files:
	Static functions GetKeySym(), SetKeycodeAndState() and InitKeymapInfo()
	from tkBind.c moved into platform files tkWinKey.c tkUnixKey.c and
	tkMacKeyboard.c.  GetKeySym() and SetKeycodeAndState() renamed to
	Tkp* and made public (as private functions) in tkInt.decls.

	Step 2, fixes in tkWinKey.c
	New static function: KeycodeToKeysym(), based on XKeycodeToKeysym()
	but with different arguments, and a lot of improvements.
	TkpGetString() changed to use KeycodeToKeysym() + other fixes.
	TkpGetKeySym() changed to use KeycodeToKeysym() + other fixes.
	InitKeymapInfo() changed to use KeycodeToKeysym().
	TkpSetKeycodeAndState() rewritten, mostly by copying code from
	XKeysymToKeycode().
	XKeycodeToKeysym() rewritten. Preferably it should be removed.

	EXPLANATION: The main problem is ToAscii() which has a lot of side
	effects, and also that XKeycodeToKeysym() is not provided enough
	input to do a proper job.  The changes' main goal is to avoid
	calling ToAscii() if not necessary, and to provide it with as
	correct information as possible when called.  Also some attempts
	to clean up what ToAscii() did are done.  See the code for details.

	BUGS FIXED: Typing shifted (and AltGr) dead keys did not work.
	Keyboard lock lamps did not work on Win98.
	Events regarding AltGr-keys behaved badly.
	Example: On a Swedish keyboard, $ is typed with AltGr-4.
	That keyboard event would get the keysym '4' not 'dollar'.
	Also, doing [event generete . <Key-dollar>] would send keysym '4'.
	Translation to ascii in TkpGetString did not handle return and
	tab correctly. I.e. [event generate . <Key-Return>] gave wrong %A

	* generic/tkDecls.h:
	* generic/tk.decls:
	* generic/tk.h: moved new public functions created in dash patch
	to the stubs interface [Bug: 4062]

	* generic/tk.h:
	* doc/CrtImgType.3:
	* doc/CrtPhImgFmt.3:
	* generic/tk.h:
	* generic/tkImgGIF.c:
	* generic/tkImgPhoto.c:
	* generic/tkStubImg.c (new file):
	* generic/tkTest.c:
	* unix/Makefile.in:
	* win/Makefile.in:
	* win/makefile.vc: improved support for moving from the old style
	image C API to the new obj'ified one with new Tk_InitImageArgs
	command and stub'ing of image code.  See docs for how to make the
	transition. [Bug: 4060]

	* library/tk.tcl: wrapped check for tcl_platform(os) around info
	exists because it won't in safe interpreters

	* win/tkWinFont.c: corrected symbol font use to only work on 8-bit
	characters [Bug: 2406]

	* unix/aclocal.m4: changed all -fpic to -fPIC

	* README:
	* unix/configure.in:
	* win/configure.in:
	* generic/tk.h (TK_RELEASE_SERIAL): Moved to 8.3.0 patchlevel

2000-02-07  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Applied patch from bug #4117,
	tk_getOpenFile/getSaveFile doesn't do the right thing when user
	types a directory name in the entry and a default extension is
	specified.

2000-02-05  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/tkUnixScale.c (TkpDestroyScale): changed ckfree to
	Tcl_EventuallyFree to behave with Tcl_Preserve in TkpDisplayScale
	(prevents possible segfault).

2000-02-03  Eric Melski  <ericm@scriptics.com>

	* tests/canvText.test: test for fix for bug #2525.

	* generic/tkFont.c (Tk_ComputeTextLayout): Was erroneously setting
	the width of newline-only text display chunks to some arbitrary
	huge number, instead of 0; this was interfering with things like
	the canvas find enclosed feature. (bug #2525).

	* tests/text.test:
	* generic/tkText.c (DumpLine/DumpSegment): Changed DumpSegment to
	take a TkTextIndex instead of two integer offsets, so that it
	could use TkTextPrintIndex to format the offsets into an index,
	which makes it UTF smart (bug #2582).

2000-02-01  Eric Melski  <ericm@scriptics.com>

	* library/tk.tcl:
	* library/tclIndex:
	* library/choosedir.tcl: Moved choosedir functions into the
	::tk::dialog::chooseDir namespace instead of a toplevel
	::tkChooseDirectory namespace.  Additional cleanup on the
	chooseDir dialog.

2000-02-01  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/text.n: clarified docs on what happens during a search with
	-count when images/windows are embedded

	* win/Makefile.in (install-*): reduced verbosity of install

	* win/tkWinPixmap.c (XGetGeometry): added support for windows in
	XGetGeometry [Bug: 4069]

	* win/tkWinFont.c (GetScreenFont): fixed possible mem overrun with
	long font names [Bug: 4108]

	* win/tkWinDialog.c: added EnableWindow calls to dialogs to
	correct for possible loss of control in parent Tk toplevel
	[Bug: 1212 et al]

	* generic/tkRectOval.c (ConfigureRectOval):
	* generic/tkCanvLine.c (ConfigureLine):
	* generic/tkCanvPoly.c (ConfigurePoly):
	* generic/tkCanvArc.c (Configure/DisplayArc): fixed handling for
	negative dash values [Bug: 4104]

	* generic/tkScale.c (TkRoundToResolution): fixed incorrect
	assumption that (N+1)*delta = N*delta + delta with floating point
	math [Bug: 3689, 4099]
	(DestroyScale) Fixed check for cancelling TkpDisplayScale (was
	REDRAW_ALL, is now REDRAW_PENDING)

	* tests/listbox.test: corrected test case for listbox itemconfigure

	* unix/aclocal.m4: added *BSD ELF recognition for
	SHARED_LIB_SUFFIX determination (from Tcl's tcl.m4)

2000-01-27  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgPhoto.c: Removed unneccesary object translation in
	MatchStringFormat (bug #4103).

2000-01-27  Eric Melski  <ericm@scriptics.com>

	* generic/tkImgGIF.c: Additional code cleanup (now we only have
	one decoder!  neat!)

2000-01-26  Eric Melski  <ericm@scriptics.com>

	* doc/getOpenFile.n:
	* doc/chooseDirectory.n: Man page/cross links for
	tk_chooseDirectory (bug #1786).

	* library/tk.tcl:
	* library/tclIndex: Added hooks for tk_chooseDirectory. (bug #1786)

	* library/choosedir.tcl: tk_chooseDirectory implementation for
	Unix/Mac (bug #1786).

	* generic/tkImgPhoto.c: Added some comments regarding slow
	processing of transparent images.

	* generic/tkImgGIF.c: Improved GIF decoder for ~60% speed
	increase.  Added some comments on how to further improve the
	implementation, time permitting.

	* doc/photo.n: Added a description of what the -data string can
	contain (base64 or binary data).

	* generic/tkImgPhoto.c: Fixed bug with use of binary data for
	"-data" option to "image create" command.

2000-01-21  Eric Melski  <ericm@scriptics.com>

	* library/tkfbox.tcl: Fixed bug relating to incorrect parent
	values for error message boxes displayed by the file dialog (bug
	#3616).

	* tests/text.test:
	* generic/tkText.c: Fixed bug relating to regexp searching for
	empty lines; previously, the starting line was ignored. (bug #1643).

2000-01-20  Jeff Hobbs  <hobbs@scriptics.com>

	* library/text.tcl: fixed double-click selection behavior where
	there were embedded windows/widgets in the same line. [Bug: 3989]

	* win/tkWinWm.c (TkWmProtocolEventProc): cached atom name as the
	window could get destroyed during eval [Bug: 2513]

	* generic/tkCanvLine.c (LineCoords): fixed segfault when too few
	coords were passed to a line with certain options set (it should
	always have thrown an error anyway). [Bug: 4042]

	* tests/text.test:
	* generic/tkText.c: fixed missing " in error case and missing
	'dump' in subcommand listing [Bug: 4036]

	* generic/tkListbox.c: adjusted use of basic string concatenation
	in (non-K&R behavior) [Bug: 4027]
	Swapped bg/fg class for -select(bg|fg) for listbox and their
	items [Bug: 4039]

	* unix/mkLinks:
	* doc/WindowId.3: added docs for Tk_IsContainer and Tk_IsEmbedded

	* doc/text.n: clarified mark gravity definition and usage of
	``word'' in binding definitions.  [Bug: 2004 2277 1388]

	* generic/tkInt.h: moved new TkDisplay useInputMethods structure
	element to end to not disturb position of previous elements in
	the structure (as compared to Tk <=8.2).

2000-01-20  Eric Melski  <ericm@scriptics.com>

	* tests/grid.test: Added a test for the consecutive ^ and multiple
	widget case (bug #1386).

	* generic/tkGrid.c: Fixed interpretation of consecutive ^
	characters in grid command.  Previously, ^ ^ was interpreted as
	meaning that there must be a 2-column widget above to extend,
	neglecting the case where there was actually 2 1-column widgets
	above.  Now, ^ ^ is interpreted as a possible width; the gridder
	will consume as many ^'s as there are columns in the widget, and
	leave the rest for the extension of other widgets.  (bug #1386).

2000-01-19  Eric Melski  <ericm@scriptics.com>

	* library/tk.tcl: Created a virtual event <<PrevWindow>> for
	reverse tab traversals, with one default binding <Shift-Tab>, and
	OS specific bindings for Linux, HP-UX, and IRIX. (bug #3163)

2000-01-13  Jeff Hobbs  <hobbs@scriptics.com>

	* changes: updated changes file to reflect 8.3b2 mods
	* README:
	* generic/tk.h:
	* unix/configure.in:
	* win/configure.in: updated to patchlevel 8.3b2

	* win/tkWinWm.c: added visibility event handler to make sure
	that transient window wrappers would be updated when the master
	was initially mapped.

2000-01-12  Jeff Hobbs  <hobbs@scriptics.com>

	* tests/text.test: changed test to reflect change of -hidden
	to -elide in search options.

	* win/tkWinScrlbr.c: added check for valid hwnd in ModalLoopProc
	to avoid crash when building statically

	* doc/event.n:
	* generic/tkBind.c: prevented core with event -warp on Windows
	when window wasn't mapped [Bug: 4004] and added docs stating
	the requirement for mapped windows.

	* generic/tkCanvas.c: fixed mem leak with TagSearchExprInit
	[Bug: 3977]

	* generic/tkStubInit.c:
	* generic/tkDecls.h: remove non-existent
	Tk_(Get|Create)CanvasVisitor prototypes

	* generic/tkText.c:
	* generic/tkEntry.c: fixed cursor to not blink when widget was
	disabled [Bug: 1807]

	* generic/tkRectOval.c: added note about change to bloat for
	RectOval bounds calculation for WIN32 only

	* library/dialog.tcl: improved handling of $default arg to allow
	for name of given button, as well as bounds checking

	* doc/wm.n:
	* tests/winWm.test:
	* tests/unixWm.test:
	* mac/tkMacWm.c:
	* unix/tkUnixWm.c: fixed possible X error being raised [Bug: 3377]
	* win/tkWinWm.c: wm deiconify in zoom state [Bug: 2077],
	fixed possible flashing of unmapped toplevel in deiconify [Bug: 3338]
	and fixed mapping of transient window [Bug: 572]
	Also, for all wm's, extended 'wm state' command to allow setting
	of the state, and added official support of 'zoomed' state on Win.

	* unix/aclocal.m4: strtod bug on Tru64 [Bug: 3378]

	* unix/Makefile.in: added tests to prevent unnecessary chmod +x
	in source dirs while installing [Bug: 3367]

	* unix/configure.in: properly sub'ed in TK_SHARED_BUILD [Bug: 3385]

2000-01-05  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/text.n:
	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextTag.c: removed the -state option for text tags,
	and reoriented it around -elide, as -state disabled was never
	implemented, and -state hidden is better as -elide.

	* mac/tkMacClipboard.c: fixed i18n problems with clipboard [Bug: 3544]

	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: fixed unprotected arg parsing through eval/after
	[Bug: 3943]

	* unix/Makefile.in: added unix/aclocal.m4 to distribution [Bug: 3938]
	* unix/aclocal.m4: changed NetBSD SHLIB_CFLAGS from -fpic to -fPIC

	* win/tkWinImage.c: added static declaration to function

1999-12-22  Jeff Hobbs  <hobbs@scriptics.com>

	* changes: updated changes file

	* generic/tkScale.c:
	* generic/tkScale.h:
	* mac/tkMacScale.c:
	* unix/tkUnixScale.c: fixed potential segv from patch in 3897

	* tests/unixWm.test: nonPOrtable -> nonPortable

1999-12-21  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.h:
	* unix/configure.in:
	* win/configure.in:
	* win/aclocal.m4:
	* README: updated for patch level 8.3b1

	* unix/tkUnixWm.c: fixed panic in Tk_CoordsToWindow to print error
	and continue instead (for Tix) [Bug: 716 et al]

	* scale.test:
	* generic/tkScale.c:
	* generic/tkScale.h: fixed possible core when freeing options
	(cursor) associated with scale widget [Bug: 3897]

	* doc/MeasureChar.3: fixed docs for Tk_MeasureChars to reflect code
	* doc/listbox.n: fixed formatting problem

	* generic/tk3d.c: added extra calculations to ensure that thin
	frames get refreshed too [Bug: 3596]

	* unix/tkUnixMenu.c:
	* unix/tkUnixFont.c:
	* generic/tkCanvText.c:
	* generic/tkEntry.c:
	* generic/tkFont.c:
	* generic/tkImgPPM.c: removed extranneous vars that were set but
	never used.

	* mac/tclMacHLEvents.c: fixed applescript for I18N [Bug: 3644]

	* unix/aclocal.m4: removed -O flag for AIX when using the IBM
	compiler (several versions have a bug that crops up in the text
	widget). [Bug: 2316]

	* unix/Makefile.in: removed extra slash in SCRIPT_INSTALL_DIR
	[Bug: 3896]

	* library/listbox.tcl: added extra checks for existence of
	tkPriv(listboxSelection) before it was used. [Bug: 3892]

1999-12-16  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/GetCursor.3:
	* win/tkWinCursor.c: added support for Windows cursors to
	TkGetCursorByName (.ani, .cur) using -cursor @<filename>
	(Ascher) [Bug: 1350]

	* win/tkWinWm.c: fixed 'wm deiconify' to update position of the
	toplevel if event is waiting before mapping. (Mao) [Bug: 3687]
	This removes the need for 'update idle' before 'wm deiconify' on
	Windows.

	* doc/listbox.n: added doc for <<ListboxSelect>> [Bug: 3500]

	* doc/getOpenFile.n: removed note that -initialfile didn't work
	for tk_getOpenFile
	* library/tkfbox.tcl: updated tk_get*File to better match the
	Windows file box it emulates, give proper support to -initialfile,
	and fixes lack of global tkPriv call.  [Bug: 3735 3882]

	* doc/tk.n: added doc for 'tk useinputmethods ...'
	* tests/tk.test:
	* unix/tkUnixKey.c:
	* generic/tkCmds.c:
	* generic/tkEvent.c:
	* generic/tkWindow.c:
	* generic/tkInt.h: add 'tk useinputmethods ?-display win? ?bool?'
	call to provide support for disabling/enabling the use of XIM on
	X.  This was previously all done at compile time, and always on.
	Now it is turned off by default, even when available, and the user
	must turn it on to use XIM (per display).

	* generic/tkCanvUtil.c: fixed bug in Tk_CanvasPsOutline that freed
	mem it shouldn't.

	* generic/tkFont.c: added "bitstream cyberbit" (popular Windows
	CJK font) to list of font fallbacks. (kenny) [Bug: 2407]

	* mac/tkMacMenu.c: finished bug 3075 by changing the char values of
	what was checked (verified correctness on Mac).

1999-12-13  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/canvas.n: added docs for items added by dash patch (-*dash*,
	-state, -active*, -disabled*, -offset, essentially rewrote the
	man patch for completely updated 8.3 canvas widget.
	* doc/entry.n: added docs for entry widget validation
	* doc/event.n: added docs for -warp
	* doc/text.n: doc'ed new -state value 'hidden'
	* doc/GetDash.3: (new file) man page explaining Tk_GetDash
	* generic/tkStubInit.c:
	* generic/tkDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkInt.decls: added XSetDashes and XWarpPointer
	* generic/tk.decls: added Tk_CreateSmoothMethod, and reserved
	two spots
	* generic/tk.h: added Tk_SmoothMethod struct,
	state item to canvas record, #defines for item state,
	support for using old char*-based canvas item C creation
	procedures with -DUSE_OLD_CANVAS,
	Tk_Dash, Tk_TSOffset (-offsets) & Tk_Outline structs and #defs,
	decls for dash, outline and postscript routines
	* generic/tkBind.c: added support for Quadruple clicks, and added
	the -warp option to 'event' with pointer warping routines
	* xlib/xgc.c:
	* generic/tkRectOval.c:
	* generic/tkCanvArc.c:
	* generic/tkCanvBmap.c:
	* generic/tkCanvImg.c:
	* generic/tkCanvLine.c:
	* generic/tkCanvPoly.c:
	* generic/tkCanvPs.c:
	* generic/tkCanvText.c:
	* generic/tkCanvUtil.c:
	* generic/tkCanvWind.c:
	* generic/tkCanvas.c:
	* generic/tkCanvas.h: Canvas and items received overhaul to with
	the addition of the dash patch (Nijtmans, et al)  This includes
	objectification of the 'canvas' command, as well as support for
	(where appropriate) dashes in items, extended stipple support,
	state for all items, and postscript generation of images and
	windows.  See the new canvas man page for related docs.
	* generic/tkEntry.c: added entry widget validation, see entry.n
	* generic/tkEvent.c: on simulated events, ButtonPress should
	be matched with ButtonRelease to be correct
	* generic/tkFont.c: corrected possible null reference
	* generic/tkFrame.c: made frame a Tcl_Obj based command
	* generic/tkGet.c: added TkGetDoublePixels
	* generic/tkImage.c: bug fixes from Img patch and new
	Tk_PostscriptImage and Tk_SetTSOrigin functions
	* generic/tkImgBmap.c: new ImgBmapPostscript function
	* generic/tkImgPhoto.c: new Tk_CreatePhotoOption, Tk_DitherPhoto
	* generic/tkInt.h: declarations for some new functions
	* generic/tkMessage.c: reworked relief drawing
	* generic/tkOldConfig.c: added TK_CONFIG_OBJS so old style
	ConfigureWidget calls can pass in Tcl_Obj arrays
	* generic/tkScrollbar.c:
	* generic/tkScrollbar.h: made -orient use an option table
	* generic/tkText.c:
	* generic/tkText.h: made -wrap and -state use option tables
	* generic/tkTextBTree.c:
	* generic/tkTextDisp.c:
	* generic/tkTextImage.c:
	* generic/tkTextMark.c:
	* generic/tkTextTag.c:
	* generic/tkTextWind.c: added support for -elide and -state hidden
	* generic/tkTrig.c: changed TkMakeBezierCurve to support returning
	the upper limit of points needed for spline
	* generic/tkUtil.c: new option table parsing routines
	* generic/tkWindow.c: init'ing of warp stuff, mouseButtonState

	related bug ids for the fixes:
	[Bug: 648 1541 1540 1779 2168 2311 2297 2340 2348 2578 3386]

	* tests/bind.test:
	* tests/canvImg.test:
	* tests/canvPsArc.tcl:
	* tests/canvPsImg.tcl: (new file)
	* tests/canvRect.test:
	* tests/canvText.test:
	* tests/canvas.test:
	* tests/defs.tcl:
	* tests/entry.test:
	* tests/event.test:
	* tests/font.test:
	* tests/frame.test:
	* tests/imgPhoto.test:
	* tests/safe.test:
	* tests/scale.test:
	* tests/scrollbar.test:
	* tests/select.test:
	* tests/text.test:
	* tests/textDisp.test:
	* tests/textTag.test:
	* tests/unixFont.test:
	* tests/unixWm.test:
	* tests/visual_bb.test:
	* tests/winClipboard.test: tests for the dash patch changes

	* unix/mkLinks: added GetDash.3 into the mkLink step

	* mac/tkMacDraw.c: mac still needs pointer warping routine
	* mac/tkMacXStubs.c:
	* win/tkWinDraw.c:
	* win/tkWinPointer.c: added support for pointer warping and
	platform specific support for dash patch items

1999-12-12  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkText.c: fixed bug in TextSearchCmd for multibyte chars
	(Darley) [Bug: 3839]

	* unix/aclocal.m4: added warning when configuring with
	--enable-threads that Tk may have problems

1999-12-09  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImgGIF.c: updated casting

	* win/makefile.vc: removed 16bit stuff, simplified makefile.

1999-12-06  Scott Redman  <redman@scriptics.com>

	* generic/tkMain.c: need to include tclInt.h for new hook
	functions that are internal-use-only.

1999-12-06  Jeff Hobbs  <hobbs@scriptics.com>

	* library/comdlg.tcl: removed tclVerifyInteger and tclSortNoCase,
	they weren't used, and were not actually correct

	* mac/tkMacFont.c:
	* mac/tkMacMenu.c:
	* mac/tkMacWindowMgr.c: fixed greyed out menu items, handling of
	... elipsis, font mapping problem, and enabled generated menu
	posting [Bug: 3705]

1999-12-02  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkInt.h:
	* generic/tkWindow.c:
	* generic/tkCmds.c: converted Tk_DestroyCmd, Tk_LowerCmd and
	Tk_RaiseCmd to their ObjCmd equivalent.

	* library/msgbox.tcl: added color icons for tk_messageBox on Unix
	and Mac when tk_strictMotif isn't set. (Hipp)
	* library/tk.tcl: added window bounds checking to ::tk::PlaceWindow

	* tests/imgPPM.test: fixed test 2.2 to use -format ppm (since
	we know have GIF write capability)

1999-12-01  Scott Redman <redman@scriptics.com>

	* generic/tkMain.c :
	* unix/tkAppInit.c:
	* win/winMain.c: Added added hooks into the main() code for
	supporting TclPro and other "big" shells more easily without
	requiring a copy of the main() code.

1999-11-29  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkImgGIF.c: added GIF writing that uses miGIF RLE
	[Bug: 2039, new patch]

	* library/entry.tcl: fixed up tkEntrySeeInsert (Nemthi)

	* generic/tkListbox.c: fixed 'get' of listbox to return a string
	when only one item is requested.

	* tests/clrpick.test:
	* tests/filebox.test: minor whitespace cleanup

	* library/tk.tcl: fixed missing $w in ::tk::PlaceWindow

1999-11-24  Jeff Hobbs  <hobbs@scriptics.com>

	* library/clrpick.tcl:
	* library/msgbox.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: fixed dialogs to center over -parent,
	added utility functions ::tk::PlaceWindow, ::tk::SetFocusGrab,
	::tk::RestoreFocusGrab to tk.tcl to help

1999-11-23  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Added a test to check that the topIndex is
	update when items are removed from the listvar variable.

	* generic/tkListbox.c: Added a check the updates the topIndex when
	items are removed from the listvar variable.

	* tests/listbox.test: Added a test to check that the vertical
	scrollbar is updated when the listvar changes.

	* generic/tkListbox.c (ListboxListVarProc): added a check that
	sets the UPDATE_V_SCROLLBAR flag if the length of the listvar has
	changed.

1999-11-23  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tk.h:
	* generic/tkConfig.c: added support for TK_OPTION_DONT_SET_DEFAULT
	as equiv for TK_CONFIG_DONT_SET_DEFAULT
	* generic/tkListbox.c: added TK_OPTION_DONT_SET_DEFAULT to the
	item specs

1999-11-19  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkColor.c:
	* generic/tkColor.h: fixed Tk_NameOfColor to work correctly,
	with minor change to TkColor struct.

	* generic/tkConsole.c: added static declaration to
	ConsoleDeleteProc function (proto already had it)

	* win/tkWinInt.h: removed TkFontAttributes typedef (was
	redundant with tkFont.h).
	* win/tkWinPort.h: put #ifndef __GNUC__ around redefinition
	of str[n]casecmp, as cygwin uses the originals.
	* win/tkWinX.c: changed GetCurrentTime to GetTickCount (the
	former is deprecated).  [Bug: 2053]

1999-11-19  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Added tests for itemcget and itemconfigure.

	* doc/listbox.n: Added documentation for -listvar option and for
	itemconfigure and itemcget commands.

	* generic/tkListbox.c: Added support for itemconfigure/itemcget
	listbox subcommands (addresses rfe #936)

1999-11-17  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Updated tests for new error messages.

	* generic/tkListbox.c: Improved error messages for bad -listvar's.

	* tests/listbox.test: Added tests for bad -listvar's.

	* generic/tkListbox.c: Added handlers for bad -listvar's (ie, bad
	lists)

	* tests/listbox.test: Added tests for ListboxUpdateHScrollbar.

	* generic/tkListbox.c: Changed some old static buffers to base
	size on TCL_DOUBLLE_SPACE instead of (completely) hardcoding the size.

	* tests/listbox.test: New tests for -listvar functionality, and an
	odd extra case that wasn't covered before.

	* generic/tkListbox.c: Tests exposed some bugs, now fixed.

1999-11-16  Eric Melski  <ericm@scriptics.com>

	* tests/listbox.test: Fixed tests to comply with new objectified
	error messages.  No -listvar specific tests yet.

	* win/tkWinDefault.h:
	* unix/tkUnixDefault.h:
	* mac/tkMacDefault.h: Added default value for -listvar option.

	* generic/tkWindow.c: Changed "listbox" mapping from old-school to
	new-school objectified command.

	* generic/tkListbox.c: Objectified listbox; added support for
	-listvar option.  Converted internal structure to use a Tcl list
	object to store the data.

	* generic/tkInt.h: Changed reference to Tk_ListboxCmd to
	Tk_ListboxObjCmd.

1999-11-09  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkGrid.c: changed Tcl_Alloc to ckalloc

	* generic/tkEntry.c: fixed C expr error in destroy of entry
	that could lead to 'malformed bucket chain' error

	* win/winMain.c: corrected winMain to not do a DebugBreak when
	returning an error message from the top level

1999-10-30  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinKey.c: fixed XKeysymToKeycode to handle mapping of
	symbolic keysyms (Left, Home, ...) with event generate

	* library/entry.tcl: change tkEntrySeeInsert to avoid the use
	of a while loop that could eat CPU tremendously.  Behavior of
	moving the cursor at the right edge changes slightly (previously
	it tried to keep the cursor at the right edge, now it moves the
	cursor to a "central right" location - better IMHO).

1999-10-28  Jeff Hobbs  <hobbs@scriptics.com>

	* doc/CrtImgType.3:
	* doc/CrtPhImgFmt.3:
	* doc/FindPhoto.3:
	* doc/photo.n:
	* generic/tk.h:
	* generic/tkCmds.c:
	* generic/tkImage.c:
	* generic/tkImgBmap.c:
	* generic/tkImgGIF.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c:
	* generic/tkInt.h:
	* generic/tkTest.c:
	* generic/tkWindow.c:
	* tests/imgPhoto.test: added Img patch (Nijtmans) with docs,
	headers #def'd with USE_OLD_IMAGE.  Upgrades image stuff to
	Tcl_Obj API, adds alpha channel (images are now 32 bpp)

	* makefile.vc: changed 'c:/program files' to c:/progra~1

1999-10-19  Jeff Hobbs  <hobbs@scriptics.com>

	* library/scrlbar.tcl: changed tkScrollButtonUp to check for
	existence of tkPriv(relief) in order to avoid spurious release
	events

	* unix/Makefile.in: added ChangeLog to dist archive

1999-09-24  Jeff Hobbs  <hobbs@scriptics.com>

	* */README:
	* win/makefile.vc:
	* */configure.in:
	* generic/tk.h:
	* library/tk.tcl: up'd to 8.3a1

	* unix/Makefile.in: changed 'mkdir' to 'mkdir -p'

	* library/dialog.tcl: changed {Times 18} to {Times 12} for
	dialog font.

1999-09-16  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkFont.c: fixed processing of font options and error
	returned [Bug: 2075]

	* win/tkWinWm.c: fixed bug in 'wm deiconify' that raised the
	wrong toplevel, and changed it to not set focus on overridden
	toplevels

1999-09-15  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/aclocal.m4: added fix for FreeBSD-[1-2] recognition [Bug: 2070]
	and fix to AIX-* to get ldAix right [Bug: 2624], fixed AIX
	version check (readjust from 8-21 fix) and several other config
	fixes for AIX
	* mac/tkMacMenubutton.c:
	* unix/tkUnixMenubu.c: fixed permanently stippled menubutton image
	* win/tkWinButton.c: fixed possible pointer smash [Bug: 2733]

1999-09-14  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinMenu.c: fix for stack overrun in GetTextFace [Bug: 909]

1999-09-01  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinDraw.c:
	* unix/tkUnixDraw.c: fixed header style for TkpDrawHighlightBorder
	* generic/tkCanvas.c: fixed GC error (bg <> fg) in tkCanvas.c
	(from code added to support TkpDrawHighlightBorder) [Bug: 2676]
	* unix/aclocal.m4: added -bnoentry to the AIX-* flags
	* library/msgbox.tcl: changed the behavior of tk_messageBox on
	Unix to be more Windows like in handling of <Return> and the
	default button
	* library/button.tcl:
	* library/clrpick.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/safetk.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl: updated commands to use [string] ops
	instead of expr equality operators

1999-08-21  Jeff Hobbs  <hobbs@scriptics.com>

	* unix/aclocal.m4: Changed AIX-4.[2-9] check to AIX-4.[1-9]
	[Bug: 1909]

1999-08-20  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkCursor.c: fixed bug in GetCursorFromObj that caused
	panic [Bug: 2562]

	* TK 8.2.0 RELEASED

1999-08-13  Jim Ingham  <jingham@cygnus.com>

	* mac/tkMacMenu.c: Tk_DrawChars ends up setting the menu background
	wrong.	There is no clean way to stop it, so I use lower level routines
	here to draw the text.
	* mac/tkMacProjects.sea.hqx: Rearrange the projects so that the build
	directory is separate from the sources.  Much more convenient!

1999-08-10  Jeff Hobbs  <hobbs@scriptics.com>

	* win/tkWinWm.c: changed "wm deiconify" on Windows to raise and
	force the focus on the deiconified window (behavioral change from
	8.1 to comply better with Windows style) [Bug: 1609]
	* doc/wm.n: clarified behavior of "wm deiconify".
	* generic/tkInt.decls: added TkSetFocusWin
	* generic/tkFocus.c: changed static SetFocus to TkSetFocusWin

	* library/clrpick.tcl:
	* library/console.tcl:
	* library/tk.tcl: fixed code where abbreviations where used
	in calling widget methods (confuses iWidgets) [Bug: 2422]

1999-08-09  Jeff Hobbs  <hobbs@scriptics.com>

	* library/button.tcl: cleaned up programming (config -> configure)
	and fixed Windows relief bug [Bug: 664]
	* library/entry.tcl: changed Entry C/C/P to not use global data
	(now uses tkPriv(data)) [Bug: 1475]
	* library/listbox.tcl: fixed extended mode script error [Bug: 866]
	* doc/options.n: clarified that -troughcolor doesn't work on Windows
	* doc/wm.n: fixed wm positionfrom docs [Bug: 2284]

1999-08-01  Jeff Hobbs  <hobbs@scriptics.com>

	* mac/tkMacPort.h: wrapped panic in #ifndef panic to avoid
	compiler errors when used with stubs-#defines, from Vince Darley.
	[Bug: 2389]

1999-07-31  Scott Redman  <redman@scriptics.com>

	* xlib/X11/Xlib.h: Remove XFillRectangle since it is now in the
	stub tables.

1999-07-30  Jeff Hobbs  <hobbs@scriptics.com>

	* generic/tkInt.decls: Added stub entry for XFillRectangle [Bug: 2446]

1999-07-30  Scott Redman  <redman@scriptics.com>

	* win/makefile.vc: Corrected building threaded tktest.exe on
	Windows.  Needed to link in .obj files from Tcl, needs to change
	later so that code is in Tk and doesn't require a Tcl build.
	Also added runtest target.

1999-07-29  Scott Redman  <redman@scriptics.com>

	* generic/tkConsole.c: Allow tcl to open CON and NUL, even for std
	channels.  Checking for bad/unusable std channels was moved to Tk
	since its only purpose was to check whether to use the Tk Console
	Window for the std channels.  [Bug: 2393 2392 2209 2458]

	* win/Makefile.in: Corrected building threaded tktest.exe on
	Windows.  Needed to link in .obj files from Tcl, needs to change
	later so that code is in Tk and doesn't require a Tcl build.

1999-07-22  Scott Redman  <redman@scriptics.com>

	* Changed version to 8.2b2

	* win/tkWinPort.h: Block out include of sys/stat.h in order to
	build extensions with MetroWerks compiler for Win32. [Bug: 2385]

	* unix/Makefile.in: Need to make install-sh executable before
	calling (with chmod +x).  [Bug: 2413]

	* library/menu.tcl: Applied patch from Jeff Hobbs to fix typo.
	[Bug: 2425]

1999-07-21  Scott Redman  <redman@scriptics.com>

	* unix/Makefile.in: Add Windows configure script to distribution.

1999-07-16  Scott Redman  <redman@scriptics.com>

	* unix/Makefile.in:
	* win/Makefile.in:  Copy the prolog.ps from the generic directory
	for install-libraries.

	* unix/aclocal.m4: Check for Alpha/Linux to set the IEEE flag to
	the compiler to be -mieee.  Patch from Don Porter.

1999-07-08  Scott Stanton  <stanton@scriptics.com>

	* tests/unixSelect.test: Fixed broken test.

	* win/makefile.vc: Added special case target to ensure that
	tkStubLib.obj is built with -DSTATIC_BUILD.

	* win/tkWinX.c (TkWinChildProc): Changed to pass
	WM_WINDOWPOSCHANGED through to DefWindowProc to make OpenGL
	sub-windows happy.  This allows Windows to generate the WM_SIZE
	and WM_MOVE messages.

1999-07-08  Scott Redman  <redman@scriptics.com>

	* unix/configure.in: Fix Tk stub lib file names and flags.

1999-06-30  Scott Redman  <redman@scriptics.com>

	* generic/tkGrid.c: removed deprecated functions (applied patch
	from Jan Nijtmans). [Bug: 2080]

	* generic/tkImgGIF.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Applied patch to allow Img extension to
	work with 8.2, from Jan Nijtmans. [Bug: 2068]

	* win/tkWinWm.c: Applied patch from Don Porter to prevent the
	windows code from calling the Tcl functions when the stub table
	has not been initialized in TkWinWmCleanup.  [Bug: 2269]

1999-06-16  Michael Thomas  <wart@scriptics.com>

	* unix/configure.in:
	* unix/Makefile.in:
	* unix/aclocal.m4: Numerous build changes to make Tk conform to
	the proposed TEA spec

	* tkConsole.c: changed some variable types from (int) to (size_t)
	to prevent compiler warnings.  Cast return value from strlen()
	to (int) in one place for the same reason.

1999-06-03  Scott Stanton  <stanton@scriptics.com>

	* unix/tkUnixSelect.c:
	* tests/unixSelect.test:
	* generic/tkSelect.c: Fixed selection code to handle Unicode data
	in COMPOUND_TEXT and STRING selections. [Bug: 1791]

1999-06-02  Scott Stanton  <stanton@scriptics.com>

	* generic/tkIntXlibDecls.h:
	* xlib/X11/Xlib.h: Added Mac specific defines to help with
	compilation.

	* generic/tkFont.c: lint

1999-06-01  Scott Stanton  <stanton@scriptics.com>

	* unix/tkUnixSelect.c: Improved I18N selection support.
	COMPOUND_TEXT is converted to/from iso2022, and STRING is
	converted to/from iso8859-1.  There are still a few loose ends to
	tie up before this is completely done.

	* unix/tkUnixFont.c: Eliminated redundant case folding code.

	* generic/tkFont.c: Eliminated use of isupper/tolower in favor of
	Unicode variants.

1999-05-24  Scott Stanton  <stanton@scriptics.com>

	* generic/tkStubLib.c:
	* generic/tkStubInit.c:
	* generic/tkIntXlibDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkInt.decls:
	* generic/tkConsole.c: Various changes to try to get the Mac
	builds working.

1999-05-21  Scott Stanton  <stanton@scriptics.com>

	* win/tkWinClipboard.c: Fixed clipboard code to handle lack of
	CF_LOCALE information (e.g. from command.com).

1999-05-20  Scott Redman  <redman@scriptics.com>

	* library/console.tcl: Changed copyright string to read 1999
	Scriptics Corp. in wish console about box.

1999-05-19  Scott Redman  <redman@scriptics.com>

	* generic/tk.h: Add extern "C" block around entire header file for
	C++ compilers to fix linkage issues.  Submitted by Don Porter and
	Paul Duffin.

1999-05-18  Scott Stanton  <stanton@scriptics.com>

	* tests/winClipboard.test:
	* win/tkWinClipboard.c: Fixed clipboard code so it handles Unicode
	data properly on Windows NT and 95. [Bug: 1791]

1999-05-07  Scott Stanton  <stanton@scriptics.com>

	* library/menu.tcl: Fixed bug where tk_popup fails when called too
	quickly. [Bug: 2009]

1999-04-30  Scott Stanton  <stanton@scriptics.com>

	* Changed version number to 8.1.1.

1999-04-30  Scott Stanton  <stanton@scriptics.com>

	* Merged changes from 8.1.0 branch:

	* generic/tkDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkStubInit.c: Changed to avoid the need for forward
	declarations in stub initializers.  Added extern "C" blocks around
	stub table pointer declarations so the stubs can be used from C++
	code. [Bug: 1934]

	* generic/tkInt.decls: Added TkClipBox, XDrawSegments, and
	XForceScreenSaver to stubs.

	* generic/tkStubLib.c: Reordered declarations to avoid
	circularities and forward references.

	* generic/tkStubInit.c: Added includes for Mac.

	* generic/tkMenubutton.c: lint

	* generic/tkEntry.c: Fixed bad option table entry.

	* generic/tkImgBmap.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Set the -translation and -encoding options
	to binary for image files. (reported by Marco Gazzetta)

1999-04-23  Scott Stanton  <stanton@scriptics.com>

	* generic/tkInt.decls: Added TkClipBox, XDrawSegments, and
	XForceScreenSaver to stubs.

	* generic/tkStubLib.c: Reordered declarations to avoid
	circularities and forward references.

	* generic/tkStubInit.c: Added includes for Mac.

	* generic/tkMenubutton.c: lint

	* generic/tkEntry.c: Fixed bad option table entry.

1999-04-22  Scott Redman  <redman@scriptics.com>

	* generic/tkImgBmap.c:
	* generic/tkImgPPM.c:
	* generic/tkImgPhoto.c: Set the -translation and -encoding options
	to binary for image files. (reported by Marco Gazzetta)

1999-04-20  Scott Redman  <redman@scriptics.com>

	* xlib/X11/Xlib.h: changed definition of Status type to use a
	typedef instead of a #define to avoid conflicting with the cygwin
	win32 headers [Bug 1804]

1999-04-15  Scott Stanton  <stanton@scriptics.com>

	* Merged 8.1 branch into the main trunk

1999-04-09  Scott Redman  <redman@scriptics.com>

	* generic/tkWindow.c: Fixed deadlock situation when the Initialize()
	function returns without releasing the mutex.  Found while testing
	Bug 1700, during safe.test (tk).

1999-04-06  Scott Stanton  <stanton@scriptics.com>

	* generic/tkMain.c (Tk_MainEx): Changed to reset result before
	calling Tcl_EvalFile.  The ensures that error messages will be
	generated cleanly.

	* tests/winfo.test: Enabled tests that previously failed.

1999-04-05  Scott Stanton  <stanton@scriptics.com>

	* library/bgerror.tcl:
	* library/button.tcl:
	* library/clrpick.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/entry.tcl:
	* library/focus.tcl:
	* library/listbox.tcl:
	* library/menu.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/scale.tcl:
	* library/scrlbar.tcl:
	* library/tearoff.tcl:
	* library/text.tcl:
	* library/tk.tcl: Lots of minor performance improvements
	contributed by Jeffrey Hobbs. [Bug: 1118]

	* win/tkWinWm.c (Tk_WmCmd): Fixed bad code in tracing
	suboption. [Bug: 1519]

	* library/tkfbox.tcl: Change to restore button text after an
	action to avoid the sticky "Open" button in a save dialog.
	[Bug: 1640]

	* library/entry.tcl: Fixed so selection is returned using the
	-show character during cut and paste operations. [Bug: 1687]

1999-04-5   Scott Redman  <redman@scriptics.com>

	* generic/tkInt.decls:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c:
	* xlib/xgc.c:
	* xlib/X11/Xlib.h:
	* xlib/X11/Xutil.h: Added more X functions to the Win & Mac stubs
	tables.

1999-04-05  Scott Stanton  <stanton@scriptics.com>

	* unix/configure.in:
	* generic/tkCanvPs.c: Added configure test for pw_gecos field in
	pwd to support OS/390. [Bug: 1724]

1999-04-02  Scott Stanton  <stanton@scriptics.com>

	* tests/text.test:
	* generic/tkText.c: Fixed handling of Unicode in text searches.
	The -count option was returning byte counts instead of character
	counts. [Bug: 1056, 1148, 1666]

1999-04-01  Scott Redman  <redman@scriptics.com>

	* generic/tk.decls:
	* generic/tk.h:
	* generic/tkStubInit.c:
	* generic/tkWindow.c:
	* unix/Makefile.in:
	* win/makefile.vc: Tk now uses its own stub library to store
	pointers to its own stubs table.

	* doc/dde.n: (removed)
	* doc/send.n:
	* generic/tk.decls:
	* tests/winSend.test:
	* generic/tkPlatDecls.h:
	* win/tkWinSend.c:  Removed the DDE-based send and dde commands,
	they were causing Tk to lock up when any window on the system was
	not processing its message queue (more importantly, windows in Tcl
	and Tk).  The send command needs to be rewritten to prevent the
	deadlock situation (soon).  The dde command is being pushed into
	its own package and will provide almost all of the capabilities
	that send did before (using a "dde eval" command), not yet
	completed.

1999-03-31  Scott Redman  <redman@scriptics.com>

	* win/tkWinSend.c: Modified dde/send code to work properly on
	Win95/Win98. String lengths are not returned properly by DDE, so
	NULL terminate all strings going in and ignore the string length
	coming back out.  Do not destroy handles until all necessary work
	on those handles (and child handles) is done.

1999-03-30  Scott Stanton  <stanton@scriptics.com>

	* generic/tkWindow.c (Tk_DestroyWindow): Image handlers are now
	finalized before the font subsystem since complex image handlers
	may contain references to fonts (e.g. Tix compound images).
	[Bug: 1603]

1999-03-29  Scott Stanton  <stanton@scriptics.com>

	* doc/MeasureChar.3:
	* doc/TextLayout.3:
	* generic/tk.decls:
	* generic/tkCanvText.c:
	* generic/tkEntry.c:
	* generic/tkFont.c:
	* generic/tkListbox.c:
	* generic/tkMessage.c:
	* mac/tkMacFont.c:
	* unix/tkUnixButton.c:
	* unix/tkUnixFont.c:
	* unix/tkUnixMenu.c:
	* win/tkWinFont.c:
	* win/tkWinMenu.c: Standardized text layout and font interfaces
	so they are consistent with respect to byte versus character
	oriented indices.  The layout functions all manipulate character
	oriented values while the lower level measurement functions all
	operate on byte oriented values.  This distinction was not clear
	and so the functions were being used improperly in a number of
	places.  [Bug: 1053, 747, 749, 1646]

	* generic/tk.decls: Eliminated uses of C++ STL types string and
	list from declarations.

	* generic/tkFont.c: Changes to named fonts were not being
	propagated in some cases. [Bug: 1144]

	* xlib/X11/Xlib.h:
	* generic/tkInt.decls: Added XParseColor to xlib stub
	tables. [Bug: 1574]

	* doc/GetBitmap.3:
	* generic/tkBitmap.c (BitmapInit): Eliminated use of Tk_Uid's in
	bitmaps.  Added a few CONST declarations.

1999-03-29  Scott Redman  <redman@scriptics.com>

	* unix/configure.in:
	* unix/Makefile.in:
	* win/makefile.vc:
	* generic/tkDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkIntXlibDecls.h: Removed stub functions. Always use the
	Tcl stubs when building with --enable-shared.

1999-03-26  Scott Redman  <redman@scriptics.com>

	* generic/tkTextIndex.c:
	* tests/testIndex.test: Avoid looking past the beginning of the
	array storing data for the text widget (.t index end-2c).  Added
	test case to check for the bug.  [Bug 991]

	* generic/tkConsole.c: Copy static strings into a Tcl_DString
	before passing to Tcl_Eval, in case the compiler puts static
	strings into read-only memory.

1999-03-26  Suresh Ankolekar  <suresh@scriptics.com>

	* unix/configure.in:
	--nameble-shared is now the default and builds Tk as a shared
	library; specify --disable-shared to build a static Tk library
	and shell.

1999-03-26  Bryan Surles  <surles@scriptics.com>

	* library/menu.tcl: Fixed bug reported by Bryan Oakley in the
	menubutton bindings.  There was a false assumption that there was
	always a menu attached to the button.  [Bug 1116]

1999-03-26  Scott Redman  <redman@scriptics.com>

	* unix/configure.in: Removed --enable-tcl-stub.  Linking Tk to Tcl
	stubs is causing too many problems when linking executables like wish.
	Until the Tk is a fully loadable extension, linking against the Tcl
	stubs is not supported in Tk.

1999-03-19  Scott Redman  <redman@scriptics.com>

	* generic/tkBitmap.c:
	* generic/tkCursor.c:
	* generic/tkGC.c: When creating hash tables that key off of XID
	handles, make sure to pass TCL_ONE_WORD_KEYS.  XIDs are guaranteed
	to be 32bit numbers, although on some 64bit systems (including 64bit
	Solaris 7) they are packed into a 64bit value where the upper 32bits
	are zero. The normal method of sizeof(XID)/sizeof(int) causes the
	hash table code to assume that the XID is a pointer to an array of
	two ints, which it is not.  Tk now supports 64bit Solaris 7.

1999-03-17  Scott Stanton  <stanton@scriptics.com>

	* win/makefile.vc:
	* generic/tk.h: Changed to use TCL_BETA_RELEASE macro, and fixed
	so this works in rc files.

	* win/makefile.vc:
	* win/makefile.bc:
	* win/README:
	* unix/configure.in:
	* generic/tk.h:
	* README: Updated version to 8.1b3.

1999-03-14  Scott Stanton  <stanton@GASPODE>

	* unix/configure.in: Added missing stub related definitions.

	* unix/Makefile.in: Install tkDecls.h in addition to tk.h.

	* generic/tkStubLib.c: Added flags to ensure we are using Tcl
	stub macros.

1999-03-11  Scott Stanton  <stanton@GASPODE>

	* generic/tkInt.decls: Added reserved slot for XSetDashes for use
	by the dash patch.

1999-03-10  Scott Redman  <redman@scriptics.com>

	* xlib/xdraw.c:
	* xlib/X11/Xlib.h:
	* mac/tkMac.h:
	* mac/tkMacInt.h:
	* mac/tkMacPort.h:
	* mac/tkMacXStubs.c:
	* mac/tkMacAppInit.c:
	* mac/tkMacCursor.c:
	* win/makefile.vc:
	* win/tkWin.h:
	* win/tkWinInt.h:
	* win/tkWinPort.h:
	* win/winMain.c:
	* generic/tk.h:
	* generic/tkInt.h:
	* generic/tk.decls:
	* generic/tkInt.decls:
	* generic/tkDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubs.c:
	* generic/tkPlatStubs.c:
	* generic/tkIntStubs.c:
	* generic/tkIntPlatStubs.c:
	* generic/tkIntXlibStubs.c:
	* generic/tkStubInit.c:
	* generic/tkStubLib.c:
	* generic/tkBind.c:
	* generic/tkCmds.c:
	* generic/tkConfig.c:
	* generic/tkConsole.c:
	* generic/tkCursor.c:
	* generic/tkGrab.c:
	* generic/tkImgPhoto.c:
	* generic/tkMain.c:
	* generic/tkMenu.c:
	* generic/tkPointer.c:
	* generic/tkTextDisp.c:
	* generic/tkWindow.c:
	* unix/tkUnixInt.h:
	* unix/tkUnixPort.h:
	* unix/Makefile.in:
	* unix/configure.in:
	* unix/tkConfig.sh.in:
	* unix/tkUnix.c:
	* unix/tkUnix3d.c:
	* unix/tkUnixDraw.c:
	* unix/tkUnixFont.c:
	* unix/tkUnixMenubu.c: Stubs implementation for 8.1.  Tk_Main() is
	replaced with a macro which calls Tk_MainEx(). Tk can link to the Tcl
	stubs library, wish links directly to Tcl and Tk. Use
	--enable-tcl-stubs to link Tk to the Tcl stubs library (Unix), on
	by default on Windows. Exported all public functions through the
	stubs mechanism (see the *.decls files) and many of the internal
	functions. Most of the changes dealt with shifting around the
	function declarations in the header files.  Mac code may not
	compile, but it shouldn't take much work to fix this.

	* mac/tkMacMenu.c: Added dummy TkpMenuThreadInit for Mac to be
	consistent with Unix and Windows versions.

1999-03-08  Lee Bernhard  <lfb@scriptics.com>

	* win/tkWinWm.c: Toplevel class no longer shared between
	threads.

	* win/tkWinX.c: Multiple threads no longer share the same
	TkDisplay structure.  Required because TkDisplay stores much
	thread-specific data for a given thread.

	* win/tkWinSend.c: Moved application instance handle out
	out thread-local storage.  DDE was failing to initialize
	when the instance handles were different between threads.

	* win/makefile.vc: Added THREADDEFINES for building with
	threads enabled.

	* generic/tkMenu.c:
	* win/tkWinMenu.c:
	* unix/tkUnixMenu.c: Added TkpMenuThreadInit for initializing
	thread-specific Menu state.

1999-03-01  Scott Redman  <redman@scriptics.com>

	* win/tkWinWm.c:
	* win/tkWinPointer.c:
	* win/tkWinInt.h: Fix "focus -force" for Windows.  The Win32 API
	function SetForegroundWindow() does not work unless the window
	handle is a toplevel window (a Windows toplevel).  The handle
	being passed was a Tk toplevel, which is a child of the Windows
	toplevel.

1999-02-26  Scott Redman  <redman@scriptics.com>

	* win/cat.c: Remove this file, use the one in the Tcl source directory.

	* win/makefile.vc: Remove the wishc.exe from the default targets.  Add
	a separate console-wish target to build it.  The need for a
	console-wish will go away soon, so we don't want to encourage its
	use.

1999-02-25  Scott Redman  <redman@scriptics.com>

	* win/tkWinWm.c: Properly initialize the tsdPtr->firstWindow field.

	* win/cat.c: Code for cat32.exe, copied from the Tcl sources. Required
	in order to run the test suite from the makefile

	* win/winMain.c: Add main() for a console-based wishc.exe, which meant
	adding code to disable the call to Tk_ConsoleInit().

	* generic/tkConsole.c: Check the standard handles before creating the
	new standard channels.	This allows a windows app that has stdin,
	stdout, or stderr to correctly connect to them.

	* generic/tkMain.c: Add a proper check for the interactive mode, since
	the standard channels may actually be connected in windows mode or
	even in the console-based wish.

	* win/makefile.vc: Add targets for wishc.exe (console-based wish) and
	cat32.exe (for testing). Fix the test suite target so it can be run
	from the makefile (which can happen since the standard handles have
	been fixed).

1999-02-12  Lee Bernhard  <lfb@scriptics.com>

	* generic/tkMenuButton.h:
	* generic/tkMenuButton.c:
	* mac/tkMacMenubutton.c:
	* mac/tkMacDefault.h
	* unix/tkUnixMenubu.c: Eliminated Tk_Uids used by -state option.
	* unix/tkUnixDefault.h
	* win/tkWinDefault.h

	* generic/tk.h:
	* generic/tkScale.h:
	* generic/tkScale.c:
	* generic/tkWindow.c:
	* unix/tkUnixScale.c:
	* unix/tkUnixDefault.h:
	* unix/tkWinDefault.h:
	* mac/tkMacDefault.h:  Objectified scale widget.

	* win/tkWinX.c: Removed Thread-specific data from process
	initialization code that was stopping the Tk Dll from
	loading.

1999-02-11  Scott Stanton  <stanton@GASPODE>

	* README:
	* generic/tk.h:
	* unix/configure.in:
	* win/README:
	* win/makefile.bc:
	* win/makefile.vc: Updated version to 8.1b2.

	* unix/tkUnixSend.c: Fixed one more Tcl_*ObjVar instance.

1999-02-04  Scott Stanton  <stanton@GASPODE>

	* Various cleanup related to the Tcl_Eval and Tcl_ObjSetVar
	changes in Tcl.

	INTEGRATED PATCHES FROM 8.0.5b2:

	* win/tkWinMenu.c (TkpDestroyMenu): Changed so modalMenuPtr is
	cleared when it is being destroyed.

	* generic/tkImgPhoto.c: Changed so color tables are freed
	immediately instead of being delayed.  This ensures that color
	tables are properly disposed at process exit.

	* library/prolog.ps: Changed string that determines font height to
	include European character with an umlaut.

	* generic/tkImgBmap.c (ImgBmapConfigureInstance): If an image
	mask changed but ended up with the same XID, the GC failed to be
	updated and so the new mask was not used. [Bug: 970]

	* generic/tkFocus.c (SetFocus): Changed so focus window is always
	set if -force is specified.  This fixes the problem on Windows
	where Tk does not activate the window if it already has focus.

	* generic/tkConsole.c: Fixed so errors in console eval are
	reported properly.  Eliminated duplicate result messages. [Bug: 973]

	* win/tkWinWm.c: Changed so windows that aren't resizable don't
	have resize handles and the zoom box is disabled.

	* win/tkWinInt.h:
	* win/tkWinPointer.c: Changed to cancel the mouse timer when a
	user initiated move/resize loop begins.

	* unix/configure.in: TK_LD_SEARCH_FLAGS was set incorrectly if
	SHLIB_LD_LIBS='${LIBS}', and shared linking is performed through
	the C compiler. Systems affected are Linux, MP-RAS and NEXTSTEP,
	but also with gcc on many more systems. [Bug: 908]

	* win/makefile.vc: First stab at install target.  Fixed quoting so
	paths with spaces work.

	* tests/main.test:
	* tests/unixWm.test: Better cleanup of temporary files.

	* mac/tkMacAppInit.c:
	* generic/tkTest.c:
	* generic/tkAppInit.c:
	* win/winMain.c: Changed some EXTERN declarations to extern
	since they are not defining exported interfaces.  This avoids
	generating useless declspec() attributes and makes the windows
	makefile simpler.

	* library/menu.tcl (tkMenuFind): Changed so keyboard shortcuts
	will only be found in the current toplevel.  Previously, they
	might be found in menus attached to other toplevels that might not
	even be mapped. [Bug: 924]

	* generic/tkCanvLine.c: Changed to treat zero width lines like
	they have width 1 for purposes of selection. [Bug: 925]

	* win/tkWinFont.c (Tk_MeasureChars): Added a workaround for a bug
	in GetTextExtentExPoint on Win NT 4.0/Japanese. [Bug: 1006]

	* unix/tkUnixSend.c (Tk_SetAppName): Fixed uninitialized memory
	access bug. [Bug: 919]

1999-1-28  Scott Stanton  <stanton@GASPODE>

	* generic/tkGrid.c: Fixed bug in "grid forget" that failed to cancel
	pending idle handlers, resulting in a crash in a few odd cases.

1999-01-06  Lee Bernhard  <lfb@JUSTICE>

	* generic/tk.h, generic/tkGet.c, generic/tkConfig.c,
	* generic/tkOldConfig.c, generic/tkEntry.c, generic/tkMenubutton.c,
	* generic/tkMenubutton.h, generic/tkScale.c, generic/tkScale.h,
	* generic/tkTextDisplay.c, generic/tkText.c, unix/tkUnixMenubu.c,
